searchData={"items":[{"type":"behaviour","title":"acceptor","doc":"This module provides a  gen_tcp  acceptor behaviour for use with  acceptor_pool . There are three callbacks. Before accepting a socket  acceptor_init/3 : <span class=\"w\">  </span><span class=\"p\">-</span><span class=\"na\">callback</span><span class=\"w\"> </span><span class=\"nf\">acceptor_init</span><span class=\"p\" data-group-id=\"7123537358-1\">(</span><span class=\"n\">SockName</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"n\">LSock</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"n\">Args</span><span class=\"p\" data-group-id=\"7123537358-1\">)</span><span class=\"w\"> </span><span class=\"p\">-&gt;</span><span class=\"w\">\n      </span><span class=\"p\" data-group-id=\"7123537358-2\">{</span><span class=\"ss\">ok</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"n\">State</span><span class=\"p\" data-group-id=\"7123537358-2\">}</span><span class=\"w\"> </span><span class=\"p\">|</span><span class=\"w\"> </span><span class=\"p\" data-group-id=\"7123537358-3\">{</span><span class=\"ss\">ok</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"n\">State</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"n\">TimeoutOrHib</span><span class=\"p\" data-group-id=\"7123537358-3\">}</span><span class=\"w\"> </span><span class=\"p\">|</span><span class=\"w\"> </span><span class=\"ss\">ignore</span><span class=\"w\"> </span><span class=\"p\">|</span><span class=\"w\"> </span><span class=\"p\" data-group-id=\"7123537358-4\">{</span><span class=\"ss\">error</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"n\">Reason</span><span class=\"p\" data-group-id=\"7123537358-4\">}</span><span class=\"w\"> </span><span class=\"k\">when</span><span class=\"w\">\n        </span><span class=\"n\">SockName</span><span class=\"w\"> </span><span class=\"p\">:</span><span class=\"p\">:</span><span class=\"w\"> </span><span class=\"nc\">acceptor_pool</span><span class=\"p\">:</span><span class=\"nf\">name</span><span class=\"p\" data-group-id=\"7123537358-5\">(</span><span class=\"p\" data-group-id=\"7123537358-5\">)</span><span class=\"p\">,</span><span class=\"w\">\n        </span><span class=\"n\">LSock</span><span class=\"w\"> </span><span class=\"p\">:</span><span class=\"p\">:</span><span class=\"w\"> </span><span class=\"nc\">gen_tcp</span><span class=\"p\">:</span><span class=\"nf\">socket</span><span class=\"p\" data-group-id=\"7123537358-6\">(</span><span class=\"p\" data-group-id=\"7123537358-6\">)</span><span class=\"p\">,</span><span class=\"w\">\n        </span><span class=\"n\">Args</span><span class=\"w\"> </span><span class=\"p\">:</span><span class=\"p\">:</span><span class=\"w\"> </span><span class=\"nf\">term</span><span class=\"p\" data-group-id=\"7123537358-7\">(</span><span class=\"p\" data-group-id=\"7123537358-7\">)</span><span class=\"p\">,</span><span class=\"w\">\n        </span><span class=\"n\">State</span><span class=\"w\"> </span><span class=\"p\">:</span><span class=\"p\">:</span><span class=\"w\"> </span><span class=\"nf\">term</span><span class=\"p\" data-group-id=\"7123537358-8\">(</span><span class=\"p\" data-group-id=\"7123537358-8\">)</span><span class=\"p\">,</span><span class=\"w\">\n        </span><span class=\"n\">TimeoutOrHib</span><span class=\"w\"> </span><span class=\"p\">:</span><span class=\"p\">:</span><span class=\"w\"> </span><span class=\"nf\">timeout</span><span class=\"p\" data-group-id=\"7123537358-9\">(</span><span class=\"p\" data-group-id=\"7123537358-9\">)</span><span class=\"w\"> </span><span class=\"p\">|</span><span class=\"w\"> </span><span class=\"ss\">hibernate</span><span class=\"p\">,</span><span class=\"w\">\n        </span><span class=\"n\">Reason</span><span class=\"w\"> </span><span class=\"p\">:</span><span class=\"p\">:</span><span class=\"w\"> </span><span class=\"nf\">term</span><span class=\"p\" data-group-id=\"7123537358-10\">(</span><span class=\"p\" data-group-id=\"7123537358-10\">)</span><span class=\"p\">.</span> SockName  is the  inet:sockname/1  of the listen socket, which may be  {{0,0,0,0}, Port}  if bound to all ip addresses.  LSock  is the listen socket and  Args  is the argument from the  acceptor_pool:acceptor_spec/0  in the  acceptor_pool . This callback should do any setup required before trying to accept on the socket. To be able to gracefully close open connections it is recommended for an acceptor process to  monitor(port, LSock)  and gracefully close on receiving the DOWN messages. This can be combined with the listen socket being shut down before the  acceptor_pool  in the supervisor tree (e.g. after the  acceptor_pool  in a  rest_for_one  or  one_for_all ) and the  acceptor_pool  defining the  grace  specification. To accept on the socket for  Timeout  timeout return  {ok, State, Timeout :: timeout()}  with  {ok, State}  and  {ok, State, hibernate}  being equivalent to  {ok, State, infinity}  wit the later also causing the process to hibernate before trying to accept a connection.  State  will be passed to either  acceptor_continue/3  or  acceptor_continue/2 . To ignore this process and try again with another process return  ignore , or if an error occurs  {error, term()} . Start errors always count towards the restart intensity of the  acceptor_pool , even with a  restart  of  temporary  but  ignore  does not. Once a socket is accepted  acceptor_continue/3 : <span class=\"w\">  </span><span class=\"p\">-</span><span class=\"na\">callback</span><span class=\"w\"> </span><span class=\"nf\">acceptor_continue</span><span class=\"p\" data-group-id=\"6110011227-1\">(</span><span class=\"n\">PeerName</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"n\">Sock</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"n\">State</span><span class=\"p\" data-group-id=\"6110011227-1\">)</span><span class=\"w\"> </span><span class=\"p\">-&gt;</span><span class=\"w\"> </span><span class=\"nf\">no_return</span><span class=\"p\" data-group-id=\"6110011227-2\">(</span><span class=\"p\" data-group-id=\"6110011227-2\">)</span><span class=\"w\"> </span><span class=\"k\">when</span><span class=\"w\">\n       </span><span class=\"n\">PeerName</span><span class=\"w\"> </span><span class=\"p\">:</span><span class=\"p\">:</span><span class=\"w\"> </span><span class=\"nc\">acceptor_pool</span><span class=\"p\">:</span><span class=\"nf\">name</span><span class=\"p\" data-group-id=\"6110011227-3\">(</span><span class=\"p\" data-group-id=\"6110011227-3\">)</span><span class=\"p\">,</span><span class=\"w\">\n       </span><span class=\"n\">Sock</span><span class=\"w\"> </span><span class=\"p\">:</span><span class=\"p\">:</span><span class=\"w\"> </span><span class=\"nc\">gen_tcp</span><span class=\"p\">:</span><span class=\"nf\">socket</span><span class=\"p\" data-group-id=\"6110011227-4\">(</span><span class=\"p\" data-group-id=\"6110011227-4\">)</span><span class=\"p\">,</span><span class=\"w\">\n       </span><span class=\"n\">State</span><span class=\"w\"> </span><span class=\"p\">:</span><span class=\"p\">:</span><span class=\"w\"> </span><span class=\"nf\">term</span><span class=\"p\" data-group-id=\"6110011227-5\">(</span><span class=\"p\" data-group-id=\"6110011227-5\">)</span><span class=\"p\">.</span> PeerName  the  inet:peername/1  of the accepted socket  Sock  and  State  is the state returned by  acceptor_init/3 . The callback module now has full control of the process and should enter its main loop, perhaps with  gen_statem:enter_loop/6 . It can be a long wait for a socket and so it possible for the  State  to have been created using an old version of the module. During the wait the process is hidden from the supervision tree and so hidden from the relup system. However it is possible to  load  both  acceptor  and the acceptor callback module during an appup with a soft post purge because neither module is on the call stack. If accepting a socket fails  acceptor_terminate/2 : <span class=\"w\">  </span><span class=\"p\">-</span><span class=\"na\">callback</span><span class=\"w\"> </span><span class=\"nf\">acceptor_terminate</span><span class=\"p\" data-group-id=\"4305346906-1\">(</span><span class=\"n\">Reason</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"n\">State</span><span class=\"p\" data-group-id=\"4305346906-1\">)</span><span class=\"w\"> </span><span class=\"p\">-&gt;</span><span class=\"w\"> </span><span class=\"nf\">any</span><span class=\"p\" data-group-id=\"4305346906-2\">(</span><span class=\"p\" data-group-id=\"4305346906-2\">)</span><span class=\"w\"> </span><span class=\"k\">when</span><span class=\"w\">\n       </span><span class=\"n\">Reason</span><span class=\"w\"> </span><span class=\"p\">:</span><span class=\"p\">:</span><span class=\"w\"> </span><span class=\"p\" data-group-id=\"4305346906-3\">{</span><span class=\"ss\">shutdown</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"ss\">timeout</span><span class=\"w\"> </span><span class=\"p\">|</span><span class=\"w\"> </span><span class=\"ss\">closed</span><span class=\"w\"> </span><span class=\"p\">|</span><span class=\"w\"> </span><span class=\"ss\">system_limit</span><span class=\"w\"> </span><span class=\"p\">|</span><span class=\"w\"> </span><span class=\"nc\">inet</span><span class=\"p\">:</span><span class=\"nf\">posix</span><span class=\"p\" data-group-id=\"4305346906-4\">(</span><span class=\"p\" data-group-id=\"4305346906-4\">)</span><span class=\"p\" data-group-id=\"4305346906-3\">}</span><span class=\"w\"> </span><span class=\"p\">|</span><span class=\"w\">\n                  </span><span class=\"nf\">term</span><span class=\"p\" data-group-id=\"4305346906-5\">(</span><span class=\"p\" data-group-id=\"4305346906-5\">)</span><span class=\"p\">,</span><span class=\"w\">\n        </span><span class=\"n\">State</span><span class=\"w\"> </span><span class=\"p\">:</span><span class=\"p\">:</span><span class=\"w\"> </span><span class=\"nf\">term</span><span class=\"p\" data-group-id=\"4305346906-6\">(</span><span class=\"p\" data-group-id=\"4305346906-6\">)</span><span class=\"p\">.</span> Reason  is the reason for termination, and the exit reason of the process. If a socket error caused the termination the reason is  {shutdown, timeout | closed | system_limit | inet:posix()} . Otherwise the reason is an exit signal from the  acceptor_pool . State  is the state returned by  acceptor_init/3 .","ref":"acceptor.html"},{"type":"callback","title":"acceptor.acceptor_continue/3","doc":"","ref":"acceptor.html#c:acceptor_continue/3"},{"type":"callback","title":"acceptor.acceptor_init/3","doc":"","ref":"acceptor.html#c:acceptor_init/3"},{"type":"callback","title":"acceptor.acceptor_terminate/2","doc":"","ref":"acceptor.html#c:acceptor_terminate/2"},{"type":"type","title":"acceptor.data/0","doc":"","ref":"acceptor.html#t:data/0"},{"type":"type","title":"acceptor.option/0","doc":"","ref":"acceptor.html#t:option/0"},{"type":"behaviour","title":"acceptor_pool","doc":"This module provides a  gen_tcp  acceptor pool supervisor. An  acceptor_pool  must define the  acceptor_pool  behaviour callback, which is very similar to the  supervisor  behaviour except all children must be  acceptor  proccesses and only the map terms are supported. The only callback is  init/1 : <span class=\"w\"> </span><span class=\"p\">-</span><span class=\"na\">callback</span><span class=\"w\"> </span><span class=\"nf\">init</span><span class=\"p\" data-group-id=\"0489243691-1\">(</span><span class=\"n\">Args</span><span class=\"p\" data-group-id=\"0489243691-1\">)</span><span class=\"w\"> </span><span class=\"p\">-&gt;</span><span class=\"w\"> </span><span class=\"p\" data-group-id=\"0489243691-2\">{</span><span class=\"ss\">ok</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"p\" data-group-id=\"0489243691-3\">{</span><span class=\"n\">PoolFlags</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"p\" data-group-id=\"0489243691-4\">[</span><span class=\"n\">AcceptorSpec</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"p\">.</span><span class=\"p\">.</span><span class=\"p\">.</span><span class=\"p\" data-group-id=\"0489243691-4\">]</span><span class=\"p\" data-group-id=\"0489243691-3\">}</span><span class=\"p\" data-group-id=\"0489243691-2\">}</span><span class=\"w\"> </span><span class=\"p\">|</span><span class=\"w\"> </span><span class=\"ss\">ignore</span><span class=\"w\"> </span><span class=\"k\">when</span><span class=\"w\">\n     </span><span class=\"n\">Args</span><span class=\"w\"> </span><span class=\"p\">:</span><span class=\"p\">:</span><span class=\"w\"> </span><span class=\"nf\">any</span><span class=\"p\" data-group-id=\"0489243691-5\">(</span><span class=\"p\" data-group-id=\"0489243691-5\">)</span><span class=\"p\">,</span><span class=\"w\">\n     </span><span class=\"n\">PoolFlags</span><span class=\"w\"> </span><span class=\"p\">:</span><span class=\"p\">:</span><span class=\"w\"> </span><span class=\"nf\">pool_flags</span><span class=\"p\" data-group-id=\"0489243691-6\">(</span><span class=\"p\" data-group-id=\"0489243691-6\">)</span><span class=\"p\">,</span><span class=\"w\">\n     </span><span class=\"n\">AcceptorSpec</span><span class=\"w\"> </span><span class=\"p\">:</span><span class=\"p\">:</span><span class=\"w\"> </span><span class=\"nf\">acceptor_spec</span><span class=\"p\" data-group-id=\"0489243691-7\">(</span><span class=\"p\" data-group-id=\"0489243691-7\">)</span><span class=\"p\">.</span> The  pool_flags()  are the  intensity  and  period  pairs as in as  supervisor:sup_flags/0  and have the equivalent behaviour. There must be list of a single  acceptor_spec() , just as there can only be a single  supervisor:child_spec/0  when the  strategy  is  simple_one_for_one . The map pairs are the same as  supervisor:child_spec/0  except that  start 's value is of form: <span class=\"w\">  </span><span class=\"p\" data-group-id=\"4959222103-1\">{</span><span class=\"n\">AcceptorMod</span><span class=\"w\"> </span><span class=\"p\">:</span><span class=\"p\">:</span><span class=\"w\"> </span><span class=\"nf\">module</span><span class=\"p\" data-group-id=\"4959222103-2\">(</span><span class=\"p\" data-group-id=\"4959222103-2\">)</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"n\">AcceptorArg</span><span class=\"w\"> </span><span class=\"p\">:</span><span class=\"p\">:</span><span class=\"w\"> </span><span class=\"nf\">term</span><span class=\"p\" data-group-id=\"4959222103-3\">(</span><span class=\"p\" data-group-id=\"4959222103-3\">)</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"n\">Opts</span><span class=\"w\"> </span><span class=\"p\">:</span><span class=\"p\">:</span><span class=\"w\"> </span><span class=\"p\" data-group-id=\"4959222103-4\">[</span><span class=\"nc\">acceptor</span><span class=\"p\">:</span><span class=\"nf\">option</span><span class=\"p\" data-group-id=\"4959222103-5\">(</span><span class=\"p\" data-group-id=\"4959222103-5\">)</span><span class=\"p\" data-group-id=\"4959222103-4\">]</span><span class=\"p\" data-group-id=\"4959222103-1\">}</span> AcceptorMod  is an  acceptor  callback module that will be called with argument  AcceptorArg , and spawned with acceptor options  Opts . There is an additional  grace  key, that has a  timeout()  value. This is the time in milliseconds that the acceptor pool will wait for children to exit before starting to shut them down when terminating. This allows connections to be gracefully closed. To start accepting connections using the  acceptor_pool  call  accept_socket/3 . See also:  acceptor ,  supervisor .","ref":"acceptor_pool.html"},{"type":"function","title":"acceptor_pool.accept_socket/3","doc":"Ask  acceptor_pool Pool  to accept on the listen socket  Sock  with  Acceptors  number of acceptors. Returns  {ok, Ref}  on success or  {error, Reason}  on failure. If acceptors fail to accept connections an exit signal is sent  Sock .","ref":"acceptor_pool.html#accept_socket/3"},{"type":"type","title":"acceptor_pool.acceptor_spec/0","doc":"","ref":"acceptor_pool.html#t:acceptor_spec/0"},{"type":"function","title":"acceptor_pool.count_children/1","doc":"Count the children of the  acceptor_pool . Processes that are waiting for a socket are not included in  active . See also:  supervisor:count_children/1 .","ref":"acceptor_pool.html#count_children/1"},{"type":"callback","title":"acceptor_pool.init/1","doc":"","ref":"acceptor_pool.html#c:init/1"},{"type":"type","title":"acceptor_pool.name/0","doc":"","ref":"acceptor_pool.html#t:name/0"},{"type":"type","title":"acceptor_pool.pool/0","doc":"","ref":"acceptor_pool.html#t:pool/0"},{"type":"type","title":"acceptor_pool.pool_flags/0","doc":"","ref":"acceptor_pool.html#t:pool_flags/0"},{"type":"function","title":"acceptor_pool.start_link/2","doc":"Start an  acceptor_pool  with callback module  Module  and argument  Args . See also:  start_link/3 .","ref":"acceptor_pool.html#start_link/2"},{"type":"function","title":"acceptor_pool.start_link/3","doc":"Start an  acceptor_pool  with name  Name , callback module  Module  and argument  Args . This function is equivalent to  supervisor:start_link/3  except starts an  acceptor_pool  instead of a  supervisor . See also:  supervisor:start_link/3 .","ref":"acceptor_pool.html#start_link/3"},{"type":"function","title":"acceptor_pool.which_children/1","doc":"List the children of the  acceptor_pool . This function is equivalent to  supervisor:which_children/1  except that the peer name, listen socket name and a unique reference are combined with the  id  from  init/1 . Processes that are waiting for a socket are not included. See also:  supervisor:which_children/1 .","ref":"acceptor_pool.html#which_children/1"},{"type":"function","title":"acceptor_pool.which_sockets/1","doc":"List the listen sockets being used by the  acceptor_pool .","ref":"acceptor_pool.html#which_sockets/1"},{"type":"module","title":"partisan_interval_sets","doc":"An implementation of a set of bounded open intervals.","ref":"partisan_interval_sets.html"},{"type":"function","title":"partisan_interval_sets.add_element/2","doc":"Return OrdSet with Element inserted in it. -----------------------------------------------------------------------------","ref":"partisan_interval_sets.html#add_element/2"},{"type":"function","title":"partisan_interval_sets.del_element/2","doc":"Return OrdSet but with Element removed. -----------------------------------------------------------------------------","ref":"partisan_interval_sets.html#del_element/2"},{"type":"type","title":"partisan_interval_sets.element/0","doc":"","ref":"partisan_interval_sets.html#t:element/0"},{"type":"function","title":"partisan_interval_sets.filter/2","doc":"Filter OrdSet with Fun. -----------------------------------------------------------------------------","ref":"partisan_interval_sets.html#filter/2"},{"type":"function","title":"partisan_interval_sets.flat_size/1","doc":"Return the number of points in the Ordset. -----------------------------------------------------------------------------","ref":"partisan_interval_sets.html#flat_size/1"},{"type":"function","title":"partisan_interval_sets.fold/3","doc":"Fold function Fun over all elements in OrdSet and return Accumulator. -----------------------------------------------------------------------------","ref":"partisan_interval_sets.html#fold/3"},{"type":"function","title":"partisan_interval_sets.from_list/1","doc":"Build an ordered set from the elements in List. -----------------------------------------------------------------------------","ref":"partisan_interval_sets.html#from_list/1"},{"type":"function","title":"partisan_interval_sets.intersection/1","doc":"Return the intersection of the list of interval sets. -----------------------------------------------------------------------------","ref":"partisan_interval_sets.html#intersection/1"},{"type":"function","title":"partisan_interval_sets.intersection/2","doc":"Return the intersection of IntervalSet1 and IntervalSet2. -----------------------------------------------------------------------------","ref":"partisan_interval_sets.html#intersection/2"},{"type":"type","title":"partisan_interval_sets.interval/0","doc":"","ref":"partisan_interval_sets.html#t:interval/0"},{"type":"function","title":"partisan_interval_sets.is_disjoint/2","doc":"Check whether IntervalSet1 and IntervalSet2 are disjoint. -----------------------------------------------------------------------------","ref":"partisan_interval_sets.html#is_disjoint/2"},{"type":"function","title":"partisan_interval_sets.is_element/2","doc":"Return 'true' if Element is an element of Sets, else 'false'. -----------------------------------------------------------------------------","ref":"partisan_interval_sets.html#is_element/2"},{"type":"function","title":"partisan_interval_sets.is_empty/1","doc":"Return 'true' if OrdSet is an empty set, otherwise 'false'. -----------------------------------------------------------------------------","ref":"partisan_interval_sets.html#is_empty/1"},{"type":"function","title":"partisan_interval_sets.is_subset/2","doc":"Return 'true' when every element of IntervalSet1 is also a member of IntervalSet2, else 'false'. -----------------------------------------------------------------------------","ref":"partisan_interval_sets.html#is_subset/2"},{"type":"function","title":"partisan_interval_sets.is_type/1","doc":"Return 'true' if Set is an ordered set of elements, else 'false'. -----------------------------------------------------------------------------","ref":"partisan_interval_sets.html#is_type/1"},{"type":"function","title":"partisan_interval_sets.max/1","doc":"Returns the maximum integer value contained in the set. -----------------------------------------------------------------------------","ref":"partisan_interval_sets.html#max/1"},{"type":"function","title":"partisan_interval_sets.min/1","doc":"Returns the minimum integer value contained in the set. -----------------------------------------------------------------------------","ref":"partisan_interval_sets.html#min/1"},{"type":"function","title":"partisan_interval_sets.new/0","doc":"Return a new empty offset. -----------------------------------------------------------------------------","ref":"partisan_interval_sets.html#new/0"},{"type":"function","title":"partisan_interval_sets.size/1","doc":"Return the number of elements in OrdSet. -----------------------------------------------------------------------------","ref":"partisan_interval_sets.html#size/1"},{"type":"function","title":"partisan_interval_sets.subtract/2","doc":"Return all and only the elements of IntervalSet1 which are not also in IntervalSet2. -----------------------------------------------------------------------------","ref":"partisan_interval_sets.html#subtract/2"},{"type":"type","title":"partisan_interval_sets.t/0","doc":"","ref":"partisan_interval_sets.html#t:t/0"},{"type":"function","title":"partisan_interval_sets.to_flat_list/1","doc":"Return the points in OrdSet as a list. -----------------------------------------------------------------------------","ref":"partisan_interval_sets.html#to_flat_list/1"},{"type":"function","title":"partisan_interval_sets.to_list/1","doc":"Return the elements in OrdSet as a list. -----------------------------------------------------------------------------","ref":"partisan_interval_sets.html#to_list/1"},{"type":"function","title":"partisan_interval_sets.union/1","doc":"Return the union of the list of interval sets. -----------------------------------------------------------------------------","ref":"partisan_interval_sets.html#union/1"},{"type":"function","title":"partisan_interval_sets.union/2","doc":"Return the union of IntervalSet1 and IntervalSet2. -----------------------------------------------------------------------------","ref":"partisan_interval_sets.html#union/2"},{"type":"module","title":"partisan_opts","doc":"","ref":"partisan_opts.html"},{"type":"function","title":"partisan_opts.get/2","doc":"","ref":"partisan_opts.html#get/2"},{"type":"type","title":"partisan_opts.opt/0","doc":"","ref":"partisan_opts.html#t:opt/0"},{"type":"type","title":"partisan_opts.t/0","doc":"","ref":"partisan_opts.html#t:t/0"},{"type":"function","title":"partisan_opts.take/2","doc":"","ref":"partisan_opts.html#take/2"},{"type":"module","title":"partisan_retry","doc":"# Overview\n\nThis module implements a structured retry mechanism with optional exponential\nbackoff and deadline tracking, designed for reliable asynchronous retries.\nIt wraps the [Backoff](https://hex.pm/packages/backoff) library.","ref":"partisan_retry.html"},{"type":"module","title":"Key Features - partisan_retry","doc":"- Supports a fixed retry interval or exponential backoff.\n- Tracks retry attempts (`count`) and enforces a maximum retry limit.\n- Optional global deadline (in milliseconds) for all retries.\n- Integrates with `erlang:start_timer/3` to fire retries after delay.","ref":"partisan_retry.html#module-key-features"},{"type":"module","title":"Record Structure - partisan_retry","doc":"- `#partisan_retry{}` contains retry state, including:\n- `id`              : Identifier associated with the retry (e.g., message ID).\n- `deadline`        : Absolute time limit in ms (from start) before giving up.\n- `max_retries`     : Maximum allowed retry attempts.\n- `interval`        : Default interval between retries (in ms).\n- `count`           : Current number of failed attempts.\n- `backoff`         : Optional backoff state (using external `backoff` module).\n- `start_ts`        : Start timestamp (used for deadline tracking).","ref":"partisan_retry.html#module-record-structure"},{"type":"module","title":"Retry Configuration Options (init/2) - partisan_retry","doc":"Can be supplied as a proplist or map:\n- `{deadline, pos_integer()}` - Absolute time limit in milliseconds for all retries.\n- `{max_retries, pos_integer()}` - Max number of retry attempts.\n- `backoff`\n    - `{enabled, boolean()}`  - Enables exponential backoff.\n    - `{min, pos_integer()}` - Minimum backoff duration.\n    - `{max, pos_integer()}` - Maximum backoff duration.\n    - `{type, jitter | normal}`  - Type of backoff strategy.","ref":"partisan_retry.html#module-retry-configuration-options-init-2"},{"type":"module","title":"Usage Example - partisan_retry","doc":"```\n{Delay, Retry1} = partisan_retry:fail(Retry0),\nRef = partisan_retry:fire(Retry1).\n```","ref":"partisan_retry.html#module-usage-example"},{"type":"module","title":"Return Semantics - partisan_retry","doc":"Functions like `get/1` and `fail/1` return either the next delay (in ms) or\nan atom indicating termination conditions: `max_retries` or `deadline`.","ref":"partisan_retry.html#module-return-semantics"},{"type":"module","title":"Integration Notes - partisan_retry","doc":"- Caller is responsible for invoking `fail/1` or `succeed/1` after outcome.\n- The retry timer must be externally scheduled using `fire/1` and monitored.","ref":"partisan_retry.html#module-integration-notes"},{"type":"type","title":"partisan_retry.backoff_opts/0","doc":"","ref":"partisan_retry.html#t:backoff_opts/0"},{"type":"function","title":"partisan_retry.count/1","doc":"Returns the number of failed retry attempts so far.","ref":"partisan_retry.html#count/1"},{"type":"function","title":"partisan_retry.fail/1","doc":"Increments the retry counter and computes the next delay.\n\nIf `max_retries` is reached, returns `{max_retries, State}`.\nIf a deadline is exceeded, `get/1` will later return `deadline`.\n\nAutomatically initializes the start timestamp on first retry.\n\nReturns the tuple `{Delay, NewState}`, or `{max_retries | deadline, NewState}`.","ref":"partisan_retry.html#fail/1"},{"type":"function","title":"partisan_retry.fire/1","doc":"Starts a timer based on the current retry delay.\n\nIf the retry has expired (due to max retries or deadline), this function raises an error.\n\nReturns the timer reference if successful; otherwise, throws `max_retries` or `deadline` error.","ref":"partisan_retry.html#fire/1"},{"type":"function","title":"partisan_retry.get/1","doc":"Returns the delay (in milliseconds) before the next retry should occur.\n\nIf no retries remain (`max_retries`) or the deadline has passed, returns\n`max_retries` or `deadline` respectively.\n\nReturns `integer()` if retry is allowed, or `deadline | max_retries` atom.","ref":"partisan_retry.html#get/1"},{"type":"function","title":"partisan_retry.init/2","doc":"Initializes a new retry state with the given ID and options.\n\nThe retry mechanism can be based on a fixed interval or use exponential\nbackoff depending on options.\n\nSet `deadline` to 0 to disable deadline tracking and rely solely on `max_retries`.","ref":"partisan_retry.html#init/2"},{"type":"type","title":"partisan_retry.optional/1","doc":"","ref":"partisan_retry.html#t:optional/1"},{"type":"type","title":"partisan_retry.opts/0","doc":"","ref":"partisan_retry.html#t:opts/0"},{"type":"function","title":"partisan_retry.succeed/1","doc":"Resets the retry counter and (if applicable) resets the backoff state.\n\nUsed after a successful attempt to stop retrying.\n\nReturns the tuple of `{Delay, NewState}` where delay is the base interval or backoff.","ref":"partisan_retry.html#succeed/1"},{"type":"type","title":"partisan_retry.t/0","doc":"","ref":"partisan_retry.html#t:t/0"},{"type":"module","title":"partisan","doc":"This module implements the Partisan API. Some of the functions in this module are the Partisan counterparts of a subset of the functions found in the  erlang  and  net_kernel  modules. -----------------------------------------------------------------------------","ref":"partisan.html"},{"type":"type","title":"partisan.actor/0","doc":"","ref":"partisan.html#t:actor/0"},{"type":"type","title":"partisan.any_name/0","doc":"","ref":"partisan.html#t:any_name/0"},{"type":"type","title":"partisan.any_pid/0","doc":"","ref":"partisan.html#t:any_pid/0"},{"type":"type","title":"partisan.any_reference/0","doc":"","ref":"partisan.html#t:any_reference/0"},{"type":"function","title":"partisan.broadcast/2","doc":"Broadcasts a message originating from this node. The message will be delivered to each node at least once. The  Mod  passed is responsible for handling the message on remote nodes as well as providing some other information both locally and and on other nodes.  Mod  must be loaded on all members of the clusters and implement the  partisan_plumtree_broadcast_handler  behaviour.","ref":"partisan.html#broadcast/2"},{"type":"function","title":"partisan.cancel_timer/1","doc":"","ref":"partisan.html#cancel_timer/1"},{"type":"function","title":"partisan.cancel_timer/2","doc":"","ref":"partisan.html#cancel_timer/2"},{"type":"function","title":"partisan.cast_message/2","doc":"Cast message to a remote ref","ref":"partisan.html#cast_message/2"},{"type":"function","title":"partisan.cast_message/3","doc":"Cast message to registered process on the remote side.","ref":"partisan.html#cast_message/3"},{"type":"function","title":"partisan.cast_message/4","doc":"Cast message to registered process on the remote side.","ref":"partisan.html#cast_message/4"},{"type":"type","title":"partisan.channel/0","doc":"","ref":"partisan.html#t:channel/0"},{"type":"type","title":"partisan.channel_opt/0","doc":"","ref":"partisan.html#t:channel_opt/0"},{"type":"type","title":"partisan.channel_opts/0","doc":"","ref":"partisan.html#t:channel_opts/0"},{"type":"function","title":"partisan.channel_opts/1","doc":"Returns a channel with name  Name . Fails if a channel named  Name  doesn't exist.","ref":"partisan.html#channel_opts/1"},{"type":"function","title":"partisan.default_channel/0","doc":"","ref":"partisan.html#default_channel/0"},{"type":"function","title":"partisan.demonitor/1","doc":"It differs from  erlang:demonitor/1  in that it doesn't fail if  MonitorRef  refers to a monitoring started by another process.","ref":"partisan.html#demonitor/1"},{"type":"function","title":"partisan.demonitor/2","doc":"","ref":"partisan.html#demonitor/2"},{"type":"type","title":"partisan.demonitor_opt/0","doc":"","ref":"partisan.html#t:demonitor_opt/0"},{"type":"function","title":"partisan.disconnect_node/1","doc":"","ref":"partisan.html#disconnect_node/1"},{"type":"function","title":"partisan.exit/2","doc":"","ref":"partisan.html#exit/2"},{"type":"function","title":"partisan.forward_message/2","doc":"Forward message to registered process on the remote side.","ref":"partisan.html#forward_message/2"},{"type":"function","title":"partisan.forward_message/3","doc":"Forward message to registered process on the remote side.","ref":"partisan.html#forward_message/3"},{"type":"function","title":"partisan.forward_message/4","doc":"Forward message to registered process on the remote side.","ref":"partisan.html#forward_message/4"},{"type":"type","title":"partisan.forward_opts/0","doc":"","ref":"partisan.html#t:forward_opts/0"},{"type":"type","title":"partisan.info_opt/0","doc":"","ref":"partisan.html#t:info_opt/0"},{"type":"function","title":"partisan.is_alive/0","doc":"Returns true if the local node is alive (that is, if the node can be part of a distributed system), otherwise false.","ref":"partisan.html#is_alive/0"},{"type":"function","title":"partisan.is_connected/1","doc":"Returns the name of the local node.","ref":"partisan.html#is_connected/1"},{"type":"function","title":"partisan.is_connected/2","doc":"Returns the name of the local node.","ref":"partisan.html#is_connected/2"},{"type":"function","title":"partisan.is_fully_connected/1","doc":"Returns the name of the local node.","ref":"partisan.html#is_fully_connected/1"},{"type":"function","title":"partisan.is_local/1","doc":"Returns the name of the local node.","ref":"partisan.html#is_local/1"},{"type":"function","title":"partisan.is_local_name/1","doc":"","ref":"partisan.html#is_local_name/1"},{"type":"function","title":"partisan.is_local_name/2","doc":"","ref":"partisan.html#is_local_name/2"},{"type":"function","title":"partisan.is_local_pid/1","doc":"","ref":"partisan.html#is_local_pid/1"},{"type":"function","title":"partisan.is_local_pid/2","doc":"","ref":"partisan.html#is_local_pid/2"},{"type":"function","title":"partisan.is_local_reference/1","doc":"","ref":"partisan.html#is_local_reference/1"},{"type":"function","title":"partisan.is_local_reference/2","doc":"","ref":"partisan.html#is_local_reference/2"},{"type":"function","title":"partisan.is_pid/1","doc":"","ref":"partisan.html#is_pid/1"},{"type":"function","title":"partisan.is_process_alive/1","doc":"Returns the name of the local node.","ref":"partisan.html#is_process_alive/1"},{"type":"function","title":"partisan.is_reference/1","doc":"Returns the name of the local node.","ref":"partisan.html#is_reference/1"},{"type":"function","title":"partisan.is_self/1","doc":"Returns true if  Arg  is the caller's process identifier.","ref":"partisan.html#is_self/1"},{"type":"function","title":"partisan.join/1","doc":"Shortcut for  partisan_peer_service:join/1 .","ref":"partisan.html#join/1"},{"type":"function","title":"partisan.kill_connections/1","doc":"","ref":"partisan.html#kill_connections/1"},{"type":"function","title":"partisan.leave/0","doc":"Shortcut for  partisan_peer_service:leave/0 .","ref":"partisan.html#leave/0"},{"type":"type","title":"partisan.listen_addr/0","doc":"","ref":"partisan.html#t:listen_addr/0"},{"type":"function","title":"partisan.make_ref/0","doc":"Returns a new partisan_remote_ref. This is the same as calling  partisan_remote_ref:from_term(erlang:make_ref()) .","ref":"partisan.html#make_ref/0"},{"type":"type","title":"partisan.message/0","doc":"","ref":"partisan.html#t:message/0"},{"type":"function","title":"partisan.monitor/1","doc":"","ref":"partisan.html#monitor/1"},{"type":"function","title":"partisan.monitor/2","doc":"Sends a monitor request of type  Type  to the entity identified by  Item . If the monitored entity does not exist or it changes monitored state, the caller of  monitor/2  is notified by a message on the following format:  {Tag, MonitorRef, Type, Object, Info} This is the Partisan's equivalent to  erlang:monitor/2 . Failure:  notalive  if the  partisan_monitor  server is not alive.","ref":"partisan.html#monitor/2"},{"type":"function","title":"partisan.monitor/3","doc":"Sends a monitor request of type  Type  to the entity identified by  Item . If the monitored entity does not exist or it changes monitored state, the caller of  monitor/2  is notified by a message on the following format: {Tag, MonitorRef, Type, Object, Info} where it differs from the message sent by  erlang:monitor/3  only when the item being monitored is a remote process identifier  erlang:monitor/3  in which case: MonitorRef  is a  remote_reference() Object  is a  remote_pid()  or  remote_name() This is the Partisan's equivalent to  erlang:monitor/2 . It differs from the Erlang implementation only when monitoring a  process . For all other cases (monitoring a  port  or  time_offset ) this function calls  erlang:monitor/2 . As opposed to  erlang:monitor/2  this function does not support aliases. Monitoring a `process` Creates monitor between the current process and another process identified by Item, which can be a  pid()  (local or remote), an atom  RegisteredName  or a tuple  {RegisteredName, Node} ' for a registered process, located elsewhere. In the case of a local  pid()  or a remote  pid()  A process monitor by name resolves the  RegisteredName  to  pid()  or  port()  only once at the moment of monitor instantiation, later changes to the name registration will not affect the existing monitor. Failure: if the  partisan_monitor  server is not alive, a reference will be returned with an immediate 'DOWN' signal with reason  notalive .","ref":"partisan.html#monitor/3"},{"type":"function","title":"partisan.monitor_node/2","doc":"Monitor the status of the node  Node . If Flag is true, monitoring is turned on. If  Flag  is  false , monitoring is turned off. Making several calls to  monitor_node(Node, true)  for the same  Node  from is not an error; it results in as many independent monitoring instances as the number of different calling processes i.e. If a process has made two calls to  monitor_node(Node, true)  and  Node  terminates, only one  nodedown  message is delivered to the process (this differs from  erlang:monitor_node/2 ). If  Node  fails or does not exist, the message  {nodedown, Node}  is delivered to the calling process. If there is no connection to Node, a  nodedown  message is delivered. As a result when using a membership strategy that uses a partial view, you can not monitor nodes that are not members of the view. If  Node  is the caller's node, the function returns  false .","ref":"partisan.html#monitor_node/2"},{"type":"function","title":"partisan.monitor_node/3","doc":"Monitor the status of the node  Node . If Flag is true, monitoring is turned on. If  Flag  is  false , monitoring is turned off. Making several calls to  monitor_node(Node, true)  for the same  Node  from is not an error; it results in as many independent monitoring instances as the number of different calling processes i.e. If a process has made two calls to  monitor_node(Node, true)  and  Node  terminates, only one  nodedown  message is delivered to the process (this differs from  erlang:monitor_node/2 ). If  Node  fails or does not exist, the message  {nodedown, Node}  is delivered to the calling process. If there is no connection to Node, a  nodedown  message is delivered. As a result when using a membership strategy that uses a partial view, you can not monitor nodes that are not members of the view. If  Node  is the caller's node, the function returns  false .","ref":"partisan.html#monitor_node/3"},{"type":"function","title":"partisan.monitor_nodes/1","doc":"","ref":"partisan.html#monitor_nodes/1"},{"type":"function","title":"partisan.monitor_nodes/2","doc":"The calling process subscribes or unsubscribes to node status change messages. A nodeup message is delivered to all subscribing processes when a new node is connected, and a nodedown message is delivered when a node is disconnected.","ref":"partisan.html#monitor_nodes/2"},{"type":"type","title":"partisan.monitor_nodes_opt/0","doc":"","ref":"partisan.html#t:monitor_nodes_opt/0"},{"type":"type","title":"partisan.monitor_opt/0","doc":"","ref":"partisan.html#t:monitor_opt/0"},{"type":"type","title":"partisan.net_kernel_opt/0","doc":"","ref":"partisan.html#t:net_kernel_opt/0"},{"type":"function","title":"partisan.node/0","doc":"Returns the name of the local node.","ref":"partisan.html#node/0"},{"type":"function","title":"partisan.node/1","doc":"Returns the node where Arg originates. Arg can be a process identifier, a reference, a port or a partisan remote reference.","ref":"partisan.html#node/1"},{"type":"type","title":"partisan.node_info/0","doc":"","ref":"partisan.html#t:node_info/0"},{"type":"function","title":"partisan.node_info/0","doc":"","ref":"partisan.html#node_info/0"},{"type":"function","title":"partisan.node_info/1","doc":"","ref":"partisan.html#node_info/1"},{"type":"type","title":"partisan.node_spec/0","doc":"","ref":"partisan.html#t:node_spec/0"},{"type":"function","title":"partisan.node_spec/0","doc":"Returns the node specification of the local node. This is the information required when other nodes wish to join this node (See  partisan_peer_service:join/1 ). Notice that the values of the keys must be sorted for the peer service to be able to compare node specifications, and prevent duplicates in the membership view data structure. This is important in case you find yourself building this representation manually in order to implement a particular orchestration strategy. As Erlang maps are naturally sorted, the only property that you need to keep sorted is  listen_addrs  as it is implemented as a list.","ref":"partisan.html#node_spec/0"},{"type":"function","title":"partisan.node_spec/1","doc":"Return the partisan node_spec() for node named  Node . This function retrieves the  node_spec()  from the remote node using RPC and returns  {error, Reason}  if the RPC fails. Otherwise, assumes the node is running on the same host and returns a  node_spec()  with with nodename  Name  and host 'Host' and same metadata as  myself/0 . If configuration option  connect_disterl  is  true , the RPC will be implemented using the  rpc  module. Otherwise it will use  partisan_rpc . You should only use this function when distributed erlang is enabled (configuration option  connect_disterl  is  true ) or if the node is running on the same host and you are using this for testing purposes as there is no much sense in running a partisan cluster on a single host.","ref":"partisan.html#node_spec/1"},{"type":"function","title":"partisan.node_spec/2","doc":"Return the tuple  {ok, node_spec()  for node named  Node  or the tuple  {error, Reason} . This function first checks If there is a partisan connection to  Node , if so returns the cached specification that was used for creating the connection. If no connection is present (the case for a p2p topology), then it tries to use @link partisan_rpc} to retrieve the node specification from the remote node. This later alternative requires the partisan configuration  forward_opts` to have `broadcast  and  transitive  enabled. NOTICE: At the moment partisan_rpc might not work correctly w/ a p2p topology.","ref":"partisan.html#node_spec/2"},{"type":"type","title":"partisan.node_type/0","doc":"","ref":"partisan.html#t:node_type/0"},{"type":"function","title":"partisan.nodes/0","doc":"Returns a list of all nodes connected to this node via Partisan. Equivalent to  erlang:nodes/1 . Sames as calling  nodes(visible) . Notice that if  connect_disterl  is  true  (possibly the case when testing), this function will NOT return the disterl nodes. For that you still need to call  erlang:nodes/1 .","ref":"partisan.html#nodes/0"},{"type":"function","title":"partisan.nodes/1","doc":"Returns a list of nodes according to the argument specified. The returned result, when the argument is a list, is the list of nodes satisfying the disjunction(s) of the list elements. Differences with Erlang: hidden  - always returns the empty list (there is no concept of hidden nodes in Partisan). this  - returns the list containing the result of calling  node/0 known  - will return the nodes known by the  partisan_peer_service  i.e.  partisan_peer_service:members/0  but not the nodes referred to by process identifiers, port identifiers, and references located on this node. visible  - equivalent to Erlang.","ref":"partisan.html#nodes/1"},{"type":"function","title":"partisan.nodestring/0","doc":"Returns the name of the local node as a binary string.","ref":"partisan.html#nodestring/0"},{"type":"function","title":"partisan.process_info/1","doc":"","ref":"partisan.html#process_info/1"},{"type":"function","title":"partisan.process_info/2","doc":"","ref":"partisan.html#process_info/2"},{"type":"type","title":"partisan.remote_name/0","doc":"","ref":"partisan.html#t:remote_name/0"},{"type":"type","title":"partisan.remote_pid/0","doc":"","ref":"partisan.html#t:remote_pid/0"},{"type":"type","title":"partisan.remote_reference/0","doc":"","ref":"partisan.html#t:remote_reference/0"},{"type":"function","title":"partisan.self/0","doc":"Returns the partisan encoded pid for the calling process. This is equivalent to calling  partisan_remote_ref:from_term(self()) . Notice that this call is more expensive than It's erlang counterpart. So you might want to cache the result in your process state. See function  self/1  which allows you to cache the result in the process dictionary and take notice of the warning related to doing this on an Erlang Shell process.","ref":"partisan.html#self/0"},{"type":"function","title":"partisan.self/1","doc":"Returns the partisan encoded pid for the calling process. If  Opts  is the empty list, this is equivalent to calling  partisan_remote_ref:from_term(self()) . Otherwise, if the option  cache  is present in  Opts  the function lazily caches the result of calling  partisan_remote_ref:from_term/1  in the process dictionary the first time and retrieves the value in subsequent calls. NOTICE You SHOULD avoid using this function in the Erlang Shell. This is because when an Erlang Shell process crashes it will copy the contents of It's dictionary to the new shell process and thus you will end up with the wrong partisan remote reference.","ref":"partisan.html#self/1"},{"type":"function","title":"partisan.send/2","doc":"","ref":"partisan.html#send/2"},{"type":"function","title":"partisan.send/3","doc":"","ref":"partisan.html#send/3"},{"type":"function","title":"partisan.send_after/3","doc":"Equivalent to calling  send_after(Time, Dest, Msg, []) .","ref":"partisan.html#send_after/3"},{"type":"function","title":"partisan.send_after/4","doc":"Equivalent to the native  erlang:send_after/4 . It calls the native implementation for local destinations. For remote destinations it spawns a process that uses a timer and accepts cancellation ( via  cancel_timer/1,2 ), so this is less efficient than the native implementation.","ref":"partisan.html#send_after/4"},{"type":"type","title":"partisan.send_after_dst/0","doc":"","ref":"partisan.html#t:send_after_dst/0"},{"type":"type","title":"partisan.send_after_opts/0","doc":"","ref":"partisan.html#t:send_after_opts/0"},{"type":"type","title":"partisan.send_dst/0","doc":"","ref":"partisan.html#t:send_dst/0"},{"type":"type","title":"partisan.server_ref/0","doc":"","ref":"partisan.html#t:server_ref/0"},{"type":"function","title":"partisan.spawn/2","doc":"","ref":"partisan.html#spawn/2"},{"type":"function","title":"partisan.spawn/4","doc":"","ref":"partisan.html#spawn/4"},{"type":"function","title":"partisan.spawn_monitor/2","doc":"","ref":"partisan.html#spawn_monitor/2"},{"type":"function","title":"partisan.spawn_monitor/4","doc":"","ref":"partisan.html#spawn_monitor/4"},{"type":"function","title":"partisan.start/0","doc":"Start the application.","ref":"partisan.html#start/0"},{"type":"function","title":"partisan.stop/0","doc":"Stop the application.","ref":"partisan.html#stop/0"},{"type":"type","title":"partisan.time/0","doc":"","ref":"partisan.html#t:time/0"},{"type":"function","title":"partisan.whereis/1","doc":"Fails with  badarg  if  Arg  is a remote reference for another node.","ref":"partisan.html#whereis/1"},{"type":"module","title":"partisan_config","doc":"This module handles the validation, access and modification of Partisan\nconfiguration options.\n\nSome options will only take effect after a restart of the Partisan application, while other will take effect while the application is still running.\n\nAs per Erlang convention the options are given using the `sys.config` file under\nthe `partisan' application section.","ref":"partisan_config.html"},{"type":"module","title":"Example - partisan_config","doc":"```\n[\n {partisan, [\n     {listen_addrs, [\n         #{ip => {127, 0, 0, 1}, port => 12345}\n     ]},\n     {channels, #{\n         data => #{parallelism => 4}\n     }},\n     {remote_ref_format, improper_list},\n     {tls, true},\n     {tls_server_options, [\n         {certfile, \"config/_ssl/server/keycert.pem\"},\n         {cacertfile, \"config/_ssl/server/cacerts.pem\"},\n         {keyfile, \"config/_ssl/server/key.pem\"},\n         {verify, verify_none}\n     ]},\n     {tls_client_options, [\n         {certfile, \"config/_ssl/client/keycert.pem\"},\n         {cacertfile, \"config/_ssl/client/cacerts.pem\"},\n         {keyfile, \"config/_ssl/client/key.pem\"},\n         {verify, verify_none}\n     ]}\n ]}\n].\n```","ref":"partisan_config.html#module-example"},{"type":"module","title":"Options - partisan_config","doc":"The following is the list of all the options you can read using `get/1` and\n`get/2`, and modify using the `sys.config` file and `set/2`.\nNotice that most values will only take effect once you restart the Partisan\napplication or the `m:partisan_peer_service_manager`. See\n[Deprecated Options](#deprecated-options) below.\n\n#### binary_padding\nA boolean value indicating whether to pad encoded messages whose external binary\nrepresentation consumes less than 65 bytes.\n\n#### broadcast\nTBD\n\n#### broadcast_mods\nTBD\n\n#### broadcast_mods\nTBD\n\n#### channels\n\nDefines the channels to be used by Partisan. The option takes either a channels map where keys are channel names ({@link partisan:channel()}) and values are channel options ({@link partisan:channel_opts()}), or a list of values where each value can be any of the following types:\n\n*   a channel name ({@link partisan:channel()}) e.g. the atom `foo'\n*   a channel with options: `{channel(), channel_opts()}'\n*   a monotonic channel using the tuple `{monotonic, Name :: channel()}' e.g. `{monotonic, bar}'. This is a legacy representation, the same can be achieved with `{bar, #{monotonic => true}}'\n\nThe list can habe a mix of types and during startup they are all coerced to channels map. Coercion works by defaulting the channel's `parallelism' to the value of the global option `parallelism' (which itself defaults to `1'), and the channel's `monotonic' to `false'. Finally the list is transformed to a map where keys are channel names and values are channel map representation. ==== Example ==== Given the following option value: ``` [ foo, {monotonic, bar}, {bar, #{parallelism => 4}} ] ''' The coerced representation will be the following map (which is a valid input and the final representation of this option after Partisan starts). ``` #{ foo => #{monotonic => false, parallelism => 1}, bar => #{monotonic => true, parallelism => 1}, baz => #{monotonic => false, parallelism => 4}, } '''\n\n#### connect_disterl\n\nA configuration that is intended solely for testing of the {@link partisan_full_membership_strategy} (See `membership_strategy'). It defines whether to use Distributed Erlang (disterl) in addition to Partisan channels. Defaults to `false'. Notice that this setting does not prevent you having both disterl and Partisan enabled for your release. However, you need to have special care to avoid mixing the two, for example by calling a {@link partisan_gen_server} that uses Partisan for distribution with {@link gen_server} that uses disterl.\n\n#### connection_interval\n\nInterval of time between peer connection attempts\n\n#### connection_jitter\n\nTBD\n\n#### connection_ping\n\nA map containing the following keys:\n- `{enabled, boolean()}` - Whether pings are enabled. Default: `true`\n- `{idle_timeout, non_neg_integer()}` - time in milliseconds\n- `{timeout, pos_integer()}` - time in milliseconds\n- `{max_attempts, pos_integer()}` - Max number of retry attempts.\n\n#### disable_fast_forward\n\nTBD\n\n#### disable_fast_receive\n\nTBD\n\n#### distance_enabled\n\nTBD\n\n#### egress_delay\n\nTBD\n\n#### exchange_selection\n\nTBD\n\n#### exchange_tick_period\n\nTBD\n\n#### gossip\n\nIf `true' gossip is used to disseminate membership to peers. Default is `true'. At the moment used only by {@link partisan_full_membership_strategy}.\n\n#### hyparview\n\nThe configuration for the {@link partisan_hyparview_peer_service_manager}. A list with the following properties:\n\n*   `active_max_size' - Defaults to `6'.\n*   `active_min_size' - Defaults to `3'.\n*   `active_rwl' - Active View Random Walk Length. Defaults to `6'.\n*   `passive_max_size' - Defaults to `30'.\n*   `passive_rwl' - Passive View Random Walk Length. Defaults to `6'.\n*   `random_promotion' - A boolean indicating if random promotion is enabled. Defaults `true'.\n*   `random_promotion_interval' - Time after which the protocol attempts to promote a node in the passive view to the active view. Defaults to `5000'.\n*   `shuffle_interval' - Defaults to `10000'.\n*   `shuffle_k_active' - Number of peers to include in the shuffle exchange. Defaults to `3'.\n*   `shuffle_k_passive' - Number of peers to include in the shuffle exchange. Defaults to `4'.\n\n#### ingress_delay\n\nTBD\n\n#### lazy_tick_period\n\nTBD\n\n#### listen_addrs\n\nA list of {@link partisan:listen_addr()} objects. This overrides [`listen_ip`](#listen_ip) and [`listen_port`](#listen_port) (see below) and its the way to configure the peer listener should you want to listen on multiple IP addresses. If this option is missing, the `peer_ip' property will be used, unless is also missing, in which case the nodename's host part will be used to determine the IP address. The {@link partisan:listen_addr()} object can be represented using lists, binaries, tuples or maps as shown in the following example: ``` {listen_addrs, [ \"127.0.0.1:12345\", <<\"127.0.0.1:12345\">>, {\"127.0.0.1\", \"12345\"}, {{127, 0, 0, 1}, 12345}, #{ip => \"127.0.0.1\", port => \"12345\"}, #{ip => <<\"127.0.0.1\">>, port => <<\"12345\">>}, #{ip => {127, 0, 0, 1}, port => 12345} ]} ''' Notice the above example will result in the following, as equivalent terms are deduplicated. ``` {listen_addrs, [ #{ip => {127, 0, 0, 1}, port => 12345} ]} ''' This option also accepts IP addresses without a port e.g. \"127.0.0.1\". In this case the port will be the value [`listen_port`](#listen_port) option. Notice [`listen_port`](#listen_port) is also used by some peer discovery strategies that cannot detect in which port the peer is listening e.g. DNS. See also [`listen_ip`](#listen_ip) for an alternative when using a single IP address.\n\n#### listen_ip\n\nThe IP address to use for the peer connection listener when no {@link partisan:listen_addr()} have been defined via option [`listen_addrs`](#listen_addrs). If a value is not defined (and [`listen_addrs`](#listen_addrs) was not used), Partisan will attempt to resolve the IP address using the nodename's host i.e. the part to the right of the `@' character in the nodename, and will default to `{127,0,0,1}' if it can't.\n\n#### listen_port\n\nThe port number to use for the peer connection listener when no {@link partisan:listen_addr()} have been defined via option [`listen_addrs`](#listen_addrs). If a value is not defined (and [`listen_addrs`](#listen_addrs) was not used), Partisan will use a randomly generated port. However, the random port will only work for clusters deployed within the same host i.e. used for testing. Moreover, the `listen_port' value is also used by some peer discovery strategies that cannot detect in which port the peer is listening e.g. DNS. So for production environments we recommend always setting the same value on all peers, and having at least one {@link partisan:listen_addr()} in each peer [`listen_addrs`](#listen_addrs) option (when used) having the same port value.\n\n#### membership_binary_compression\n\nA boolean value or an integer in the range from `0..9' to be used with {@link erlang:term_to_binary/2} when encoding the membership set for broadcast. A value of `true' is equivalent to integer `6' (equivalent to option `compressed' in {@link erlang:term_to_binary/2}). A value of `false' is equivalent to `0' (no compression). Default is`true'.\n\n#### membership_strategy\n\nThe membership strategy to be used with {@link partisan_pluggable_peer_service_manager}. Default is {@link partisan_full_membership_strategy}\n\n#### membership_strategy_tracing\n\nTBD\n\n#### metadata\n\nA custom mapping of keys to values.\n\n#### name\n\nThe nodename to be used when one was not provided via the Erlang `vm.args' configuration file or via the shell flag `--name'. The value should be a longname e.g. `{{Name}}@{{HostOrIPAddress}}'. When neither Erlang's nodename nor this value are defined, Partisan will generate a random nodename. This is primarily used for testing and you should always set the nodename when deploying to production, either via Erlang or using this option.\n\n#### orchestration_strategy\n\nTBD\n\n#### parallelism\n\nThe default number of connections to use per channel, when a channel hasn't been given a specific `parallelism' value via the `channels' option. The default is `1'. For more information see option `channels'.\n\n#### peer_service_manager\n\nThe peer service manager to be used. An implementation of the {@link partisan_peer_service_manager} behaviour which defines the overlay network topology and the membership view maintenance strategy. Default is {@link partisan_pluggable_peer_service_manager}.\n\n#### periodic_enabled\n\nTBD\n\n#### periodic_interval\n\nTBD\n\n#### pid_encoding\n\nTBD\n\n#### random_seed\n\nTBD\n\n#### ref_encoding\n\nTBD\n\n#### register_pid_for_encoding\n\nTBD\n\n#### remote_ref_format\n\nDefines how partisan remote references pids, references and registered names will be encoded. See {@link partisan_remote_ref}). Accepts the following atom values:\n\n*   `uri' - remote references will be encoded as binary URIs.\n*   `tuple' - remote references will be encoded as tuples (the format used by Partisan v1 to v4).\n*   `improper_list' - remote references will be encoded as improper lists, similar to how aliases are encoded by the OTP modules.\n\nThis option exists to allow the user to tradeoff between memory and latency. In terms of memory `uri' is the cheapest, followed by `improper_list'. In terms of latency `tuple' is the fastest followed by `improper_list'. The default is `improper_list' a if offers a good balance between memory and latency. ``` 1> partisan_config:set(remote_ref_format, uri). ok 2> partisan:self(). <<\"partisan:pid:nonode@nohost:0.1062.0\">> 3> partisan_config:set(remote_ref_format, tuple). 4> partisan:self(). {partisan_remote_reference, nonode@nohost, {partisan_process_reference,\"<0.1062.0>\"}} 5> partisan_config:set(remote_ref_format, improper_list). 6> partisan:self(). [nonode@nohost|<<\"Pid#<0.1062.0>\">>] '''\n\n#### remote_ref_uri_padding\n\nIf `true' and the URI encoding of a remote reference results in a binary smaller than 65 bytes, the URI will be padded. The default is `false'. ``` 1> partisan_config:set(remote_ref_binary_padding, false). 1> partisan:self(). <<\"partisan:pid:nonode@nohost:0.1062.0\">> 2> partisan_config:set(remote_ref_binary_padding, true). ok 3> partisan:self(). <<\"partisan:pid:nonode@nohost:0.1062.0:\"...>> '''\n\n#### replaying\n\nTBD\n\n#### reservations\n\nTBD\n\n#### retransmit_interval\n\nWhen option `retransmission' is set to `true' in the `partisan:forward_opts()' used in a call to {@link partisan:forward_message/3} and message delivery fails, the Peer Service will enqueue the message for retransmission. This option is used to control the interval of time between retransmission attempts.\n\n#### shrinking\n\nTBD\n\n#### tag\n\nThe role of this node when using the Client-Server topology implemented by @{link partisan_client_server_peer_manager}. ==== Options ====\n\n*   `undefined' - The node acts as a normal peer in all other topologies. This the default value\n*   `client' - The node acts as a client. To be used only in combination with `{partisan_peer_manager, partisan_client_server_peer_manager}'\n*   `server' - The node acts as a server. To be used only in combination with `{partisan_peer_manager, partisan_client_server_peer_manager}'\n\n#### tls\n\nA boolean value indicating whether channel connections should use TLS. If enabled, you have to provide a value for `tls_client_options' and `tls_server_options'. The default is `false'.\n\n#### tls_client_options\n\nThe TLS socket options used when establishing outgoing connections to peers. The configuration applies to all Partisan channels. The default is `[]'. ==== Example ==== ``` {tls_client_options, [ {certfile, \"config/_ssl/client/keycert.pem\"}, {cacertfile, \"config/_ssl/client/cacerts.pem\"}, {keyfile, \"config/_ssl/client/key.pem\"}, {verify, verify_none} ]} '''\n\n#### tls_server_options\n\nThe TLS socket options used when establishing incoming connections from peers. The configuration applies to all Partisan channels. The default is `[]'. ==== Example ==== ``` {tls_server_options, [ {certfile, \"config/_ssl/server/keycert.pem\"}, {cacertfile, \"config/_ssl/server/cacerts.pem\"}, {keyfile, \"config/_ssl/server/key.pem\"}, {verify, verify_none} ]} '''\n\n#### tracing\n\na boolean value. The default is `false'.\n\n#### xbot_interval\n\nTBD == Deprecated Options == The following is the list of options have been deprecated. Some of them have been renamed and/or moved down a level in the configuration tree.\n\n#### arwl\n\nHyParView's Active View Random Walk Length. Defaults to `6'. Use `active_rwl' in the `hyparview' option instead.\n\n#### fanout\n\nThe number of nodes that are contacted at each gossip interval.\n\n#### max_active_size\n\nHyParView's Active View Random Walk Length. Defaults to `6'. Use `active_max_size' in the `hyparview' option instead.\n\n#### max_passive_size\n\nHyParView's Active View Random Walk Length. Defaults to `30'. Use `passive_max_size' in the `hyparview' option instead.\n\n#### mix_active_size\n\nHyParView's Active View Random Walk Length. Defaults to `3'. Use `active_min_size' in the `hyparview' option instead.\n\n#### passive_view_shuffle_period\n\nUse `shuffle_interval' in the `hyparview' option instead.\n\n#### peer_ip\n\nUse [`listen_ip`](#listen_ip) instead.\n\n#### peer_port\n\nUse [`listen_port`](#listen_port) instead.\n\n#### peer_host\n\nUse [`listen_addrs`](#listen_addrs) instead.\n\n#### partisan_peer_service_manager\n\nUse `peer_service_manager' instead.\n\n#### prwl\n\nHyParView's Passive View Random Walk Length. Defaults to `6'. Use `passive_rwl' in the `hyparview' option instead.\n\n#### random_promotion\n\nUse `random_promotion' in the `hyparview' option instead.\n\n#### random_promotion_period\n\nUse `random_promotion_interval' in the `hyparview' option instead.\n\n#### remote_ref_as_uri\n\nUse `{remote_ref_format, uri}' instead","ref":"partisan_config.html#module-options"},{"type":"function","title":"partisan_config.channel_opts/1","doc":"","ref":"partisan_config.html#channel_opts/1"},{"type":"function","title":"partisan_config.channels/0","doc":"","ref":"partisan_config.html#channels/0"},{"type":"function","title":"partisan_config.default_channel/0","doc":"","ref":"partisan_config.html#default_channel/0"},{"type":"function","title":"partisan_config.default_channel_opts/0","doc":"","ref":"partisan_config.html#default_channel_opts/0"},{"type":"function","title":"partisan_config.get/1","doc":"","ref":"partisan_config.html#get/1"},{"type":"function","title":"partisan_config.get/2","doc":"","ref":"partisan_config.html#get/2"},{"type":"function","title":"partisan_config.get_with_opts/2","doc":"Returns the value for `Key' in `Opts', if found. Otherwise, calls `get/1`.","ref":"partisan_config.html#get_with_opts/2"},{"type":"function","title":"partisan_config.get_with_opts/3","doc":"","ref":"partisan_config.html#get_with_opts/3"},{"type":"function","title":"partisan_config.init/0","doc":"","ref":"partisan_config.html#init/0"},{"type":"function","title":"partisan_config.listen_addrs/0","doc":"","ref":"partisan_config.html#listen_addrs/0"},{"type":"function","title":"partisan_config.parallelism/0","doc":"","ref":"partisan_config.html#parallelism/0"},{"type":"function","title":"partisan_config.seed/0","doc":"","ref":"partisan_config.html#seed/0"},{"type":"function","title":"partisan_config.seed/1","doc":"","ref":"partisan_config.html#seed/1"},{"type":"function","title":"partisan_config.set/2","doc":"","ref":"partisan_config.html#set/2"},{"type":"function","title":"partisan_config.trace/2","doc":"","ref":"partisan_config.html#trace/2"},{"type":"module","title":"partisan_peer_service","doc":"This modules implements the Peer Service API. All functions in this module forward the invocation to the configured peer service manager (option  peer_service_manager ) which must be one of the Partisan's managers implementing  partisan_peer_service_manager , i.e. one of: partisan_pluggable_peer_service_manager partisan_client_server_peer_service_manager partisan_hyparview_peer_service_manager partisan_static_peer_service_manager Each node running Partisan listens for connections on a particular IP address and port. This is the information that is required when other nodes wish to join this node.","ref":"partisan_peer_service.html"},{"type":"function","title":"partisan_peer_service.add_sup_callback/1","doc":"Adds a supervised callback to receive peer service membership updates.","ref":"partisan_peer_service.html#add_sup_callback/1"},{"type":"function","title":"partisan_peer_service.broadcast_members/0","doc":"Returns the broadcast servers view of full cluster membership. Wait indefinitely for a response is returned from the process.","ref":"partisan_peer_service.html#broadcast_members/0"},{"type":"function","title":"partisan_peer_service.broadcast_members/1","doc":"Returns the broadcast servers view of full cluster membership. Waits  Timeout  ms for a response from the server.","ref":"partisan_peer_service.html#broadcast_members/1"},{"type":"function","title":"partisan_peer_service.cancel_exchanges/1","doc":"cancel exchanges started by this node.","ref":"partisan_peer_service.html#cancel_exchanges/1"},{"type":"function","title":"partisan_peer_service.connections/0","doc":"Return peer service connections","ref":"partisan_peer_service.html#connections/0"},{"type":"function","title":"partisan_peer_service.decode/1","doc":"Decode peer_service_manager state from an encoded form","ref":"partisan_peer_service.html#decode/1"},{"type":"function","title":"partisan_peer_service.exchanges/0","doc":"return a list of exchanges, started by broadcast on thisnode, that are running.","ref":"partisan_peer_service.html#exchanges/0"},{"type":"function","title":"partisan_peer_service.exchanges/1","doc":"returns a list of exchanges, started by broadcast on  Node , that are running.","ref":"partisan_peer_service.html#exchanges/1"},{"type":"function","title":"partisan_peer_service.get_local_state/0","doc":"","ref":"partisan_peer_service.html#get_local_state/0"},{"type":"function","title":"partisan_peer_service.inject_partition/2","doc":"Inject a partition.","ref":"partisan_peer_service.html#inject_partition/2"},{"type":"function","title":"partisan_peer_service.join/1","doc":"","ref":"partisan_peer_service.html#join/1"},{"type":"function","title":"partisan_peer_service.leave/0","doc":"Leave the cluster.","ref":"partisan_peer_service.html#leave/0"},{"type":"function","title":"partisan_peer_service.leave/1","doc":"Remove a node from the cluster.","ref":"partisan_peer_service.html#leave/1"},{"type":"function","title":"partisan_peer_service.manager/0","doc":"Return current peer service manager for this","ref":"partisan_peer_service.html#manager/0"},{"type":"function","title":"partisan_peer_service.member/1","doc":"Return a sampling of nodes connected to this node. When using a full-mesh topology i.e.  partisan_pluggable_peer_service_manager  or  partisan_static_peer_service_manager  this is the set of all cluster members. However, if you're using other managers, the result will only be a sampling of the nodes.","ref":"partisan_peer_service.html#member/1"},{"type":"function","title":"partisan_peer_service.members/0","doc":"Return cluster members","ref":"partisan_peer_service.html#members/0"},{"type":"function","title":"partisan_peer_service.members_for_orchestration/0","doc":"Return cluster members","ref":"partisan_peer_service.html#members_for_orchestration/0"},{"type":"function","title":"partisan_peer_service.on_down/2","doc":"Trigger function on connection close for a given node.  Function  is a function object taking zero or a single argument, where the argument is the Node name. At the moment, this only works when using a full-mesh topology i.e.  partisan_pluggable_peer_service_manager  or  partisan_static_peer_service_manager .","ref":"partisan_peer_service.html#on_down/2"},{"type":"function","title":"partisan_peer_service.on_down/3","doc":"Trigger function on connection close for a given node.  Function  is a function object taking zero or a single argument, where the argument is the Node name. At the moment, this only works when using a full-mesh topology i.e.  partisan_pluggable_peer_service_manager  or  partisan_static_peer_service_manager .","ref":"partisan_peer_service.html#on_down/3"},{"type":"function","title":"partisan_peer_service.on_up/2","doc":"Trigger function on connection open for a given node.  Function  is a function object taking zero or a single argument, where the argument is the Node name. At the moment, this only works when using a full-mesh topology i.e.  partisan_pluggable_peer_service_manager  or  partisan_static_peer_service_manager .","ref":"partisan_peer_service.html#on_up/2"},{"type":"function","title":"partisan_peer_service.on_up/3","doc":"Trigger function on connection open for a given node.  Function  is a function object taking zero or a single argument, where the argument is the Node name. At the moment, this only works when using a full-mesh topology i.e.  partisan_pluggable_peer_service_manager  or  partisan_static_peer_service_manager .","ref":"partisan_peer_service.html#on_up/3"},{"type":"function","title":"partisan_peer_service.partitions/0","doc":"","ref":"partisan_peer_service.html#partitions/0"},{"type":"function","title":"partisan_peer_service.reserve/1","doc":"Reserve a slot for the particular tag.","ref":"partisan_peer_service.html#reserve/1"},{"type":"function","title":"partisan_peer_service.resolve_partition/1","doc":"Resolve a partition.","ref":"partisan_peer_service.html#resolve_partition/1"},{"type":"function","title":"partisan_peer_service.stop/0","doc":"Stop","ref":"partisan_peer_service.html#stop/0"},{"type":"function","title":"partisan_peer_service.stop/1","doc":"Stop","ref":"partisan_peer_service.html#stop/1"},{"type":"function","title":"partisan_peer_service.sync_join/1","doc":"","ref":"partisan_peer_service.html#sync_join/1"},{"type":"type","title":"partisan_peer_service.ttl/0","doc":"","ref":"partisan_peer_service.html#t:ttl/0"},{"type":"function","title":"partisan_peer_service.update_members/1","doc":"Update cluster members with a list of node specifications.","ref":"partisan_peer_service.html#update_members/1"},{"type":"module","title":"partisan_erpc","doc":"This module is an adaptation of Erlang  erpc  module. It replaces all instances of  erlang:send/2` and `erlang:monitor/2` with their Partisan counterparts. It maintains the `erpc  API with the following exceptions:  TODO - Channels NOTICE:  At the moment this only works for  partisan_pluggable_peer_service_manager .","ref":"partisan_erpc.html"},{"type":"function","title":"partisan_erpc.call/2","doc":"","ref":"partisan_erpc.html#call/2"},{"type":"function","title":"partisan_erpc.call/3","doc":"","ref":"partisan_erpc.html#call/3"},{"type":"function","title":"partisan_erpc.call/4","doc":"","ref":"partisan_erpc.html#call/4"},{"type":"function","title":"partisan_erpc.call/5","doc":"","ref":"partisan_erpc.html#call/5"},{"type":"function","title":"partisan_erpc.call_result/4","doc":"","ref":"partisan_erpc.html#call_result/4"},{"type":"function","title":"partisan_erpc.cast/2","doc":"","ref":"partisan_erpc.html#cast/2"},{"type":"function","title":"partisan_erpc.cast/4","doc":"","ref":"partisan_erpc.html#cast/4"},{"type":"type","title":"partisan_erpc.caught_call_exception/0","doc":"","ref":"partisan_erpc.html#t:caught_call_exception/0"},{"type":"function","title":"partisan_erpc.check_response/2","doc":"","ref":"partisan_erpc.html#check_response/2"},{"type":"function","title":"partisan_erpc.execute_call/3","doc":"","ref":"partisan_erpc.html#execute_call/3"},{"type":"function","title":"partisan_erpc.execute_call/4","doc":"","ref":"partisan_erpc.html#execute_call/4"},{"type":"function","title":"partisan_erpc.execute_cast/3","doc":"","ref":"partisan_erpc.html#execute_cast/3"},{"type":"function","title":"partisan_erpc.is_arg_error/4","doc":"","ref":"partisan_erpc.html#is_arg_error/4"},{"type":"function","title":"partisan_erpc.multicall/2","doc":"","ref":"partisan_erpc.html#multicall/2"},{"type":"function","title":"partisan_erpc.multicall/3","doc":"","ref":"partisan_erpc.html#multicall/3"},{"type":"function","title":"partisan_erpc.multicall/4","doc":"","ref":"partisan_erpc.html#multicall/4"},{"type":"function","title":"partisan_erpc.multicall/5","doc":"","ref":"partisan_erpc.html#multicall/5"},{"type":"function","title":"partisan_erpc.multicast/2","doc":"","ref":"partisan_erpc.html#multicast/2"},{"type":"function","title":"partisan_erpc.multicast/4","doc":"","ref":"partisan_erpc.html#multicast/4"},{"type":"function","title":"partisan_erpc.receive_response/1","doc":"","ref":"partisan_erpc.html#receive_response/1"},{"type":"function","title":"partisan_erpc.receive_response/2","doc":"","ref":"partisan_erpc.html#receive_response/2"},{"type":"opaque","title":"partisan_erpc.request_id/0","doc":"","ref":"partisan_erpc.html#t:request_id/0"},{"type":"function","title":"partisan_erpc.send_request/2","doc":"","ref":"partisan_erpc.html#send_request/2"},{"type":"function","title":"partisan_erpc.send_request/4","doc":"","ref":"partisan_erpc.html#send_request/4"},{"type":"type","title":"partisan_erpc.stack_item/0","doc":"","ref":"partisan_erpc.html#t:stack_item/0"},{"type":"function","title":"partisan_erpc.trim_stack/4","doc":"","ref":"partisan_erpc.html#trim_stack/4"},{"type":"function","title":"partisan_erpc.wait_response/1","doc":"","ref":"partisan_erpc.html#wait_response/1"},{"type":"function","title":"partisan_erpc.wait_response/2","doc":"","ref":"partisan_erpc.html#wait_response/2"},{"type":"module","title":"partisan_monitor","doc":"This module is responsible for monitoring processes on remote nodes and implementing the monitoring API provided by the  partisan  module which follows the API provided by the Erlang modules  erlang  and  net_kernel . YOU SHOULD NEVER USE the functions in this module directly.  Use the related functions in  partisan  instead. NOTICE At the moment this only works for  partisan_pluggable_peer_service_manager  backend. Also, certain partisan_peer_service_manager implementations might not support the  partisan_peer_service_manager:on_up/2  and  partisan_peer_service_manager:on_down/2  callbacks which we need for node monitoring, so in those cases this module will not work.","ref":"partisan_monitor.html"},{"type":"function","title":"partisan_monitor.code_change/3","doc":"","ref":"partisan_monitor.html#code_change/3"},{"type":"function","title":"partisan_monitor.demonitor/2","doc":"Failure: notalive  if the partisan_monitor process is not alive. not_implemented  if the partisan peer service manager does not support the required capabilities required for monitoring. badarg  if any of the arguments is invalid.","ref":"partisan_monitor.html#demonitor/2"},{"type":"function","title":"partisan_monitor.handle_call/3","doc":"","ref":"partisan_monitor.html#handle_call/3"},{"type":"function","title":"partisan_monitor.handle_cast/2","doc":"","ref":"partisan_monitor.html#handle_cast/2"},{"type":"function","title":"partisan_monitor.handle_info/2","doc":"","ref":"partisan_monitor.html#handle_info/2"},{"type":"function","title":"partisan_monitor.init/1","doc":"","ref":"partisan_monitor.html#init/1"},{"type":"function","title":"partisan_monitor.monitor/2","doc":"When you attempt to monitor a remote process, it is not guaranteed that you will receive the DOWN message. A few reasons for not receiving the message are message loss and tree reconfiguration. The monitor options  Opts  are currently ignored. Failure: notalive If the partisan_monitor server process is not alive. not_implemented If the partisan peer service manager in use doesn't support the capabilities required for monitoring. badarg If any of the arguments are invalid.","ref":"partisan_monitor.html#monitor/2"},{"type":"function","title":"partisan_monitor.monitor_node/2","doc":"Monitor the status of the node  Node . If Flag is true, monitoring is turned on. If  Flag  is  false , monitoring is turned off. Making several calls to  monitor_node(Node, true)  for the same  Node  is not an error; it results in as many independent monitoring instances as the number of different calling processes i.e. If a process has made two calls to  monitor_node(Node, true)  and  Node  terminates, only one  nodedown  message is delivered to the process (this differs from  erlang:monitor_node/2 ). If  Node  fails or does not exist, the message  {nodedown, Node}  is delivered to the calling process. If there is no connection to Node, a  nodedown  message is delivered. As a result when using a membership strategy that uses a partial view, you cannot monitor nodes that are not members of the view. Failure: notalive  if the partisan_monitor process is not alive. not_implemented  if the partisan peer service manager does not support the required capabilities required for monitoring. badarg  if any of the arguments is invalid. This function is executed in the calling process.","ref":"partisan_monitor.html#monitor_node/2"},{"type":"function","title":"partisan_monitor.monitor_nodes/2","doc":"The calling process subscribes or unsubscribes to node status change messages. A nodeup message is delivered to all subscribing processes when a new node is connected, and a nodedown message is delivered when a node is disconnected. If Flag is true, a new subscription is started. If Flag is false, all previous subscriptions started with the same Options are stopped. Two option lists are considered the same if they contain the same set of options. Notice that the following two disterl guarantees are NOT yet provided by Partisan: nodeup  messages are delivered before delivery of any message from the remote node passed through the newly established connection. nodedown  messages are not delivered until all messages from the remote node that have been passed through the connection have been delivered. This function is executed in the calling process.","ref":"partisan_monitor.html#monitor_nodes/2"},{"type":"type","title":"partisan_monitor.node_mon/0","doc":"","ref":"partisan_monitor.html#t:node_mon/0"},{"type":"type","title":"partisan_monitor.node_type_mon/0","doc":"","ref":"partisan_monitor.html#t:node_type_mon/0"},{"type":"type","title":"partisan_monitor.node_type_mon_opts/0","doc":"","ref":"partisan_monitor.html#t:node_type_mon_opts/0"},{"type":"type","title":"partisan_monitor.proc_mon_in/0","doc":"","ref":"partisan_monitor.html#t:proc_mon_in/0"},{"type":"type","title":"partisan_monitor.proc_mon_in_idx/0","doc":"","ref":"partisan_monitor.html#t:proc_mon_in_idx/0"},{"type":"type","title":"partisan_monitor.proc_mon_out/0","doc":"","ref":"partisan_monitor.html#t:proc_mon_out/0"},{"type":"type","title":"partisan_monitor.proc_mon_out_idx/0","doc":"","ref":"partisan_monitor.html#t:proc_mon_out_idx/0"},{"type":"function","title":"partisan_monitor.start_link/0","doc":"Starts the  partisan_monitor  server. There is one  partisan_monitor  server instance per node.","ref":"partisan_monitor.html#start_link/0"},{"type":"function","title":"partisan_monitor.terminate/2","doc":"","ref":"partisan_monitor.html#terminate/2"},{"type":"module","title":"partisan_rpc","doc":"","ref":"partisan_rpc.html"},{"type":"function","title":"partisan_rpc.call/4","doc":"","ref":"partisan_rpc.html#call/4"},{"type":"function","title":"partisan_rpc.call/5","doc":"","ref":"partisan_rpc.html#call/5"},{"type":"type","title":"partisan_rpc.error_reason/0","doc":"","ref":"partisan_rpc.html#t:error_reason/0"},{"type":"function","title":"partisan_rpc.prepare_opts/1","doc":"","ref":"partisan_rpc.html#prepare_opts/1"},{"type":"module","title":"partisan_rpc_backend","doc":"","ref":"partisan_rpc_backend.html"},{"type":"function","title":"partisan_rpc_backend.code_change/3","doc":"","ref":"partisan_rpc_backend.html#code_change/3"},{"type":"function","title":"partisan_rpc_backend.handle_call/3","doc":"","ref":"partisan_rpc_backend.html#handle_call/3"},{"type":"function","title":"partisan_rpc_backend.handle_cast/2","doc":"","ref":"partisan_rpc_backend.html#handle_cast/2"},{"type":"function","title":"partisan_rpc_backend.handle_info/2","doc":"","ref":"partisan_rpc_backend.html#handle_info/2"},{"type":"function","title":"partisan_rpc_backend.init/1","doc":"","ref":"partisan_rpc_backend.html#init/1"},{"type":"function","title":"partisan_rpc_backend.start_link/0","doc":"","ref":"partisan_rpc_backend.html#start_link/0"},{"type":"function","title":"partisan_rpc_backend.terminate/2","doc":"","ref":"partisan_rpc_backend.html#terminate/2"},{"type":"module","title":"partisan_test_server","doc":"","ref":"partisan_test_server.html"},{"type":"function","title":"partisan_test_server.call/0","doc":"","ref":"partisan_test_server.html#call/0"},{"type":"function","title":"partisan_test_server.call/1","doc":"","ref":"partisan_test_server.html#call/1"},{"type":"function","title":"partisan_test_server.cast/1","doc":"","ref":"partisan_test_server.html#cast/1"},{"type":"function","title":"partisan_test_server.cast/2","doc":"","ref":"partisan_test_server.html#cast/2"},{"type":"function","title":"partisan_test_server.crash/0","doc":"","ref":"partisan_test_server.html#crash/0"},{"type":"function","title":"partisan_test_server.delayed_reply_call/0","doc":"","ref":"partisan_test_server.html#delayed_reply_call/0"},{"type":"function","title":"partisan_test_server.delayed_reply_call/1","doc":"","ref":"partisan_test_server.html#delayed_reply_call/1"},{"type":"function","title":"partisan_test_server.is_alive/1","doc":"","ref":"partisan_test_server.html#is_alive/1"},{"type":"function","title":"partisan_test_server.reply_crash/0","doc":"","ref":"partisan_test_server.html#reply_crash/0"},{"type":"function","title":"partisan_test_server.start_link/0","doc":"","ref":"partisan_test_server.html#start_link/0"},{"type":"behaviour","title":"partisan_peer_discovery_agent","doc":"This state machine is responsible for enabled cluster peers using the defined implementation backend (callback module).","ref":"partisan_peer_discovery_agent.html"},{"type":"function","title":"partisan_peer_discovery_agent.callback_mode/0","doc":"","ref":"partisan_peer_discovery_agent.html#callback_mode/0"},{"type":"function","title":"partisan_peer_discovery_agent.code_change/4","doc":"","ref":"partisan_peer_discovery_agent.html#code_change/4"},{"type":"function","title":"partisan_peer_discovery_agent.disable/0","doc":"","ref":"partisan_peer_discovery_agent.html#disable/0"},{"type":"function","title":"partisan_peer_discovery_agent.disabled/3","doc":"","ref":"partisan_peer_discovery_agent.html#disabled/3"},{"type":"function","title":"partisan_peer_discovery_agent.enable/0","doc":"","ref":"partisan_peer_discovery_agent.html#enable/0"},{"type":"function","title":"partisan_peer_discovery_agent.enabled/3","doc":"In this state the agent uses the callback module to discover peers by calling its lookup/2 callback.","ref":"partisan_peer_discovery_agent.html#enabled/3"},{"type":"callback","title":"partisan_peer_discovery_agent.init/1","doc":"","ref":"partisan_peer_discovery_agent.html#c:init/1"},{"type":"function","title":"partisan_peer_discovery_agent.init/1","doc":"","ref":"partisan_peer_discovery_agent.html#init/1"},{"type":"function","title":"partisan_peer_discovery_agent.lookup/0","doc":"","ref":"partisan_peer_discovery_agent.html#lookup/0"},{"type":"callback","title":"partisan_peer_discovery_agent.lookup/2","doc":"","ref":"partisan_peer_discovery_agent.html#c:lookup/2"},{"type":"function","title":"partisan_peer_discovery_agent.start/0","doc":"","ref":"partisan_peer_discovery_agent.html#start/0"},{"type":"function","title":"partisan_peer_discovery_agent.start_link/0","doc":"","ref":"partisan_peer_discovery_agent.html#start_link/0"},{"type":"type","title":"partisan_peer_discovery_agent.state/0","doc":"","ref":"partisan_peer_discovery_agent.html#t:state/0"},{"type":"function","title":"partisan_peer_discovery_agent.status/0","doc":"","ref":"partisan_peer_discovery_agent.html#status/0"},{"type":"function","title":"partisan_peer_discovery_agent.terminate/3","doc":"","ref":"partisan_peer_discovery_agent.html#terminate/3"},{"type":"module","title":"partisan_peer_discovery_dns","doc":"An implementation of the  partisan_peer_discovery_agent  behaviour that uses DNS for service discovery. It is enabled by using the following options in the sys.conf file <span class=\"w\">     </span><span class=\"ss\">bash</span><span class=\"w\">\n  </span><span class=\"p\" data-group-id=\"8057372712-1\">{</span><span class=\"ss\">partisan</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"p\" data-group-id=\"8057372712-2\">[</span><span class=\"w\">\n      </span><span class=\"p\" data-group-id=\"8057372712-3\">{</span><span class=\"ss\">peer_discovery</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"p\" data-group-id=\"8057372712-4\">[</span><span class=\"w\">\n           </span><span class=\"p\" data-group-id=\"8057372712-5\">{</span><span class=\"ss\">type</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"ss\">partisan_peer_discovery_dns</span><span class=\"p\" data-group-id=\"8057372712-5\">}</span><span class=\"p\">,</span><span class=\"w\">\n           </span><span class=\"p\" data-group-id=\"8057372712-6\">{</span><span class=\"ss\">config</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"p\" data-group-id=\"8057372712-7\">#{</span><span class=\"w\">\n               </span><span class=\"ss\">record_type</span><span class=\"w\"> </span><span class=\"p\">=&gt;</span><span class=\"w\"> </span><span class=\"ss\">fqdns</span><span class=\"p\">,</span><span class=\"w\">\n               </span><span class=\"k\">query</span><span class=\"w\"> </span><span class=\"p\">=&gt;</span><span class=\"w\"> </span><span class=\"s\">&quot;foo.local&quot;</span><span class=\"p\">,</span><span class=\"w\">\n               </span><span class=\"ss\">node_basename</span><span class=\"w\"> </span><span class=\"p\">=&gt;</span><span class=\"w\"> </span><span class=\"s\">&quot;foo&quot;</span><span class=\"w\">\n           </span><span class=\"p\" data-group-id=\"8057372712-7\">}</span><span class=\"p\" data-group-id=\"8057372712-6\">}</span><span class=\"w\">\n      </span><span class=\"p\" data-group-id=\"8057372712-4\">]</span><span class=\"p\" data-group-id=\"8057372712-3\">}</span><span class=\"w\">\n  </span><span class=\"p\" data-group-id=\"8057372712-2\">]</span><span class=\"p\" data-group-id=\"8057372712-1\">}</span> Checking if a DNS query If you are experiencing an issue with Partisan not finding the peers using DNS you might want to check the configuration is correct. One way of doing that is by doing the following on your Erlang shell: <span class=\"w\">  </span><span class=\"mi\">1</span><span class=\"o\">&gt;</span><span class=\"w\"> </span><span class=\"n\">Config</span><span class=\"w\"> </span><span class=\"o\">=</span><span class=\"w\"> </span><span class=\"p\" data-group-id=\"5943214408-1\">#{</span><span class=\"w\">\n       </span><span class=\"ss\">record_type</span><span class=\"w\"> </span><span class=\"p\">=&gt;</span><span class=\"w\"> </span><span class=\"ss\">fqdns</span><span class=\"p\">,</span><span class=\"w\">\n       </span><span class=\"k\">query</span><span class=\"w\"> </span><span class=\"p\">=&gt;</span><span class=\"w\"> </span><span class=\"s\">&quot;foo.local&quot;</span><span class=\"p\">,</span><span class=\"w\">\n       </span><span class=\"ss\">node_basename</span><span class=\"w\"> </span><span class=\"p\">=&gt;</span><span class=\"w\"> </span><span class=\"s\">&quot;foo&quot;</span><span class=\"w\">\n  </span><span class=\"p\" data-group-id=\"5943214408-1\">}</span><span class=\"p\">.</span><span class=\"w\">\n  </span><span class=\"mi\">2</span><span class=\"o\">&gt;</span><span class=\"w\"> </span><span class=\"p\" data-group-id=\"5943214408-2\">{</span><span class=\"ss\">ok</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"n\">State</span><span class=\"p\" data-group-id=\"5943214408-2\">}</span><span class=\"w\"> </span><span class=\"o\">=</span><span class=\"w\"> </span><span class=\"nc\">partisan_peer_discovery_dns</span><span class=\"p\">:</span><span class=\"nf\">init</span><span class=\"p\" data-group-id=\"5943214408-3\">(</span><span class=\"n\">Config</span><span class=\"p\" data-group-id=\"5943214408-3\">)</span><span class=\"p\">.</span><span class=\"w\">\n  </span><span class=\"mi\">3</span><span class=\"o\">&gt;</span><span class=\"w\"> </span><span class=\"nc\">partisan_peer_discovery_dns</span><span class=\"p\">:</span><span class=\"nf\">lookup</span><span class=\"p\" data-group-id=\"5943214408-4\">(</span><span class=\"n\">Config</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"mi\">1000</span><span class=\"p\" data-group-id=\"5943214408-4\">)</span><span class=\"p\">.</span> The last line should return the result","ref":"partisan_peer_discovery_dns.html"},{"type":"type","title":"partisan_peer_discovery_dns.config/0","doc":"","ref":"partisan_peer_discovery_dns.html#t:config/0"},{"type":"type","title":"partisan_peer_discovery_dns.deprecated_config/0","doc":"","ref":"partisan_peer_discovery_dns.html#t:deprecated_config/0"},{"type":"function","title":"partisan_peer_discovery_dns.init/1","doc":"","ref":"partisan_peer_discovery_dns.html#init/1"},{"type":"function","title":"partisan_peer_discovery_dns.lookup/2","doc":"","ref":"partisan_peer_discovery_dns.html#lookup/2"},{"type":"type","title":"partisan_peer_discovery_dns.nameserver/0","doc":"","ref":"partisan_peer_discovery_dns.html#t:nameserver/0"},{"type":"type","title":"partisan_peer_discovery_dns.options/0","doc":"","ref":"partisan_peer_discovery_dns.html#t:options/0"},{"type":"type","title":"partisan_peer_discovery_dns.record_type/0","doc":"","ref":"partisan_peer_discovery_dns.html#t:record_type/0"},{"type":"type","title":"partisan_peer_discovery_dns.string_or_type/1","doc":"","ref":"partisan_peer_discovery_dns.html#t:string_or_type/1"},{"type":"module","title":"partisan_peer_discovery_list","doc":"An implementation of the  partisan_peer_discovery_agent  behaviour that uses a static list of node names for service discovery. It is enabled by using the following options in the sys.conf file <span class=\"w\">     </span><span class=\"ss\">bash</span><span class=\"w\">\n  </span><span class=\"p\" data-group-id=\"7699543883-1\">{</span><span class=\"ss\">partisan</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"p\" data-group-id=\"7699543883-2\">[</span><span class=\"w\">\n      </span><span class=\"p\" data-group-id=\"7699543883-3\">{</span><span class=\"ss\">peer_discovery</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"p\" data-group-id=\"7699543883-4\">[</span><span class=\"w\">\n           </span><span class=\"p\" data-group-id=\"7699543883-5\">{</span><span class=\"ss\">type</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"ss\">partisan_peer_discovery_list</span><span class=\"p\" data-group-id=\"7699543883-5\">}</span><span class=\"p\">,</span><span class=\"w\">\n           </span><span class=\"p\" data-group-id=\"7699543883-6\">{</span><span class=\"ss\">config</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"p\" data-group-id=\"7699543883-7\">#{</span><span class=\"w\">\n               </span><span class=\"ss\">name</span><span class=\"w\"> </span><span class=\"p\">=&gt;</span><span class=\"w\"> </span><span class=\"ss\">mynode</span><span class=\"w\">\n               </span><span class=\"ss\">addresses</span><span class=\"w\"> </span><span class=\"p\">=&gt;</span><span class=\"w\"> </span><span class=\"p\" data-group-id=\"7699543883-8\">[</span><span class=\"w\">\n                   </span><span class=\"p\" data-group-id=\"7699543883-9\">&lt;&lt;</span><span class=\"s\">&quot;192.168.40.1:9000&quot;</span><span class=\"p\" data-group-id=\"7699543883-9\">&gt;&gt;</span><span class=\"p\">,</span><span class=\"w\">\n                   </span><span class=\"p\" data-group-id=\"7699543883-10\">&lt;&lt;</span><span class=\"s\">&quot;192.168.40.10:9000&quot;</span><span class=\"p\" data-group-id=\"7699543883-10\">&gt;&gt;</span><span class=\"p\">,</span><span class=\"w\">\n                   </span><span class=\"p\" data-group-id=\"7699543883-11\">&lt;&lt;</span><span class=\"s\">&quot;mynode@192.168.40.100:9000&quot;</span><span class=\"p\" data-group-id=\"7699543883-11\">&gt;&gt;</span><span class=\"p\">,</span><span class=\"w\">\n               </span><span class=\"p\" data-group-id=\"7699543883-8\">]</span><span class=\"w\">\n           </span><span class=\"p\" data-group-id=\"7699543883-7\">}</span><span class=\"p\" data-group-id=\"7699543883-6\">}</span><span class=\"w\">\n      </span><span class=\"p\" data-group-id=\"7699543883-4\">]</span><span class=\"p\" data-group-id=\"7699543883-3\">}</span><span class=\"w\">\n  </span><span class=\"p\" data-group-id=\"7699543883-2\">]</span><span class=\"p\" data-group-id=\"7699543883-1\">}</span>","ref":"partisan_peer_discovery_list.html"},{"type":"function","title":"partisan_peer_discovery_list.init/1","doc":"","ref":"partisan_peer_discovery_list.html#init/1"},{"type":"function","title":"partisan_peer_discovery_list.lookup/2","doc":"","ref":"partisan_peer_discovery_list.html#lookup/2"},{"type":"type","title":"partisan_peer_discovery_list.name/0","doc":"","ref":"partisan_peer_discovery_list.html#t:name/0"},{"type":"type","title":"partisan_peer_discovery_list.options/0","doc":"","ref":"partisan_peer_discovery_list.html#t:options/0"},{"type":"type","title":"partisan_peer_discovery_list.state/0","doc":"","ref":"partisan_peer_discovery_list.html#t:state/0"},{"type":"module","title":"partisan_peer_service_client","doc":"","ref":"partisan_peer_service_client.html"},{"type":"function","title":"partisan_peer_service_client.code_change/3","doc":"","ref":"partisan_peer_service_client.html#code_change/3"},{"type":"function","title":"partisan_peer_service_client.connect/3","doc":"Test harness specific. If we're running a local test, we have to use the same IP address for every bind operation, but a different port instead of the standard port.","ref":"partisan_peer_service_client.html#connect/3"},{"type":"function","title":"partisan_peer_service_client.handle_call/3","doc":"","ref":"partisan_peer_service_client.html#handle_call/3"},{"type":"function","title":"partisan_peer_service_client.handle_cast/2","doc":"","ref":"partisan_peer_service_client.html#handle_cast/2"},{"type":"function","title":"partisan_peer_service_client.handle_info/2","doc":"","ref":"partisan_peer_service_client.html#handle_info/2"},{"type":"function","title":"partisan_peer_service_client.init/1","doc":"","ref":"partisan_peer_service_client.html#init/1"},{"type":"type","title":"partisan_peer_service_client.optional/1","doc":"","ref":"partisan_peer_service_client.html#t:optional/1"},{"type":"function","title":"partisan_peer_service_client.start_link/5","doc":"Start and link to calling process. If the process is started and can get a connection it returns  {ok, pid()} . Otherwise if it fails with  {error, Reason :: any()} .","ref":"partisan_peer_service_client.html#start_link/5"},{"type":"type","title":"partisan_peer_service_client.state/0","doc":"","ref":"partisan_peer_service_client.html#t:state/0"},{"type":"function","title":"partisan_peer_service_client.terminate/2","doc":"","ref":"partisan_peer_service_client.html#terminate/2"},{"type":"module","title":"partisan_peer_service_console","doc":"","ref":"partisan_peer_service_console.html"},{"type":"function","title":"partisan_peer_service_console.members/1","doc":"","ref":"partisan_peer_service_console.html#members/1"},{"type":"function","title":"partisan_peer_service_console.print_members/1","doc":"","ref":"partisan_peer_service_console.html#print_members/1"},{"type":"module","title":"partisan_peer_service_events","doc":"","ref":"partisan_peer_service_events.html"},{"type":"function","title":"partisan_peer_service_events.add_callback/1","doc":"","ref":"partisan_peer_service_events.html#add_callback/1"},{"type":"function","title":"partisan_peer_service_events.add_handler/2","doc":"","ref":"partisan_peer_service_events.html#add_handler/2"},{"type":"function","title":"partisan_peer_service_events.add_sup_callback/1","doc":"","ref":"partisan_peer_service_events.html#add_sup_callback/1"},{"type":"function","title":"partisan_peer_service_events.add_sup_handler/2","doc":"","ref":"partisan_peer_service_events.html#add_sup_handler/2"},{"type":"function","title":"partisan_peer_service_events.code_change/3","doc":"","ref":"partisan_peer_service_events.html#code_change/3"},{"type":"function","title":"partisan_peer_service_events.handle_call/2","doc":"","ref":"partisan_peer_service_events.html#handle_call/2"},{"type":"function","title":"partisan_peer_service_events.handle_event/2","doc":"","ref":"partisan_peer_service_events.html#handle_event/2"},{"type":"function","title":"partisan_peer_service_events.handle_info/2","doc":"","ref":"partisan_peer_service_events.html#handle_info/2"},{"type":"function","title":"partisan_peer_service_events.init/1","doc":"","ref":"partisan_peer_service_events.html#init/1"},{"type":"function","title":"partisan_peer_service_events.start_link/0","doc":"","ref":"partisan_peer_service_events.html#start_link/0"},{"type":"function","title":"partisan_peer_service_events.terminate/2","doc":"","ref":"partisan_peer_service_events.html#terminate/2"},{"type":"function","title":"partisan_peer_service_events.update/1","doc":"","ref":"partisan_peer_service_events.html#update/1"},{"type":"behaviour","title":"partisan_peer_service_manager","doc":"","ref":"partisan_peer_service_manager.html"},{"type":"callback","title":"partisan_peer_service_manager.cast_message/2","doc":"","ref":"partisan_peer_service_manager.html#c:cast_message/2"},{"type":"callback","title":"partisan_peer_service_manager.cast_message/3","doc":"","ref":"partisan_peer_service_manager.html#c:cast_message/3"},{"type":"callback","title":"partisan_peer_service_manager.cast_message/4","doc":"","ref":"partisan_peer_service_manager.html#c:cast_message/4"},{"type":"function","title":"partisan_peer_service_manager.connect/1","doc":"Tries to create a new connection to a node, but only if required. If successful it stores the new connection record in the  partisan_peer_connections  table. This function calls  connect/2  with options  #{prune => false} .","ref":"partisan_peer_service_manager.html#connect/1"},{"type":"function","title":"partisan_peer_service_manager.connect/2","doc":"Create a new connection to a node specified by  NodeSpec  and options  Opts . If a new connection is created it will be stored in the  partisan_peer_connections  table. If option  prune  is  true  returns the tuple  {ok, L :: [ partisan:node_spec()]}  where list L is the list of nodes specifications for all stale nodes. Otherwise returns  ok . A specification is stale if there is another specification for the same node for which we already have one or more active connections. A stale specification will exist when a node has crashed (without leaving the cluster) and later on returned with a different IP address i.e. a normal situation on cloud orchestration platforms. In this case the membership set ( partisan_membership_set ) will have two node specifications for the same node (with differing values for the  listen_addrs  property). See the section **Stale Specifications** in  partisan_membership_set .","ref":"partisan_peer_service_manager.html#connect/2"},{"type":"type","title":"partisan_peer_service_manager.connect_opts/0","doc":"","ref":"partisan_peer_service_manager.html#t:connect_opts/0"},{"type":"callback","title":"partisan_peer_service_manager.decode/1","doc":"","ref":"partisan_peer_service_manager.html#c:decode/1"},{"type":"function","title":"partisan_peer_service_manager.deliver/2","doc":"Internal function used by peer_service manager implementations to forward a message to a local process identified by  ServerRef  (or a global process when connected using disterl). Trying to send a message to a remote server reference when the process is located at a node connected with Partisan will return  ok  but will not succeed.","ref":"partisan_peer_service_manager.html#deliver/2"},{"type":"function","title":"partisan_peer_service_manager.disconnect/1","doc":"Kill all connections with node in  Nodes  and for each call function  Fun  passing the node as argument","ref":"partisan_peer_service_manager.html#disconnect/1"},{"type":"function","title":"partisan_peer_service_manager.disconnect/2","doc":"Kill all connections with node in  Nodes  and for each call function  Fun  passing the node as argument","ref":"partisan_peer_service_manager.html#disconnect/2"},{"type":"callback","title":"partisan_peer_service_manager.forward_message/2","doc":"","ref":"partisan_peer_service_manager.html#c:forward_message/2"},{"type":"callback","title":"partisan_peer_service_manager.forward_message/3","doc":"","ref":"partisan_peer_service_manager.html#c:forward_message/3"},{"type":"callback","title":"partisan_peer_service_manager.forward_message/4","doc":"","ref":"partisan_peer_service_manager.html#c:forward_message/4"},{"type":"type","title":"partisan_peer_service_manager.forward_opts/0","doc":"","ref":"partisan_peer_service_manager.html#t:forward_opts/0"},{"type":"callback","title":"partisan_peer_service_manager.get_local_state/0","doc":"","ref":"partisan_peer_service_manager.html#c:get_local_state/0"},{"type":"callback","title":"partisan_peer_service_manager.inject_partition/2","doc":"","ref":"partisan_peer_service_manager.html#c:inject_partition/2"},{"type":"callback","title":"partisan_peer_service_manager.join/1","doc":"","ref":"partisan_peer_service_manager.html#c:join/1"},{"type":"callback","title":"partisan_peer_service_manager.leave/0","doc":"","ref":"partisan_peer_service_manager.html#c:leave/0"},{"type":"callback","title":"partisan_peer_service_manager.leave/1","doc":"","ref":"partisan_peer_service_manager.html#c:leave/1"},{"type":"callback","title":"partisan_peer_service_manager.members/0","doc":"","ref":"partisan_peer_service_manager.html#c:members/0"},{"type":"callback","title":"partisan_peer_service_manager.members_for_orchestration/0","doc":"","ref":"partisan_peer_service_manager.html#c:members_for_orchestration/0"},{"type":"function","title":"partisan_peer_service_manager.mynode/0","doc":"","ref":"partisan_peer_service_manager.html#mynode/0"},{"type":"function","title":"partisan_peer_service_manager.myself/0","doc":"","ref":"partisan_peer_service_manager.html#myself/0"},{"type":"callback","title":"partisan_peer_service_manager.on_down/2","doc":"","ref":"partisan_peer_service_manager.html#c:on_down/2"},{"type":"callback","title":"partisan_peer_service_manager.on_down/3","doc":"","ref":"partisan_peer_service_manager.html#c:on_down/3"},{"type":"type","title":"partisan_peer_service_manager.on_event_fun/0","doc":"","ref":"partisan_peer_service_manager.html#t:on_event_fun/0"},{"type":"callback","title":"partisan_peer_service_manager.on_up/2","doc":"","ref":"partisan_peer_service_manager.html#c:on_up/2"},{"type":"callback","title":"partisan_peer_service_manager.on_up/3","doc":"","ref":"partisan_peer_service_manager.html#c:on_up/3"},{"type":"type","title":"partisan_peer_service_manager.partitions/0","doc":"","ref":"partisan_peer_service_manager.html#t:partitions/0"},{"type":"callback","title":"partisan_peer_service_manager.partitions/0","doc":"","ref":"partisan_peer_service_manager.html#c:partitions/0"},{"type":"callback","title":"partisan_peer_service_manager.receive_message/3","doc":"","ref":"partisan_peer_service_manager.html#c:receive_message/3"},{"type":"callback","title":"partisan_peer_service_manager.reserve/1","doc":"","ref":"partisan_peer_service_manager.html#c:reserve/1"},{"type":"callback","title":"partisan_peer_service_manager.resolve_partition/1","doc":"","ref":"partisan_peer_service_manager.html#c:resolve_partition/1"},{"type":"callback","title":"partisan_peer_service_manager.send_message/2","doc":"","ref":"partisan_peer_service_manager.html#c:send_message/2"},{"type":"function","title":"partisan_peer_service_manager.send_message/2","doc":"Send a message to a remote peer_service_manager.","ref":"partisan_peer_service_manager.html#send_message/2"},{"type":"type","title":"partisan_peer_service_manager.server_ref/0","doc":"","ref":"partisan_peer_service_manager.html#t:server_ref/0"},{"type":"callback","title":"partisan_peer_service_manager.start_link/0","doc":"","ref":"partisan_peer_service_manager.html#c:start_link/0"},{"type":"callback","title":"partisan_peer_service_manager.supports_capability/1","doc":"","ref":"partisan_peer_service_manager.html#c:supports_capability/1"},{"type":"function","title":"partisan_peer_service_manager.supports_capability/2","doc":"If  Mod  implements callback  supports_capability/1  returns the result of calling the callback passing argument  Arg . Otherwise, returns  false .","ref":"partisan_peer_service_manager.html#supports_capability/2"},{"type":"callback","title":"partisan_peer_service_manager.sync_join/1","doc":"","ref":"partisan_peer_service_manager.html#c:sync_join/1"},{"type":"callback","title":"partisan_peer_service_manager.update_members/1","doc":"","ref":"partisan_peer_service_manager.html#c:update_members/1"},{"type":"module","title":"partisan_peer_service_server","doc":"","ref":"partisan_peer_service_server.html"},{"type":"function","title":"partisan_peer_service_server.acceptor_continue/3","doc":"","ref":"partisan_peer_service_server.html#acceptor_continue/3"},{"type":"function","title":"partisan_peer_service_server.acceptor_init/3","doc":"","ref":"partisan_peer_service_server.html#acceptor_init/3"},{"type":"function","title":"partisan_peer_service_server.acceptor_terminate/2","doc":"","ref":"partisan_peer_service_server.html#acceptor_terminate/2"},{"type":"function","title":"partisan_peer_service_server.code_change/3","doc":"","ref":"partisan_peer_service_server.html#code_change/3"},{"type":"function","title":"partisan_peer_service_server.handle_call/3","doc":"","ref":"partisan_peer_service_server.html#handle_call/3"},{"type":"function","title":"partisan_peer_service_server.handle_cast/2","doc":"","ref":"partisan_peer_service_server.html#handle_cast/2"},{"type":"function","title":"partisan_peer_service_server.handle_inbound/2","doc":"","ref":"partisan_peer_service_server.html#handle_inbound/2"},{"type":"function","title":"partisan_peer_service_server.handle_info/2","doc":"","ref":"partisan_peer_service_server.html#handle_info/2"},{"type":"function","title":"partisan_peer_service_server.init/1","doc":"","ref":"partisan_peer_service_server.html#init/1"},{"type":"type","title":"partisan_peer_service_server.optional/1","doc":"","ref":"partisan_peer_service_server.html#t:optional/1"},{"type":"type","title":"partisan_peer_service_server.state_t/0","doc":"","ref":"partisan_peer_service_server.html#t:state_t/0"},{"type":"function","title":"partisan_peer_service_server.terminate/2","doc":"","ref":"partisan_peer_service_server.html#terminate/2"},{"type":"module","title":"partisan_peer_service_sup","doc":"","ref":"partisan_peer_service_sup.html"},{"type":"function","title":"partisan_peer_service_sup.init/1","doc":"","ref":"partisan_peer_service_sup.html#init/1"},{"type":"function","title":"partisan_peer_service_sup.start_link/0","doc":"","ref":"partisan_peer_service_sup.html#start_link/0"},{"type":"module","title":"partisan_remote_ref","doc":"Remote references are Partisan's representation for remote process identifiers ( pid() ), registered names and references ( reference() ). Distributed Erlang (disterl) will transform the representation of process identifiers, registered names and references when they are sent to a remote node. This is done to disambiguate between remote and local instances. Because Partisan doesn't use disterl it needs to implement this same disambiguation mechanism somehow. As disterl's implementation is done by the BEAM internally and not API is exposed, this module is required to achieve a similar result. Representation In cases where lots of references are stored in process state,  ets  and specially where those are uses as keys, a binary format is preferable to the tuple format in order to save memory and avoid copying the term every time a message is send between processes (by leveraging off-heap binary storage). For this reason, this module implements two alternative representations: references as binary URIs references as tuples The representation to use is controlled by the configuration option  remote_ref_as_uri`. If `true  this module will generate references as binary URIs. Otherwise it will generate them as tuples.r URI Representation <span class=\"w\">  </span><span class=\"mi\">1</span><span class=\"o\">&gt;</span><span class=\"w\"> </span><span class=\"nc\">partisan_remote_ref</span><span class=\"p\">:</span><span class=\"nf\">from_term</span><span class=\"p\" data-group-id=\"1097714694-1\">(</span><span class=\"nf\">self</span><span class=\"p\" data-group-id=\"1097714694-2\">(</span><span class=\"p\" data-group-id=\"1097714694-2\">)</span><span class=\"p\" data-group-id=\"1097714694-1\">)</span><span class=\"p\">.</span><span class=\"w\">\n  </span><span class=\"p\" data-group-id=\"1097714694-3\">&lt;&lt;</span><span class=\"s\">&quot;partisan:pid:nonode@nohost:0.1062.0&quot;</span><span class=\"p\" data-group-id=\"1097714694-3\">&gt;&gt;</span> URI Padding For those cases where the resulting references are smaller than 64 bytes ( and thus will be stored on the process heap) this module can pad the generated binary URIs to 65 bytes, thus forcing them to be stored off-heap. This is controlled with the configuration option  remote_ref_binary_padding . <span class=\"w\">  </span><span class=\"mi\">1</span><span class=\"o\">&gt;</span><span class=\"w\"> </span><span class=\"nc\">partisan_config</span><span class=\"p\">:</span><span class=\"nf\">set</span><span class=\"p\" data-group-id=\"4261224322-1\">(</span><span class=\"ss\">remote_ref_binary_padding</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"ss\">false</span><span class=\"p\" data-group-id=\"4261224322-1\">)</span><span class=\"p\">.</span><span class=\"w\">\n  </span><span class=\"mi\">2</span><span class=\"o\">&gt;</span><span class=\"w\"> </span><span class=\"nc\">partisan_remote_ref</span><span class=\"p\">:</span><span class=\"nf\">from_term</span><span class=\"p\" data-group-id=\"4261224322-2\">(</span><span class=\"nf\">self</span><span class=\"p\" data-group-id=\"4261224322-3\">(</span><span class=\"p\" data-group-id=\"4261224322-3\">)</span><span class=\"p\" data-group-id=\"4261224322-2\">)</span><span class=\"p\">.</span><span class=\"w\">\n  </span><span class=\"p\" data-group-id=\"4261224322-4\">&lt;&lt;</span><span class=\"s\">&quot;partisan:pid:nonode@nohost:0.1062.0&quot;</span><span class=\"p\" data-group-id=\"4261224322-4\">&gt;&gt;</span><span class=\"w\">\n  </span><span class=\"mi\">3</span><span class=\"o\">&gt;</span><span class=\"w\"> </span><span class=\"nc\">partisan_config</span><span class=\"p\">:</span><span class=\"nf\">set</span><span class=\"p\" data-group-id=\"4261224322-5\">(</span><span class=\"ss\">remote_ref_binary_padding</span><span class=\"p\">,</span><span class=\"w\"> </span><span class=\"ss\">true</span><span class=\"p\" data-group-id=\"4261224322-5\">)</span><span class=\"p\">.</span><span class=\"w\">\n  </span><span class=\"ss\">ok</span><span class=\"w\">\n  </span><span class=\"mi\">4</span><span class=\"o\">&gt;</span><span class=\"w\"> </span><span class=\"nc\">partisan_remote_ref</span><span class=\"p\">:</span><span class=\"nf\">from_term</span><span class=\"p\" data-group-id=\"4261224322-6\">(</span><span class=\"nf\">self</span><span class=\"p\" data-group-id=\"4261224322-7\">(</span><span class=\"p\" data-group-id=\"4261224322-7\">)</span><span class=\"p\" data-group-id=\"4261224322-6\">)</span><span class=\"p\">.</span><span class=\"w\">\n  </span><span class=\"p\" data-group-id=\"4261224322-8\">&lt;&lt;</span><span class=\"s\">&quot;partisan:pid:nonode@nohost:0.1062.0:&quot;</span><span class=\"p\">.</span><span class=\"p\">.</span><span class=\"p\">.</span><span class=\"p\" data-group-id=\"4261224322-8\">&gt;&gt;</span> Tuple Representation <span class=\"w\">  </span><span class=\"mi\">1</span><span class=\"o\">&gt;</span><span class=\"w\"> </span><span class=\"nc\">partisan_remote_ref</span><span class=\"p\">:</span><span class=\"nf\">from_term</span><span class=\"p\" data-group-id=\"5510562828-1\">(</span><span class=\"nf\">self</span><span class=\"p\" data-group-id=\"5510562828-2\">(</span><span class=\"p\" data-group-id=\"5510562828-2\">)</span><span class=\"p\" data-group-id=\"5510562828-1\">)</span><span class=\"p\">.</span><span class=\"w\">\n  </span><span class=\"p\" data-group-id=\"5510562828-3\">{</span><span class=\"ss\">partisan_remote_reference</span><span class=\"p\">,</span><span class=\"w\">\n     </span><span class=\"ss\">nonode@nohost</span><span class=\"p\">,</span><span class=\"w\">\n     </span><span class=\"p\" data-group-id=\"5510562828-4\">{</span><span class=\"ss\">partisan_process_reference</span><span class=\"p\">,</span><span class=\"s\">&quot;&lt;0.1062.0&gt;&quot;</span><span class=\"p\" data-group-id=\"5510562828-4\">}</span><span class=\"p\" data-group-id=\"5510562828-3\">}</span> Issues and TODOs As opposed to erlang pid encodintg ( NEW_PID_EXT`) our current representation cannot distinguished between identifiers from old (crashed) nodes from a new one. So maybe we need to adopt the `NEW_PID_EXT Creation  attribute.","ref":"partisan_remote_ref.html"},{"type":"type","title":"partisan_remote_ref.encoded_name/0","doc":"","ref":"partisan_remote_ref.html#t:encoded_name/0"},{"type":"type","title":"partisan_remote_ref.encoded_pid/0","doc":"","ref":"partisan_remote_ref.html#t:encoded_pid/0"},{"type":"type","title":"partisan_remote_ref.encoded_ref/0","doc":"","ref":"partisan_remote_ref.html#t:encoded_ref/0"},{"type":"type","title":"partisan_remote_ref.format/0","doc":"","ref":"partisan_remote_ref.html#t:format/0"},{"type":"function","title":"partisan_remote_ref.from_term/1","doc":"Returns the partisan-encoded representation of a process identifier, reference, local or remote registered name (atom). In the case of a name, the function does not check  Name  is an actual registered name.","ref":"partisan_remote_ref.html#from_term/1"},{"type":"function","title":"partisan_remote_ref.from_term/2","doc":"Returns the partisan-encoded representation of a registered name  Name  at node  Node . The function does not check  Name  is an actual registered name,","ref":"partisan_remote_ref.html#from_term/2"},{"type":"function","title":"partisan_remote_ref.is_identical/2","doc":"Checks two refs for identity. Two refs are identical if the are equal or if one is a process reference and the other one is a registered name reference of said process. In the latter case the function uses  erlang:whereis/1  which means the check can fail if the process has died (and thus is no longer registered).","ref":"partisan_remote_ref.html#is_identical/2"},{"type":"function","title":"partisan_remote_ref.is_local/1","doc":"","ref":"partisan_remote_ref.html#is_local/1"},{"type":"function","title":"partisan_remote_ref.is_local/2","doc":"Returns true if reference  Ref  is located in node  Node .","ref":"partisan_remote_ref.html#is_local/2"},{"type":"function","title":"partisan_remote_ref.is_local_name/1","doc":"","ref":"partisan_remote_ref.html#is_local_name/1"},{"type":"function","title":"partisan_remote_ref.is_local_name/2","doc":"","ref":"partisan_remote_ref.html#is_local_name/2"},{"type":"function","title":"partisan_remote_ref.is_local_pid/1","doc":"","ref":"partisan_remote_ref.html#is_local_pid/1"},{"type":"function","title":"partisan_remote_ref.is_local_pid/2","doc":"","ref":"partisan_remote_ref.html#is_local_pid/2"},{"type":"function","title":"partisan_remote_ref.is_local_reference/1","doc":"","ref":"partisan_remote_ref.html#is_local_reference/1"},{"type":"function","title":"partisan_remote_ref.is_local_reference/2","doc":"","ref":"partisan_remote_ref.html#is_local_reference/2"},{"type":"function","title":"partisan_remote_ref.is_name/1","doc":"","ref":"partisan_remote_ref.html#is_name/1"},{"type":"function","title":"partisan_remote_ref.is_name/2","doc":"","ref":"partisan_remote_ref.html#is_name/2"},{"type":"function","title":"partisan_remote_ref.is_pid/1","doc":"","ref":"partisan_remote_ref.html#is_pid/1"},{"type":"function","title":"partisan_remote_ref.is_reference/1","doc":"","ref":"partisan_remote_ref.html#is_reference/1"},{"type":"function","title":"partisan_remote_ref.is_type/1","doc":"","ref":"partisan_remote_ref.html#is_type/1"},{"type":"type","title":"partisan_remote_ref.n/0","doc":"","ref":"partisan_remote_ref.html#t:n/0"},{"type":"function","title":"partisan_remote_ref.node/1","doc":"","ref":"partisan_remote_ref.html#node/1"},{"type":"function","title":"partisan_remote_ref.nodestring/1","doc":"","ref":"partisan_remote_ref.html#nodestring/1"},{"type":"type","title":"partisan_remote_ref.p/0","doc":"","ref":"partisan_remote_ref.html#t:p/0"},{"type":"type","title":"partisan_remote_ref.r/0","doc":"","ref":"partisan_remote_ref.html#t:r/0"},{"type":"type","title":"partisan_remote_ref.t/0","doc":"","ref":"partisan_remote_ref.html#t:t/0"},{"type":"type","title":"partisan_remote_ref.target/0","doc":"","ref":"partisan_remote_ref.html#t:target/0"},{"type":"function","title":"partisan_remote_ref.target/1","doc":"","ref":"partisan_remote_ref.html#target/1"},{"type":"function","title":"partisan_remote_ref.to_name/1","doc":"Calls  to_term/1  and returns the result if it is an local name i.e. atom(). Otherwise fails with  badarg","ref":"partisan_remote_ref.html#to_name/1"},{"type":"function","title":"partisan_remote_ref.to_pid/1","doc":"Calls  to_term/1  and returns the result if it is a local pid(). Otherwise fails with  badarg","ref":"partisan_remote_ref.html#to_pid/1"},{"type":"function","title":"partisan_remote_ref.to_pid_or_name/1","doc":"Calls  to_term/1  and returns the result if it is an local name i.e. atom() or local pid(). Otherwise fails with  badarg","ref":"partisan_remote_ref.html#to_pid_or_name/1"},{"type":"function","title":"partisan_remote_ref.to_reference/1","doc":"Calls  to_term/1  and returns the result if it is a local reference(). Otherwise fails with  badarg","ref":"partisan_remote_ref.html#to_reference/1"},{"type":"function","title":"partisan_remote_ref.to_term/1","doc":"","ref":"partisan_remote_ref.html#to_term/1"},{"type":"type","title":"partisan_remote_ref.tuple_ref/1","doc":"","ref":"partisan_remote_ref.html#t:tuple_ref/1"},{"type":"type","title":"partisan_remote_ref.uri/0","doc":"","ref":"partisan_remote_ref.html#t:uri/0"},{"type":"module","title":"partisan_client_server_peer_service_manager","doc":"This module realises the  partisan_peer_service_manager  behaviour implementing client-server topology where clients communicate with a single server and servers form a full-mesh topology. Characteristics Uses TCP/IP. Client nodes communicate and maintain connections with server nodes. They refuse connections from other clients but refer them to a server node. Server nodes communicate and maintain connections with all other server nodes. Nodes periodically send heartbeat messages. The service considers a node \"failed\" when it misses X heartbeats. Point-to-point messaging through the server (server as relay). Eventually consistent membership maintained in a CRDT and replicated using gossip. Scalability limited to hundres of nodes (60-200 nodes).","ref":"partisan_client_server_peer_service_manager.html"},{"type":"type","title":"partisan_client_server_peer_service_manager.call/0","doc":"","ref":"partisan_client_server_peer_service_manager.html#t:call/0"},{"type":"type","title":"partisan_client_server_peer_service_manager.cast/0","doc":"","ref":"partisan_client_server_peer_service_manager.html#t:cast/0"},{"type":"function","title":"partisan_client_server_peer_service_manager.cast_message/2","doc":"","ref":"partisan_client_server_peer_service_manager.html#cast_message/2"},{"type":"function","title":"partisan_client_server_peer_service_manager.cast_message/3","doc":"Cast a message to a remote gen_server.","ref":"partisan_client_server_peer_service_manager.html#cast_message/3"},{"type":"function","title":"partisan_client_server_peer_service_manager.cast_message/4","doc":"Cast a message to a remote gen_server.","ref":"partisan_client_server_peer_service_manager.html#cast_message/4"},{"type":"function","title":"partisan_client_server_peer_service_manager.decode/1","doc":"Decode state.","ref":"partisan_client_server_peer_service_manager.html#decode/1"},{"type":"function","title":"partisan_client_server_peer_service_manager.forward_message/2","doc":"Gensym support for forwarding.","ref":"partisan_client_server_peer_service_manager.html#forward_message/2"},{"type":"function","title":"partisan_client_server_peer_service_manager.forward_message/3","doc":"Gensym support for forwarding.","ref":"partisan_client_server_peer_service_manager.html#forward_message/3"},{"type":"function","title":"partisan_client_server_peer_service_manager.forward_message/4","doc":"Forward message to registered process on the remote side.","ref":"partisan_client_server_peer_service_manager.html#forward_message/4"},{"type":"function","title":"partisan_client_server_peer_service_manager.get_local_state/0","doc":"Return local node's view of cluster membership.","ref":"partisan_client_server_peer_service_manager.html#get_local_state/0"},{"type":"function","title":"partisan_client_server_peer_service_manager.handle_call/3","doc":"","ref":"partisan_client_server_peer_service_manager.html#handle_call/3"},{"type":"function","title":"partisan_client_server_peer_service_manager.handle_cast/2","doc":"","ref":"partisan_client_server_peer_service_manager.html#handle_cast/2"},{"type":"function","title":"partisan_client_server_peer_service_manager.handle_info/2","doc":"","ref":"partisan_client_server_peer_service_manager.html#handle_info/2"},{"type":"function","title":"partisan_client_server_peer_service_manager.init/1","doc":"","ref":"partisan_client_server_peer_service_manager.html#init/1"},{"type":"function","title":"partisan_client_server_peer_service_manager.inject_partition/2","doc":"Inject a partition.","ref":"partisan_client_server_peer_service_manager.html#inject_partition/2"},{"type":"function","title":"partisan_client_server_peer_service_manager.join/1","doc":"Attempt to join a remote node.","ref":"partisan_client_server_peer_service_manager.html#join/1"},{"type":"function","title":"partisan_client_server_peer_service_manager.leave/0","doc":"Leave the cluster.","ref":"partisan_client_server_peer_service_manager.html#leave/0"},{"type":"function","title":"partisan_client_server_peer_service_manager.leave/1","doc":"Remove another node from the cluster.","ref":"partisan_client_server_peer_service_manager.html#leave/1"},{"type":"function","title":"partisan_client_server_peer_service_manager.members/0","doc":"Return membership list.","ref":"partisan_client_server_peer_service_manager.html#members/0"},{"type":"function","title":"partisan_client_server_peer_service_manager.members_for_orchestration/0","doc":"Return membership list.","ref":"partisan_client_server_peer_service_manager.html#members_for_orchestration/0"},{"type":"type","title":"partisan_client_server_peer_service_manager.membership/0","doc":"","ref":"partisan_client_server_peer_service_manager.html#t:membership/0"},{"type":"function","title":"partisan_client_server_peer_service_manager.on_down/2","doc":"Trigger function on connection close for a given node.  Fun  is a function object taking zero or a single argument, where the argument is the Node name.","ref":"partisan_client_server_peer_service_manager.html#on_down/2"},{"type":"function","title":"partisan_client_server_peer_service_manager.on_down/3","doc":"Trigger function on connection close for a given node.  Fun  is a function object taking zero or a single argument, where the argument is the Node name.","ref":"partisan_client_server_peer_service_manager.html#on_down/3"},{"type":"type","title":"partisan_client_server_peer_service_manager.on_event_fun/0","doc":"","ref":"partisan_client_server_peer_service_manager.html#t:on_event_fun/0"},{"type":"function","title":"partisan_client_server_peer_service_manager.on_up/2","doc":"Trigger function on connection open for a given node.  Fun  is a function object taking zero or a single argument, where the argument is the Node name.","ref":"partisan_client_server_peer_service_manager.html#on_up/2"},{"type":"function","title":"partisan_client_server_peer_service_manager.on_up/3","doc":"Trigger function on connection open for a given node.  Fun  is a function object taking zero or a single argument, where the argument is the Node name.","ref":"partisan_client_server_peer_service_manager.html#on_up/3"},{"type":"function","title":"partisan_client_server_peer_service_manager.partitions/0","doc":"Return partitions.","ref":"partisan_client_server_peer_service_manager.html#partitions/0"},{"type":"type","title":"partisan_client_server_peer_service_manager.pending/0","doc":"","ref":"partisan_client_server_peer_service_manager.html#t:pending/0"},{"type":"function","title":"partisan_client_server_peer_service_manager.receive_message/3","doc":"Receive message from a remote manager.","ref":"partisan_client_server_peer_service_manager.html#receive_message/3"},{"type":"function","title":"partisan_client_server_peer_service_manager.reserve/1","doc":"Reserve a slot for the particular tag.","ref":"partisan_client_server_peer_service_manager.html#reserve/1"},{"type":"function","title":"partisan_client_server_peer_service_manager.resolve_partition/1","doc":"Resolve a partition.","ref":"partisan_client_server_peer_service_manager.html#resolve_partition/1"},{"type":"function","title":"partisan_client_server_peer_service_manager.send_message/2","doc":"Send message to a remote manager.","ref":"partisan_client_server_peer_service_manager.html#send_message/2"},{"type":"function","title":"partisan_client_server_peer_service_manager.start_link/0","doc":"Same as start_link([]).","ref":"partisan_client_server_peer_service_manager.html#start_link/0"},{"type":"type","title":"partisan_client_server_peer_service_manager.state/0","doc":"","ref":"partisan_client_server_peer_service_manager.html#t:state/0"},{"type":"function","title":"partisan_client_server_peer_service_manager.supports_capability/1","doc":"","ref":"partisan_client_server_peer_service_manager.html#supports_capability/1"},{"type":"function","title":"partisan_client_server_peer_service_manager.sync_join/1","doc":"Attempt to join a remote node.","ref":"partisan_client_server_peer_service_manager.html#sync_join/1"},{"type":"type","title":"partisan_client_server_peer_service_manager.tag/0","doc":"","ref":"partisan_client_server_peer_service_manager.html#t:tag/0"},{"type":"function","title":"partisan_client_server_peer_service_manager.update_members/1","doc":"Update membership.","ref":"partisan_client_server_peer_service_manager.html#update_members/1"},{"type":"module","title":"partisan_hyparview_peer_service_manager","doc":"This module realises the  partisan_peer_service_manager  behaviour implementing a peer-to-peer partial mesh topology using the protocol described in the paper  HyParView: a membership protocol for reliable gossip-based broadcast  by João Leitão, José Pereira and Luís Rodrigues. The following content contains abstracts from the paper. Characteristics Uses TCP/IP as an unreliable failure detector (unreliable because it can generate false positives e.g. when the network becomes suddenly congested). It can sustain high level of node failres while ensuring connectivity of the overlay. Nodes are considered \"failed\" when the TCP/IP connection is dropped. Nodes maintain partial views of the network. Every node will contain and  active view  that forms a connected grah, and a  passive view  of backup links that are used to repair graph connectivity under failure. Some links to passive nodes are kept open for fast replacement of failed nodes in the active view. So the view is probabilistic, meaning that the protocol doesn't prevent (nor detects) the cluter to be split into several subclusters with no connections to each other. HyParView sacrificies strong membership for high availability and connectivity: the algorithm constantly works towards and ensures that eventually the clsuter membership is a fully-connected component. However, at any point in time different nodes may have different, inconsistent views of the cluster membership. As a consequence, HyParView is not designed to work with systems that require strong membership properties, eg. consensus protocols like Paxos or Raft. Point-to-point messaging for connected nodes with a minimum of 1 hop via transitive message delivery (as not all nodes directly connected). Delivery is probabilistic. No explicit leave operation, because the overlay is able to react fast enough to node failures. Hence when a node wishes to leave the system it is simply treated as if the node have failed. Scalability to up-to 2,000 nodes. HyParView Membership Protocol Partial View A partial view is a small subset of the entire system (cluster) membership, a set of node specifications maintained locally at each node. A node specification i.e.  partisan:node_spec()  allows a node to be reached by other nodes. A membership protocol is in charge of initializing and maintaining the partial views at each node in face of dynamic changes in the system. For instance, when a new node joins the system, its identifier should be added to the partial view of (some) other nodes and it has to create its own partial view, including identifiers of nodes already in the system. Also, if a node fails or leaves the system, its identifier should be removed from all partial views as soon as possible. Partial views establish neighboring associations among nodes. Therefore, partial views define an overlay network, in other words, partial views establish an directed graph that captures the neighbor relation between all nodes executing the protocol. In this graph nodes are represented by a vertex while a neighbor relation is represented by an arc from the node who contains the target node in his partial view. Membership Protocol The Hybrid Partial View (HyParView) membership protocol is in charge of maintaining two distinct views at each node: a small active view, of size  log(n) + c , and a larger passive view, of size  k(log(n) + c) . It then selects which members of this view should be promoted to the active view. Active View Each node maintains a small symmetric ctive view the size of fanout + 1. Being symmetric means means that if node  q  is in the active view of node  p  then node  p  is also in the active view of node  q . The active views af all cluster nodes create an overlay that is used for message dissemination. Each node keeps an open TCP connection to every other node in its active view. Broadcast is performed deterministically by flooding the graph defined by the active views across the cluster. When a node receives a message for the first time, it broadcasts the message to all nodes of its active view ( except, obviously, to the node that has sent the message). While this graph is generated at random, gossip is deterministic as long as the graph remains unchanged. Active View Management A reactive strategy is used to maintain the active view. Nodes can be added to the active view when they join the system. Also, nodes are removed from the active view when they fail. When a node  p  suspects that one of the nodes present in its active view has failed (by either disconnecting or blocking), it selects a random node  q  from its passive view and attempts to establish a TCP connection with  q . If the connection fails to establish, node  q  is considered failed and removed from  p’s  passive view; another node  q′  is selected at random and a new attempt is made. When the connection is established with success, p sends to q a Neighbor request with its own identifier and a priority level. The priority level of the request may take two values, depending on the number of nodes present in the active view of p: if p has no elements in its active view the priority is high; the priority is low otherwise. A node q that receives a high priority neighbor request will always accept the request, even if it has to drop a random member from its active view ( again, the member that is dropped will receive a Disconnect notification). If a node q receives a low priority Neighbor request, it will only accept the request if it has a free slot in its active view, otherwise it will refuse the request. If the node q accepts the Neighbor request, p will remove q’s identifier from its passive view and add it to the active view. If q rejects the Neighbor request, the initiator will select another node from its passive view and repeat the whole procedure (without removing q from its passive view). Each node tests its entire active view every time it forwards a message. Therefore, the entire broadcast overlay is implicitly tested at every broadcast, which allows a very fast failure detection. Passive View In addition to the active view, each node maintains a larger passive view of backup nodes that can be promoted to the active view when one of the nodes in the active view fails. The passive view is not used for message dissemination. Instead, the goal of the passive view is to maintain a list of nodes that can be used to replace failed members of the active view. The passive view is maintained using a cyclic strategy. Periodically, each node performs a shuffle operation with one of its neighbors in order to update its passive view. Passive View Management The passive view is maintained using a cyclic strategy. Periodically, each node perform a shuffle operation with one of its peers at random. The purpose of the shuffle operation is to update the passive views of the nodes involved in the exchange. The node p that initiates the exchange creates an exchange list with the following contents: p’s own identifier, ka nodes from its active view and kp nodes from its passive view (where ka and kp are protocol parameters). It then sends the list in a Shuffle request to a random neighbor of its active view. Shuffle requests are propagated using a random walk and have an associated “time to live”, just like the ForwardJoin requests. A node q that receives a Shuffle request will first decrease its time to live. If the time to live of the message is greater than zero and the number of nodes in q’s active view is greater than 1, the node will select a random node from its active view, different from the one he received this shuffle message from, and simply forwards the Shuffle request. Otherwise, node q accepts the Shuffle request and send back, using a temporary TCP connection, a ShuffleReply message that includes a number of nodes selected at random from q’s passive view equal to the number of nodes received in the Shuffle request. Then, both nodes integrate the elements they received in the Shuffle/ ShuffleReply mes- sage into their passive views (naturally, they exclude their own identifier and nodes that are part of the active or passive views). Because the passive view has a fixed length, it might get full; in that case, some identifiers will have to be removed in order to free space to include the new ones. A node will first attempt to remove identifiers sent to the peer. If no such identifiers remain in the passive view, it will remove identifiers at random. Configuration The following are the HyParView configuration parameters managed by  partisan_config . The params are passed as  {hyparview, Config}  where  Config  is a property list or map where the keys are the following: active_max_size Defaults to 6. active_min_size Defaults to 3. active_rwl Active View Random Walk Length. Defaults to 6. passive_max_size Defaults to 30. passive_rwl Passive View Random Walk Length. Defaults to 6. random_promotion A boolean indicating if random promotion is enabled. Defaults  true . random_promotion_interval Time after which the protocol attempts to promote a node in the passive view to the active view.Defaults to 5000. shuffle_interval Defaults to 10000. shuffle_k_active Number of peers to include in the shuffle exchange. Defaults to 3. shuffle_k_passive Number of peers to include in the shuffle exchange. Defaults to 4.","ref":"partisan_hyparview_peer_service_manager.html"},{"type":"type","title":"partisan_hyparview_peer_service_manager.active/0","doc":"","ref":"partisan_hyparview_peer_service_manager.html#t:active/0"},{"type":"function","title":"partisan_hyparview_peer_service_manager.active/0","doc":"Debugging.","ref":"partisan_hyparview_peer_service_manager.html#active/0"},{"type":"function","title":"partisan_hyparview_peer_service_manager.active/1","doc":"Debugging.","ref":"partisan_hyparview_peer_service_manager.html#active/1"},{"type":"function","title":"partisan_hyparview_peer_service_manager.add_to_active_view/3","doc":"Add to the active view. However, interesting race condition here: if the passive random walk timer exceeded and the node was added to the passive view, we might also have the active random walk timer exceed *after* because of a network delay; if so, we have to remove this element from the passive view, otherwise it will exist in both places.","ref":"partisan_hyparview_peer_service_manager.html#add_to_active_view/3"},{"type":"type","title":"partisan_hyparview_peer_service_manager.call/0","doc":"","ref":"partisan_hyparview_peer_service_manager.html#t:call/0"},{"type":"type","title":"partisan_hyparview_peer_service_manager.cast/0","doc":"","ref":"partisan_hyparview_peer_service_manager.html#t:cast/0"},{"type":"function","title":"partisan_hyparview_peer_service_manager.cast_message/2","doc":"","ref":"partisan_hyparview_peer_service_manager.html#cast_message/2"},{"type":"function","title":"partisan_hyparview_peer_service_manager.cast_message/3","doc":"Cast a message to a remote gen_server.","ref":"partisan_hyparview_peer_service_manager.html#cast_message/3"},{"type":"function","title":"partisan_hyparview_peer_service_manager.cast_message/4","doc":"Cast a message to a remote gen_server.","ref":"partisan_hyparview_peer_service_manager.html#cast_message/4"},{"type":"function","title":"partisan_hyparview_peer_service_manager.code_change/3","doc":"","ref":"partisan_hyparview_peer_service_manager.html#code_change/3"},{"type":"type","title":"partisan_hyparview_peer_service_manager.config/0","doc":"","ref":"partisan_hyparview_peer_service_manager.html#t:config/0"},{"type":"function","title":"partisan_hyparview_peer_service_manager.decode/1","doc":"Decode state.","ref":"partisan_hyparview_peer_service_manager.html#decode/1"},{"type":"type","title":"partisan_hyparview_peer_service_manager.epoch/0","doc":"The epoch_count indicates how many disconnect messages are generated.","ref":"partisan_hyparview_peer_service_manager.html#t:epoch/0"},{"type":"type","title":"partisan_hyparview_peer_service_manager.epoch_count/0","doc":"","ref":"partisan_hyparview_peer_service_manager.html#t:epoch_count/0"},{"type":"function","title":"partisan_hyparview_peer_service_manager.forward_message/2","doc":"Gensym support for forwarding.","ref":"partisan_hyparview_peer_service_manager.html#forward_message/2"},{"type":"function","title":"partisan_hyparview_peer_service_manager.forward_message/3","doc":"Gensym support for forwarding.","ref":"partisan_hyparview_peer_service_manager.html#forward_message/3"},{"type":"function","title":"partisan_hyparview_peer_service_manager.forward_message/4","doc":"Forward message to registered process on the remote side.","ref":"partisan_hyparview_peer_service_manager.html#forward_message/4"},{"type":"function","title":"partisan_hyparview_peer_service_manager.get_local_state/0","doc":"Return local node's view of cluster membership.","ref":"partisan_hyparview_peer_service_manager.html#get_local_state/0"},{"type":"function","title":"partisan_hyparview_peer_service_manager.handle_call/3","doc":"","ref":"partisan_hyparview_peer_service_manager.html#handle_call/3"},{"type":"function","title":"partisan_hyparview_peer_service_manager.handle_cast/2","doc":"","ref":"partisan_hyparview_peer_service_manager.html#handle_cast/2"},{"type":"function","title":"partisan_hyparview_peer_service_manager.handle_info/2","doc":"","ref":"partisan_hyparview_peer_service_manager.html#handle_info/2"},{"type":"function","title":"partisan_hyparview_peer_service_manager.init/1","doc":"","ref":"partisan_hyparview_peer_service_manager.html#init/1"},{"type":"function","title":"partisan_hyparview_peer_service_manager.inject_partition/2","doc":"Inject a partition.","ref":"partisan_hyparview_peer_service_manager.html#inject_partition/2"},{"type":"function","title":"partisan_hyparview_peer_service_manager.join/1","doc":"Attempt to join a remote node.","ref":"partisan_hyparview_peer_service_manager.html#join/1"},{"type":"function","title":"partisan_hyparview_peer_service_manager.leave/0","doc":"Leave the cluster.","ref":"partisan_hyparview_peer_service_manager.html#leave/0"},{"type":"function","title":"partisan_hyparview_peer_service_manager.leave/1","doc":"Remove another node from the cluster.","ref":"partisan_hyparview_peer_service_manager.html#leave/1"},{"type":"function","title":"partisan_hyparview_peer_service_manager.members/0","doc":"Returns membership list.","ref":"partisan_hyparview_peer_service_manager.html#members/0"},{"type":"function","title":"partisan_hyparview_peer_service_manager.members_for_orchestration/0","doc":"Return membership list.","ref":"partisan_hyparview_peer_service_manager.html#members_for_orchestration/0"},{"type":"type","title":"partisan_hyparview_peer_service_manager.message_id/0","doc":"","ref":"partisan_hyparview_peer_service_manager.html#t:message_id/0"},{"type":"type","title":"partisan_hyparview_peer_service_manager.message_id_store/0","doc":"","ref":"partisan_hyparview_peer_service_manager.html#t:message_id_store/0"},{"type":"function","title":"partisan_hyparview_peer_service_manager.on_down/2","doc":"Register a trigger to fire when a connection drops.","ref":"partisan_hyparview_peer_service_manager.html#on_down/2"},{"type":"function","title":"partisan_hyparview_peer_service_manager.on_down/3","doc":"Register a trigger to fire when a connection drops.","ref":"partisan_hyparview_peer_service_manager.html#on_down/3"},{"type":"function","title":"partisan_hyparview_peer_service_manager.on_up/2","doc":"Register a trigger to fire when a connection opens.","ref":"partisan_hyparview_peer_service_manager.html#on_up/2"},{"type":"function","title":"partisan_hyparview_peer_service_manager.on_up/3","doc":"Register a trigger to fire when a connection opens.","ref":"partisan_hyparview_peer_service_manager.html#on_up/3"},{"type":"function","title":"partisan_hyparview_peer_service_manager.partitions/0","doc":"Return partitions.","ref":"partisan_hyparview_peer_service_manager.html#partitions/0"},{"type":"type","title":"partisan_hyparview_peer_service_manager.passive/0","doc":"","ref":"partisan_hyparview_peer_service_manager.html#t:passive/0"},{"type":"function","title":"partisan_hyparview_peer_service_manager.passive/0","doc":"Debugging.","ref":"partisan_hyparview_peer_service_manager.html#passive/0"},{"type":"function","title":"partisan_hyparview_peer_service_manager.receive_message/3","doc":"Receive message from a remote manager.","ref":"partisan_hyparview_peer_service_manager.html#receive_message/3"},{"type":"function","title":"partisan_hyparview_peer_service_manager.reserve/1","doc":"Reserve a slot for the particular tag.","ref":"partisan_hyparview_peer_service_manager.html#reserve/1"},{"type":"type","title":"partisan_hyparview_peer_service_manager.reserved/0","doc":"","ref":"partisan_hyparview_peer_service_manager.html#t:reserved/0"},{"type":"function","title":"partisan_hyparview_peer_service_manager.resolve_partition/1","doc":"Resolve a partition.","ref":"partisan_hyparview_peer_service_manager.html#resolve_partition/1"},{"type":"function","title":"partisan_hyparview_peer_service_manager.send_message/2","doc":"Send message to a remote peer service manager.","ref":"partisan_hyparview_peer_service_manager.html#send_message/2"},{"type":"function","title":"partisan_hyparview_peer_service_manager.start_link/0","doc":"Starts the peer service manager.","ref":"partisan_hyparview_peer_service_manager.html#start_link/0"},{"type":"function","title":"partisan_hyparview_peer_service_manager.supports_capability/1","doc":"","ref":"partisan_hyparview_peer_service_manager.html#supports_capability/1"},{"type":"function","title":"partisan_hyparview_peer_service_manager.sync_join/1","doc":"Attempt to join a remote node.","ref":"partisan_hyparview_peer_service_manager.html#sync_join/1"},{"type":"type","title":"partisan_hyparview_peer_service_manager.t/0","doc":"","ref":"partisan_hyparview_peer_service_manager.html#t:t/0"},{"type":"type","title":"partisan_hyparview_peer_service_manager.tag/0","doc":"The epoch indicates how many times the node is restarted.","ref":"partisan_hyparview_peer_service_manager.html#t:tag/0"},{"type":"function","title":"partisan_hyparview_peer_service_manager.terminate/2","doc":"","ref":"partisan_hyparview_peer_service_manager.html#terminate/2"},{"type":"function","title":"partisan_hyparview_peer_service_manager.update_members/1","doc":"Update membership.","ref":"partisan_hyparview_peer_service_manager.html#update_members/1"},{"type":"module","title":"partisan_pluggable_peer_service_manager","doc":"This module realises the  partisan_peer_service_manager  behaviour implementing a peer sampling service with a pluggable overlay topology by delegating the topology definition to a callback module implementing the {partisan_peer_service_strategy} behaviour. Characteristics Uses TCP/IP. All nodes communicate and maintain connections with all other nodes. Nodes periodically send heartbeat messages. The service considers a node \"failed\" when it misses X heartbeats. Point-to-point messaging with a single network hop. Eventually consistent membership maintained in a CRDT and replicated using gossip. Scalability limited to hundres of nodes (60-200 nodes).","ref":"partisan_pluggable_peer_service_manager.html"},{"type":"function","title":"partisan_pluggable_peer_service_manager.add_interposition_fun/2","doc":"","ref":"partisan_pluggable_peer_service_manager.html#add_interposition_fun/2"},{"type":"function","title":"partisan_pluggable_peer_service_manager.add_post_interposition_fun/2","doc":"","ref":"partisan_pluggable_peer_service_manager.html#add_post_interposition_fun/2"},{"type":"function","title":"partisan_pluggable_peer_service_manager.add_pre_interposition_fun/2","doc":"","ref":"partisan_pluggable_peer_service_manager.html#add_pre_interposition_fun/2"},{"type":"function","title":"partisan_pluggable_peer_service_manager.cast_message/2","doc":"","ref":"partisan_pluggable_peer_service_manager.html#cast_message/2"},{"type":"function","title":"partisan_pluggable_peer_service_manager.cast_message/3","doc":"Cast a message to a remote gen_server.","ref":"partisan_pluggable_peer_service_manager.html#cast_message/3"},{"type":"function","title":"partisan_pluggable_peer_service_manager.cast_message/4","doc":"Cast a message to a remote gen_server.","ref":"partisan_pluggable_peer_service_manager.html#cast_message/4"},{"type":"type","title":"partisan_pluggable_peer_service_manager.channel_subs/0","doc":"","ref":"partisan_pluggable_peer_service_manager.html#t:channel_subs/0"},{"type":"function","title":"partisan_pluggable_peer_service_manager.code_change/3","doc":"","ref":"partisan_pluggable_peer_service_manager.html#code_change/3"},{"type":"function","title":"partisan_pluggable_peer_service_manager.decode/1","doc":"Decode state.","ref":"partisan_pluggable_peer_service_manager.html#decode/1"},{"type":"function","title":"partisan_pluggable_peer_service_manager.forward_message/2","doc":"Gensym support for forwarding.","ref":"partisan_pluggable_peer_service_manager.html#forward_message/2"},{"type":"function","title":"partisan_pluggable_peer_service_manager.forward_message/3","doc":"Gensym support for forwarding.","ref":"partisan_pluggable_peer_service_manager.html#forward_message/3"},{"type":"function","title":"partisan_pluggable_peer_service_manager.forward_message/4","doc":"Forward message to registered process on the remote side.","ref":"partisan_pluggable_peer_service_manager.html#forward_message/4"},{"type":"type","title":"partisan_pluggable_peer_service_manager.from/0","doc":"","ref":"partisan_pluggable_peer_service_manager.html#t:from/0"},{"type":"function","title":"partisan_pluggable_peer_service_manager.get_interposition_funs/0","doc":"","ref":"partisan_pluggable_peer_service_manager.html#get_interposition_funs/0"},{"type":"function","title":"partisan_pluggable_peer_service_manager.get_local_state/0","doc":"Return local node's view of cluster membership.","ref":"partisan_pluggable_peer_service_manager.html#get_local_state/0"},{"type":"function","title":"partisan_pluggable_peer_service_manager.get_pre_interposition_funs/0","doc":"","ref":"partisan_pluggable_peer_service_manager.html#get_pre_interposition_funs/0"},{"type":"function","title":"partisan_pluggable_peer_service_manager.handle_call/3","doc":"","ref":"partisan_pluggable_peer_service_manager.html#handle_call/3"},{"type":"function","title":"partisan_pluggable_peer_service_manager.handle_cast/2","doc":"","ref":"partisan_pluggable_peer_service_manager.html#handle_cast/2"},{"type":"function","title":"partisan_pluggable_peer_service_manager.handle_info/2","doc":"","ref":"partisan_pluggable_peer_service_manager.html#handle_info/2"},{"type":"type","title":"partisan_pluggable_peer_service_manager.info/0","doc":"","ref":"partisan_pluggable_peer_service_manager.html#t:info/0"},{"type":"function","title":"partisan_pluggable_peer_service_manager.init/1","doc":"","ref":"partisan_pluggable_peer_service_manager.html#init/1"},{"type":"function","title":"partisan_pluggable_peer_service_manager.inject_partition/2","doc":"Inject a partition.","ref":"partisan_pluggable_peer_service_manager.html#inject_partition/2"},{"type":"type","title":"partisan_pluggable_peer_service_manager.interpos_arg/0","doc":"","ref":"partisan_pluggable_peer_service_manager.html#t:interpos_arg/0"},{"type":"type","title":"partisan_pluggable_peer_service_manager.interpos_fun/0","doc":"","ref":"partisan_pluggable_peer_service_manager.html#t:interpos_fun/0"},{"type":"type","title":"partisan_pluggable_peer_service_manager.interposition_map/1","doc":"","ref":"partisan_pluggable_peer_service_manager.html#t:interposition_map/1"},{"type":"function","title":"partisan_pluggable_peer_service_manager.join/1","doc":"Attempt to join a remote node.","ref":"partisan_pluggable_peer_service_manager.html#join/1"},{"type":"function","title":"partisan_pluggable_peer_service_manager.leave/0","doc":"Leave the cluster.","ref":"partisan_pluggable_peer_service_manager.html#leave/0"},{"type":"function","title":"partisan_pluggable_peer_service_manager.leave/1","doc":"Remove another node from the cluster.","ref":"partisan_pluggable_peer_service_manager.html#leave/1"},{"type":"function","title":"partisan_pluggable_peer_service_manager.maybe_reply_sync_joins/1","doc":"","ref":"partisan_pluggable_peer_service_manager.html#maybe_reply_sync_joins/1"},{"type":"function","title":"partisan_pluggable_peer_service_manager.member/1","doc":"Returns true if node  Node  is a member in the membership list. Otherwise returns  false .","ref":"partisan_pluggable_peer_service_manager.html#member/1"},{"type":"function","title":"partisan_pluggable_peer_service_manager.members/0","doc":"Return membership list.","ref":"partisan_pluggable_peer_service_manager.html#members/0"},{"type":"function","title":"partisan_pluggable_peer_service_manager.members_for_orchestration/0","doc":"Return membership list.","ref":"partisan_pluggable_peer_service_manager.html#members_for_orchestration/0"},{"type":"type","title":"partisan_pluggable_peer_service_manager.node_subs/0","doc":"","ref":"partisan_pluggable_peer_service_manager.html#t:node_subs/0"},{"type":"function","title":"partisan_pluggable_peer_service_manager.on_down/2","doc":"Trigger function on connection close for a given node.  Fun  is a function object taking zero or a single argument, where the argument is the Node name.","ref":"partisan_pluggable_peer_service_manager.html#on_down/2"},{"type":"function","title":"partisan_pluggable_peer_service_manager.on_down/3","doc":"Trigger function on connection close for a given node.  Fun  is a function object taking zero or a single argument, where the argument is the Node name.","ref":"partisan_pluggable_peer_service_manager.html#on_down/3"},{"type":"type","title":"partisan_pluggable_peer_service_manager.on_event_fun/0","doc":"","ref":"partisan_pluggable_peer_service_manager.html#t:on_event_fun/0"},{"type":"function","title":"partisan_pluggable_peer_service_manager.on_up/2","doc":"Trigger function on connection open for a given node.  Fun  is a function object taking zero or a single argument, where the argument is the Node name.","ref":"partisan_pluggable_peer_service_manager.html#on_up/2"},{"type":"function","title":"partisan_pluggable_peer_service_manager.on_up/3","doc":"Trigger function on connection open for a given node.  Fun  is a function object taking zero or a single argument, where the argument is the Node name.","ref":"partisan_pluggable_peer_service_manager.html#on_up/3"},{"type":"function","title":"partisan_pluggable_peer_service_manager.partitions/0","doc":"Return partitions.","ref":"partisan_pluggable_peer_service_manager.html#partitions/0"},{"type":"function","title":"partisan_pluggable_peer_service_manager.receive_message/3","doc":"Receive message from a remote manager.","ref":"partisan_pluggable_peer_service_manager.html#receive_message/3"},{"type":"function","title":"partisan_pluggable_peer_service_manager.remove_interposition_fun/1","doc":"","ref":"partisan_pluggable_peer_service_manager.html#remove_interposition_fun/1"},{"type":"function","title":"partisan_pluggable_peer_service_manager.remove_post_interposition_fun/1","doc":"","ref":"partisan_pluggable_peer_service_manager.html#remove_post_interposition_fun/1"},{"type":"function","title":"partisan_pluggable_peer_service_manager.remove_pre_interposition_fun/1","doc":"","ref":"partisan_pluggable_peer_service_manager.html#remove_pre_interposition_fun/1"},{"type":"function","title":"partisan_pluggable_peer_service_manager.reserve/1","doc":"Reserve a slot for the particular tag.","ref":"partisan_pluggable_peer_service_manager.html#reserve/1"},{"type":"function","title":"partisan_pluggable_peer_service_manager.resolve_partition/1","doc":"Resolve a partition.","ref":"partisan_pluggable_peer_service_manager.html#resolve_partition/1"},{"type":"function","title":"partisan_pluggable_peer_service_manager.send_message/2","doc":"Send message to a remote peer service manager.","ref":"partisan_pluggable_peer_service_manager.html#send_message/2"},{"type":"function","title":"partisan_pluggable_peer_service_manager.start_link/0","doc":"Same as start_link([]).","ref":"partisan_pluggable_peer_service_manager.html#start_link/0"},{"type":"function","title":"partisan_pluggable_peer_service_manager.supports_capability/1","doc":"","ref":"partisan_pluggable_peer_service_manager.html#supports_capability/1"},{"type":"function","title":"partisan_pluggable_peer_service_manager.sync_join/1","doc":"Attempt to join a remote node.","ref":"partisan_pluggable_peer_service_manager.html#sync_join/1"},{"type":"type","title":"partisan_pluggable_peer_service_manager.t/0","doc":"","ref":"partisan_pluggable_peer_service_manager.html#t:t/0"},{"type":"type","title":"partisan_pluggable_peer_service_manager.tag/0","doc":"","ref":"partisan_pluggable_peer_service_manager.html#t:tag/0"},{"type":"function","title":"partisan_pluggable_peer_service_manager.terminate/2","doc":"","ref":"partisan_pluggable_peer_service_manager.html#terminate/2"},{"type":"function","title":"partisan_pluggable_peer_service_manager.update_members/1","doc":"Update membership.","ref":"partisan_pluggable_peer_service_manager.html#update_members/1"},{"type":"type","title":"partisan_pluggable_peer_service_manager.x_interpos_fun/0","doc":"","ref":"partisan_pluggable_peer_service_manager.html#t:x_interpos_fun/0"},{"type":"module","title":"partisan_static_peer_service_manager","doc":"","ref":"partisan_static_peer_service_manager.html"},{"type":"function","title":"partisan_static_peer_service_manager.cast_message/2","doc":"","ref":"partisan_static_peer_service_manager.html#cast_message/2"},{"type":"function","title":"partisan_static_peer_service_manager.cast_message/3","doc":"Cast a message to a remote gen_server.","ref":"partisan_static_peer_service_manager.html#cast_message/3"},{"type":"function","title":"partisan_static_peer_service_manager.cast_message/4","doc":"Cast a message to a remote gen_server.","ref":"partisan_static_peer_service_manager.html#cast_message/4"},{"type":"function","title":"partisan_static_peer_service_manager.decode/1","doc":"Decode state.","ref":"partisan_static_peer_service_manager.html#decode/1"},{"type":"function","title":"partisan_static_peer_service_manager.forward_message/2","doc":"Gensym support for forwarding.","ref":"partisan_static_peer_service_manager.html#forward_message/2"},{"type":"function","title":"partisan_static_peer_service_manager.forward_message/3","doc":"Gensym support for forwarding.","ref":"partisan_static_peer_service_manager.html#forward_message/3"},{"type":"function","title":"partisan_static_peer_service_manager.forward_message/4","doc":"Forward message to registered process on the remote side.","ref":"partisan_static_peer_service_manager.html#forward_message/4"},{"type":"function","title":"partisan_static_peer_service_manager.get_local_state/0","doc":"Return local node's view of cluster membership.","ref":"partisan_static_peer_service_manager.html#get_local_state/0"},{"type":"function","title":"partisan_static_peer_service_manager.handle_info/2","doc":"","ref":"partisan_static_peer_service_manager.html#handle_info/2"},{"type":"function","title":"partisan_static_peer_service_manager.handle_message/3","doc":"","ref":"partisan_static_peer_service_manager.html#handle_message/3"},{"type":"function","title":"partisan_static_peer_service_manager.inject_partition/2","doc":"Inject a partition.","ref":"partisan_static_peer_service_manager.html#inject_partition/2"},{"type":"function","title":"partisan_static_peer_service_manager.join/1","doc":"Attempt to join a remote node.","ref":"partisan_static_peer_service_manager.html#join/1"},{"type":"function","title":"partisan_static_peer_service_manager.leave/0","doc":"Leave the cluster.","ref":"partisan_static_peer_service_manager.html#leave/0"},{"type":"function","title":"partisan_static_peer_service_manager.leave/1","doc":"Remove another node from the cluster.","ref":"partisan_static_peer_service_manager.html#leave/1"},{"type":"function","title":"partisan_static_peer_service_manager.members/0","doc":"Return membership list.","ref":"partisan_static_peer_service_manager.html#members/0"},{"type":"function","title":"partisan_static_peer_service_manager.members_for_orchestration/0","doc":"Return membership list.","ref":"partisan_static_peer_service_manager.html#members_for_orchestration/0"},{"type":"type","title":"partisan_static_peer_service_manager.membership/0","doc":"","ref":"partisan_static_peer_service_manager.html#t:membership/0"},{"type":"function","title":"partisan_static_peer_service_manager.on_down/2","doc":"Trigger function on connection close for a given node.","ref":"partisan_static_peer_service_manager.html#on_down/2"},{"type":"function","title":"partisan_static_peer_service_manager.on_up/2","doc":"Trigger function on connection open for a given node.","ref":"partisan_static_peer_service_manager.html#on_up/2"},{"type":"function","title":"partisan_static_peer_service_manager.partitions/0","doc":"Return partitions.","ref":"partisan_static_peer_service_manager.html#partitions/0"},{"type":"type","title":"partisan_static_peer_service_manager.pending/0","doc":"","ref":"partisan_static_peer_service_manager.html#t:pending/0"},{"type":"function","title":"partisan_static_peer_service_manager.receive_message/3","doc":"Receive message from a remote manager.","ref":"partisan_static_peer_service_manager.html#receive_message/3"},{"type":"function","title":"partisan_static_peer_service_manager.reserve/1","doc":"Reserve a slot for the particular tag.","ref":"partisan_static_peer_service_manager.html#reserve/1"},{"type":"function","title":"partisan_static_peer_service_manager.resolve_partition/1","doc":"Resolve a partition.","ref":"partisan_static_peer_service_manager.html#resolve_partition/1"},{"type":"function","title":"partisan_static_peer_service_manager.send_message/2","doc":"Send message to a remote manager.","ref":"partisan_static_peer_service_manager.html#send_message/2"},{"type":"function","title":"partisan_static_peer_service_manager.start_link/0","doc":"Same as start_link([]).","ref":"partisan_static_peer_service_manager.html#start_link/0"},{"type":"type","title":"partisan_static_peer_service_manager.state_t/0","doc":"","ref":"partisan_static_peer_service_manager.html#t:state_t/0"},{"type":"function","title":"partisan_static_peer_service_manager.supports_capability/1","doc":"","ref":"partisan_static_peer_service_manager.html#supports_capability/1"},{"type":"function","title":"partisan_static_peer_service_manager.sync_join/1","doc":"Attempt to join a remote node.","ref":"partisan_static_peer_service_manager.html#sync_join/1"},{"type":"function","title":"partisan_static_peer_service_manager.update_members/1","doc":"Update membership.","ref":"partisan_static_peer_service_manager.html#update_members/1"},{"type":"module","title":"partisan_full_membership_strategy","doc":"This module implements the full-mesh membership strategy to be used with {link partisan_pluggable_peer_service_manager}.","ref":"partisan_full_membership_strategy.html"},{"type":"function","title":"partisan_full_membership_strategy.compare/2","doc":"Returns the tuple  {Joiners, Leavers}  where  Joiners  is the list of node specifications that are elements of  List  but are not in the membership set, and  Leavers  are the node specifications for the current members that are not elements in  List .","ref":"partisan_full_membership_strategy.html#compare/2"},{"type":"function","title":"partisan_full_membership_strategy.handle_message/2","doc":"Handling incoming protocol message.","ref":"partisan_full_membership_strategy.html#handle_message/2"},{"type":"function","title":"partisan_full_membership_strategy.init/1","doc":"Initialize the strategy state.","ref":"partisan_full_membership_strategy.html#init/1"},{"type":"function","title":"partisan_full_membership_strategy.join/3","doc":"When a node is connected, return the state, membership and outgoing message queue to be transmitted.","ref":"partisan_full_membership_strategy.html#join/3"},{"type":"function","title":"partisan_full_membership_strategy.leave/2","doc":"Leave a node from the cluster.","ref":"partisan_full_membership_strategy.html#leave/2"},{"type":"type","title":"partisan_full_membership_strategy.membership_list/0","doc":"","ref":"partisan_full_membership_strategy.html#t:membership_list/0"},{"type":"type","title":"partisan_full_membership_strategy.outgoing_messages/0","doc":"","ref":"partisan_full_membership_strategy.html#t:outgoing_messages/0"},{"type":"function","title":"partisan_full_membership_strategy.periodic/1","doc":"Periodic protocol maintenance.","ref":"partisan_full_membership_strategy.html#periodic/1"},{"type":"function","title":"partisan_full_membership_strategy.prune/2","doc":"","ref":"partisan_full_membership_strategy.html#prune/2"},{"type":"type","title":"partisan_full_membership_strategy.t/0","doc":"","ref":"partisan_full_membership_strategy.html#t:t/0"},{"type":"module","title":"partisan_membership_set","doc":"This module represents the cluster membership view for this node. When a node joins the cluster it is added to the set. Conversely when a node leaves the cluster it is removed from the set. A node that crashes or gets disconnected will remain in the set so that Partisan can try to re-connect with the node when it restarts or becomes reachable again. Implementation The set is implemented as a CRDT set of  partisan:node_spec()  objects. More specifically a state_orset. Notice that because the set stores  partisan:node_spec()  objects and not  node() , the set can have multiple  partisan:node_spec()  objects for the same node. This can occur when the set contains one or more  stale specifications . Stale Specifications A stale specification exists due to the following reasons: A node crashes (without leaving the cluster) and returns bearing  different IP Addresses  (the value of the node specification's  listen_addrs  property). This is common in cloud orchestration scenarios where instances have dynamic IP addresses. A node crashes (without leaving the cluster) and returns bearing different values for the node specification properties  channels  and/or  parallelism . For example, this can happen in the case the Partisan configuration has changed when using a rolling update strategy i.e. a gradual update process that allows you to update a cluster one node at a time to minimise downtime.","ref":"partisan_membership_set.html"},{"type":"function","title":"partisan_membership_set.add/3","doc":"","ref":"partisan_membership_set.html#add/3"},{"type":"function","title":"partisan_membership_set.compare/2","doc":"Returns the tuple  {Joiners, Leavers}  where  Joiners  is the list of node specifications that are elements of  List  but are not in the membership set, and  Leavers  are the node specifications for the current members that are not elements in  List .","ref":"partisan_membership_set.html#compare/2"},{"type":"function","title":"partisan_membership_set.decode/1","doc":"","ref":"partisan_membership_set.html#decode/1"},{"type":"function","title":"partisan_membership_set.encode/1","doc":"","ref":"partisan_membership_set.html#encode/1"},{"type":"function","title":"partisan_membership_set.equal/2","doc":"","ref":"partisan_membership_set.html#equal/2"},{"type":"function","title":"partisan_membership_set.merge/2","doc":"","ref":"partisan_membership_set.html#merge/2"},{"type":"function","title":"partisan_membership_set.new/0","doc":"","ref":"partisan_membership_set.html#new/0"},{"type":"function","title":"partisan_membership_set.remove/3","doc":"","ref":"partisan_membership_set.html#remove/3"},{"type":"opaque","title":"partisan_membership_set.t/0","doc":"","ref":"partisan_membership_set.html#t:t/0"},{"type":"function","title":"partisan_membership_set.to_list/1","doc":"","ref":"partisan_membership_set.html#to_list/1"},{"type":"function","title":"partisan_membership_set.to_peer_list/1","doc":"Returns a list of node specifications but omitting the specification for the local node. No sorting is applied, so the sorting is undefined.","ref":"partisan_membership_set.html#to_peer_list/1"},{"type":"behaviour","title":"partisan_membership_strategy","doc":"","ref":"partisan_membership_strategy.html"},{"type":"callback","title":"partisan_membership_strategy.compare/2","doc":"","ref":"partisan_membership_strategy.html#c:compare/2"},{"type":"callback","title":"partisan_membership_strategy.handle_message/2","doc":"","ref":"partisan_membership_strategy.html#c:handle_message/2"},{"type":"function","title":"partisan_membership_strategy.handle_message/3","doc":"","ref":"partisan_membership_strategy.html#handle_message/3"},{"type":"callback","title":"partisan_membership_strategy.init/1","doc":"","ref":"partisan_membership_strategy.html#c:init/1"},{"type":"function","title":"partisan_membership_strategy.init/2","doc":"","ref":"partisan_membership_strategy.html#init/2"},{"type":"callback","title":"partisan_membership_strategy.join/3","doc":"","ref":"partisan_membership_strategy.html#c:join/3"},{"type":"function","title":"partisan_membership_strategy.join/4","doc":"","ref":"partisan_membership_strategy.html#join/4"},{"type":"callback","title":"partisan_membership_strategy.leave/2","doc":"","ref":"partisan_membership_strategy.html#c:leave/2"},{"type":"function","title":"partisan_membership_strategy.leave/3","doc":"","ref":"partisan_membership_strategy.html#leave/3"},{"type":"type","title":"partisan_membership_strategy.membership_list/0","doc":"","ref":"partisan_membership_strategy.html#t:membership_list/0"},{"type":"type","title":"partisan_membership_strategy.outgoing_message/0","doc":"","ref":"partisan_membership_strategy.html#t:outgoing_message/0"},{"type":"type","title":"partisan_membership_strategy.outgoing_messages/0","doc":"","ref":"partisan_membership_strategy.html#t:outgoing_messages/0"},{"type":"callback","title":"partisan_membership_strategy.periodic/1","doc":"","ref":"partisan_membership_strategy.html#c:periodic/1"},{"type":"function","title":"partisan_membership_strategy.periodic/2","doc":"","ref":"partisan_membership_strategy.html#periodic/2"},{"type":"callback","title":"partisan_membership_strategy.prune/2","doc":"","ref":"partisan_membership_strategy.html#c:prune/2"},{"type":"function","title":"partisan_membership_strategy.prune/3","doc":"","ref":"partisan_membership_strategy.html#prune/3"},{"type":"module","title":"partisan_scamp_v1_membership_strategy","doc":"","ref":"partisan_scamp_v1_membership_strategy.html"},{"type":"function","title":"partisan_scamp_v1_membership_strategy.compare/2","doc":"Returns the tuple  {Joiners, Leavers}  where  Joiners  is the list of node specifications that are elements of  List  but are not in the membership set, and  Leavers  are the node specifications for the current members that are not elements in  List .","ref":"partisan_scamp_v1_membership_strategy.html#compare/2"},{"type":"function","title":"partisan_scamp_v1_membership_strategy.handle_message/2","doc":"Handling incoming protocol message.","ref":"partisan_scamp_v1_membership_strategy.html#handle_message/2"},{"type":"function","title":"partisan_scamp_v1_membership_strategy.init/1","doc":"Initialize the strategy state. Start with an empty state with only ourselves known.","ref":"partisan_scamp_v1_membership_strategy.html#init/1"},{"type":"function","title":"partisan_scamp_v1_membership_strategy.join/3","doc":"When a remote node is connected, notify that node to add us. Then, perform forwarding, if necessary.","ref":"partisan_scamp_v1_membership_strategy.html#join/3"},{"type":"function","title":"partisan_scamp_v1_membership_strategy.leave/2","doc":"Leave a node from the cluster.","ref":"partisan_scamp_v1_membership_strategy.html#leave/2"},{"type":"function","title":"partisan_scamp_v1_membership_strategy.periodic/1","doc":"Periodic protocol maintenance.","ref":"partisan_scamp_v1_membership_strategy.html#periodic/1"},{"type":"function","title":"partisan_scamp_v1_membership_strategy.prune/2","doc":"","ref":"partisan_scamp_v1_membership_strategy.html#prune/2"},{"type":"function","title":"partisan_scamp_v1_membership_strategy.shuffle/1","doc":"http://stackoverflow.com/questions/8817171/shuffling-elements-in-a-list-randomly-re-arrange-list-elements/8820501#8820501","ref":"partisan_scamp_v1_membership_strategy.html#shuffle/1"},{"type":"type","title":"partisan_scamp_v1_membership_strategy.t/0","doc":"","ref":"partisan_scamp_v1_membership_strategy.html#t:t/0"},{"type":"module","title":"partisan_scamp_v2_membership_strategy","doc":"","ref":"partisan_scamp_v2_membership_strategy.html"},{"type":"function","title":"partisan_scamp_v2_membership_strategy.compare/2","doc":"Returns the tuple  {Joiners, Leavers}  where  Joiners  is the list of node specifications that are elements of  List  but are not in the membership set, and  Leavers  are the node specifications for the current members that are not elements in  List .","ref":"partisan_scamp_v2_membership_strategy.html#compare/2"},{"type":"function","title":"partisan_scamp_v2_membership_strategy.handle_message/2","doc":"Handling incoming protocol message.","ref":"partisan_scamp_v2_membership_strategy.html#handle_message/2"},{"type":"function","title":"partisan_scamp_v2_membership_strategy.init/1","doc":"Initialize the strategy state. Start with an empty state with only ourselves known.","ref":"partisan_scamp_v2_membership_strategy.html#init/1"},{"type":"function","title":"partisan_scamp_v2_membership_strategy.join/3","doc":"When a remote node is connected, notify that node to add us. Then, perform forwarding, if necessary.","ref":"partisan_scamp_v2_membership_strategy.html#join/3"},{"type":"function","title":"partisan_scamp_v2_membership_strategy.leave/2","doc":"Leave a node from the cluster.","ref":"partisan_scamp_v2_membership_strategy.html#leave/2"},{"type":"function","title":"partisan_scamp_v2_membership_strategy.periodic/1","doc":"Periodic protocol maintenance.","ref":"partisan_scamp_v2_membership_strategy.html#periodic/1"},{"type":"function","title":"partisan_scamp_v2_membership_strategy.prune/2","doc":"","ref":"partisan_scamp_v2_membership_strategy.html#prune/2"},{"type":"type","title":"partisan_scamp_v2_membership_strategy.t/0","doc":"","ref":"partisan_scamp_v2_membership_strategy.html#t:t/0"},{"type":"module","title":"partisan_plumtree_backend","doc":"This modules implements a server that realises the  partisan_plumtree_broadcast_handler  behaviour in order to diseminate heartbeat messages. Partisan uses these heartbeat messages to stimulate the Epidemic Broadcast Tree construction. The server will schedule the sending of a  hearbeat` message periodically using the `broadcast_heartbeat_interval` option. Notice that this handler does not perform AAE Exchanges, as we will always have a periodic heartbeat. For that reason, the implementation of the <a docgen-rel=\"seemfa\" docgen-href=\"partisan_plumtree_broadcast_handler#exchange/1\" href=\"partisan_plumtree_broadcast_handler.html#exchange-1\"><code>partisan_plumtree_broadcast_handler:exchange/1</code></a> callback always returns `ignore .","ref":"partisan_plumtree_backend.html"},{"type":"function","title":"partisan_plumtree_backend.broadcast_channel/0","doc":"Returns the channel to be used when broadcasting a message on behalf of this handler.","ref":"partisan_plumtree_backend.html#broadcast_channel/0"},{"type":"function","title":"partisan_plumtree_backend.broadcast_data/1","doc":"Returns from the broadcast message the identifier and the payload. In this case a tuple where both arguments have the broadcast message  timestamp . These messages are used by Partisan as a stimulus for the Epidemic Broadcast Tree (Plumtree) construction.","ref":"partisan_plumtree_backend.html#broadcast_data/1"},{"type":"type","title":"partisan_plumtree_backend.broadcast_id/0","doc":"","ref":"partisan_plumtree_backend.html#t:broadcast_id/0"},{"type":"type","title":"partisan_plumtree_backend.broadcast_message/0","doc":"","ref":"partisan_plumtree_backend.html#t:broadcast_message/0"},{"type":"type","title":"partisan_plumtree_backend.broadcast_payload/0","doc":"","ref":"partisan_plumtree_backend.html#t:broadcast_payload/0"},{"type":"function","title":"partisan_plumtree_backend.code_change/3","doc":"","ref":"partisan_plumtree_backend.html#code_change/3"},{"type":"function","title":"partisan_plumtree_backend.exchange/1","doc":"Returns  ignore`. This is because we don t need to worry about reliable delivery: we always know we'll have another heartbeat message to further repair during the next interval.","ref":"partisan_plumtree_backend.html#exchange/1"},{"type":"function","title":"partisan_plumtree_backend.extract_log_type_and_payload/1","doc":"","ref":"partisan_plumtree_backend.html#extract_log_type_and_payload/1"},{"type":"function","title":"partisan_plumtree_backend.graft/1","doc":"Given a message identifier and a clock, return a given message.","ref":"partisan_plumtree_backend.html#graft/1"},{"type":"function","title":"partisan_plumtree_backend.handle_call/3","doc":"","ref":"partisan_plumtree_backend.html#handle_call/3"},{"type":"function","title":"partisan_plumtree_backend.handle_cast/2","doc":"","ref":"partisan_plumtree_backend.html#handle_cast/2"},{"type":"function","title":"partisan_plumtree_backend.handle_info/2","doc":"","ref":"partisan_plumtree_backend.html#handle_info/2"},{"type":"function","title":"partisan_plumtree_backend.init/1","doc":"","ref":"partisan_plumtree_backend.html#init/1"},{"type":"function","title":"partisan_plumtree_backend.is_stale/1","doc":"Use the clock on the object to determine if this message is stale or not. A message is stale if the received message is causually newer than an existing one. If the message is missing or if the context does not represent an ancestor of message, false is returned. Otherwise, true is returned.","ref":"partisan_plumtree_backend.html#is_stale/1"},{"type":"function","title":"partisan_plumtree_backend.merge/2","doc":"Perform a merge of an incoming object with an object in the local datastore.","ref":"partisan_plumtree_backend.html#merge/2"},{"type":"function","title":"partisan_plumtree_backend.start_link/0","doc":"Same as start_link([]).","ref":"partisan_plumtree_backend.html#start_link/0"},{"type":"function","title":"partisan_plumtree_backend.start_link/1","doc":"Start and link to calling process.","ref":"partisan_plumtree_backend.html#start_link/1"},{"type":"type","title":"partisan_plumtree_backend.state/0","doc":"","ref":"partisan_plumtree_backend.html#t:state/0"},{"type":"function","title":"partisan_plumtree_backend.terminate/2","doc":"","ref":"partisan_plumtree_backend.html#terminate/2"},{"type":"type","title":"partisan_plumtree_backend.timestamp/0","doc":"","ref":"partisan_plumtree_backend.html#t:timestamp/0"},{"type":"function","title":"partisan_plumtree_backend.timestamps/0","doc":"Returns all the timestamps. Notice this can copy a lot of data from the ets table to the calling process. In case  partisan_config:get(broadcast)  returns  false , this function returns an empty list.","ref":"partisan_plumtree_backend.html#timestamps/0"},{"type":"module","title":"partisan_plumtree_broadcast","doc":"This module implements the  Plumtree Protocol  which is the component that materialises Partisan's gossip scheme. The component is implemented as as a  gen_server  that has two functions: Tree construction This component is in charge of selecting which links of the random overlay network will be used to forward the message payload using an eager push strategy. It implements a tree construction mechanisms that is as simple as possible, with minimal overhead in terms of control messages. Tree repair This component is in charge of repairing the tree when failures occur. The process ensures that, despite failures, all nodes remain covered by the spanning tree. Therefore, it should be able to detect and heal partitions of the tree. The overhead imposed by this operation should also be as low as possible. Overview The protocol operates as any pure gossip protocol, in the sense that, in order to broadcast a message, each node gossips with  f  nodes provided by a peer sampling service (where  f  is the protocol fanout). However, each node uses a combination of eager push and lazy push gossip. Eager push  is used just for a subset of the  f  nodes, while  lazy push  is used for the remaining nodes. The links used for eager push are selected in such a way that their closure effectively builds a broadcast tree embedded in the random overlay network. Lazy push links are used to ensure gossip reliability when nodes fail and also to quickly heal the broadcast tree. Furthermore, the set of (random) peers is not changed at each gossip round. Instead, the same peers are used until failures are detected. The protocol uses a Partisan Channel (See {link broadcast_channel}), i.e. based on TCP, to support the message exchange, as they offer extra reliability and an additional source of failure detection. Plumtree depends on an overlay network which is maintained by a peer sampling service ( partisan_peer_service_manager ) and relies on the peer sampling services/s exhibiting a property:  Symmetric (partial) views . If the links that form the spanning tree are symmetric, then the tree may be shared by multiple sources. Symmetric partial views render the task of creating bi-directional trees easier, and reduce the amount of peers that each node has to maintain.","ref":"partisan_plumtree_broadcast.html"},{"type":"function","title":"partisan_plumtree_broadcast.broadcast/2","doc":"Broadcasts a message originating from this node. The message will be delivered to each node at least once. The  Mod  passed must be loaded on all members of the cluster and implement the  partisan_plumtree_broadcast_handler  behaviour which is responsible for handling the message on remote nodes as well as providing some other information both locally and on other nodes. The broadcast will be sent over the channel defined by  broadcast_channel/1 .","ref":"partisan_plumtree_broadcast.html#broadcast/2"},{"type":"function","title":"partisan_plumtree_broadcast.broadcast_channel/1","doc":"Returns the channel to be used when sending broadcasting a message on behalf of module  Mod . The channel defined by the callback  Mod:broadcast_channel()  or default channel i.e.  partisan:default_channel/0  if the callback is not implemented.","ref":"partisan_plumtree_broadcast.html#broadcast_channel/1"},{"type":"function","title":"partisan_plumtree_broadcast.broadcast_members/0","doc":"Returns the broadcast servers view of full cluster membership. Wait indefinitely for a response is returned from the process.","ref":"partisan_plumtree_broadcast.html#broadcast_members/0"},{"type":"function","title":"partisan_plumtree_broadcast.broadcast_members/1","doc":"Returns the broadcast servers view of full cluster membership. Waits  Timeout  ms for a response from the server.","ref":"partisan_plumtree_broadcast.html#broadcast_members/1"},{"type":"function","title":"partisan_plumtree_broadcast.cancel_exchanges/1","doc":"Cancel exchanges started by this node.","ref":"partisan_plumtree_broadcast.html#cancel_exchanges/1"},{"type":"function","title":"partisan_plumtree_broadcast.code_change/3","doc":"","ref":"partisan_plumtree_broadcast.html#code_change/3"},{"type":"function","title":"partisan_plumtree_broadcast.debug_get_peers/2","doc":"return the peers for  Node  for the tree rooted at  Root . Wait indefinitely for a response is returned from the process","ref":"partisan_plumtree_broadcast.html#debug_get_peers/2"},{"type":"function","title":"partisan_plumtree_broadcast.debug_get_peers/3","doc":"return the peers for  Node  for the tree rooted at  Root . Waits  Timeout  ms for a response from the server","ref":"partisan_plumtree_broadcast.html#debug_get_peers/3"},{"type":"function","title":"partisan_plumtree_broadcast.debug_get_peers/4","doc":"return the peers for  Node  for the tree rooted at  Root . Waits  Timeout  ms for a response from the server","ref":"partisan_plumtree_broadcast.html#debug_get_peers/4"},{"type":"function","title":"partisan_plumtree_broadcast.debug_get_tree/2","doc":"return peers for all  Nodes  for tree rooted at  Root  Wait indefinitely for a response is returned from the process","ref":"partisan_plumtree_broadcast.html#debug_get_tree/2"},{"type":"function","title":"partisan_plumtree_broadcast.debug_get_tree/3","doc":"return peers for all  Nodes  for tree rooted at  Root  Wait  Timeout  for a response is returned from the process","ref":"partisan_plumtree_broadcast.html#debug_get_tree/3"},{"type":"function","title":"partisan_plumtree_broadcast.debug_get_tree/4","doc":"return peers for all  Nodes  for tree rooted at  Root  Wait  Timeout  for a response is returned from the process","ref":"partisan_plumtree_broadcast.html#debug_get_tree/4"},{"type":"type","title":"partisan_plumtree_broadcast.exchange/0","doc":"","ref":"partisan_plumtree_broadcast.html#t:exchange/0"},{"type":"type","title":"partisan_plumtree_broadcast.exchanges/0","doc":"","ref":"partisan_plumtree_broadcast.html#t:exchanges/0"},{"type":"function","title":"partisan_plumtree_broadcast.exchanges/0","doc":"return a list of exchanges, started by broadcast on this node, that are running.","ref":"partisan_plumtree_broadcast.html#exchanges/0"},{"type":"function","title":"partisan_plumtree_broadcast.exchanges/1","doc":"Returns a list of running exchanges, started on  Node .","ref":"partisan_plumtree_broadcast.html#exchanges/1"},{"type":"function","title":"partisan_plumtree_broadcast.exchanges/2","doc":"Returns a list of running exchanges, started on  Node .","ref":"partisan_plumtree_broadcast.html#exchanges/2"},{"type":"function","title":"partisan_plumtree_broadcast.get_eager_peers/1","doc":"","ref":"partisan_plumtree_broadcast.html#get_eager_peers/1"},{"type":"function","title":"partisan_plumtree_broadcast.get_lazy_peers/1","doc":"","ref":"partisan_plumtree_broadcast.html#get_lazy_peers/1"},{"type":"function","title":"partisan_plumtree_broadcast.get_peers/1","doc":"","ref":"partisan_plumtree_broadcast.html#get_peers/1"},{"type":"function","title":"partisan_plumtree_broadcast.get_peers/2","doc":"","ref":"partisan_plumtree_broadcast.html#get_peers/2"},{"type":"function","title":"partisan_plumtree_broadcast.handle_call/3","doc":"","ref":"partisan_plumtree_broadcast.html#handle_call/3"},{"type":"function","title":"partisan_plumtree_broadcast.handle_cast/2","doc":"","ref":"partisan_plumtree_broadcast.html#handle_cast/2"},{"type":"function","title":"partisan_plumtree_broadcast.handle_info/2","doc":"","ref":"partisan_plumtree_broadcast.html#handle_info/2"},{"type":"type","title":"partisan_plumtree_broadcast.info_opt/0","doc":"","ref":"partisan_plumtree_broadcast.html#t:info_opt/0"},{"type":"function","title":"partisan_plumtree_broadcast.init/1","doc":"","ref":"partisan_plumtree_broadcast.html#init/1"},{"type":"function","title":"partisan_plumtree_broadcast.maybe_exchange/2","doc":"","ref":"partisan_plumtree_broadcast.html#maybe_exchange/2"},{"type":"type","title":"partisan_plumtree_broadcast.message_id/0","doc":"","ref":"partisan_plumtree_broadcast.html#t:message_id/0"},{"type":"type","title":"partisan_plumtree_broadcast.message_round/0","doc":"Lazy messages that have not been acked. Messages are added to this set when a node is sent a lazy message (or when it should be sent one sometime in the future). Messages are removed when the lazy pushes are acknowledged via graft or ignores. Entries are keyed by their destination These are stored in the ?PLUMTREE_OUTSTANDING ets table under using nodename as key. PLUMTREE_OUTSTANDING is created and owned by partisan_sup","ref":"partisan_plumtree_broadcast.html#t:message_round/0"},{"type":"type","title":"partisan_plumtree_broadcast.nodeset/0","doc":"","ref":"partisan_plumtree_broadcast.html#t:nodeset/0"},{"type":"type","title":"partisan_plumtree_broadcast.opts/0","doc":"","ref":"partisan_plumtree_broadcast.html#t:opts/0"},{"type":"type","title":"partisan_plumtree_broadcast.opts_list/0","doc":"","ref":"partisan_plumtree_broadcast.html#t:opts_list/0"},{"type":"type","title":"partisan_plumtree_broadcast.opts_map/0","doc":"","ref":"partisan_plumtree_broadcast.html#t:opts_map/0"},{"type":"type","title":"partisan_plumtree_broadcast.outstanding/0","doc":"","ref":"partisan_plumtree_broadcast.html#t:outstanding/0"},{"type":"function","title":"partisan_plumtree_broadcast.random_peer/3","doc":"picks random peer favoring peers not in eager or lazy set and ensuring peer is not this node","ref":"partisan_plumtree_broadcast.html#random_peer/3"},{"type":"type","title":"partisan_plumtree_broadcast.selector/0","doc":"","ref":"partisan_plumtree_broadcast.html#t:selector/0"},{"type":"function","title":"partisan_plumtree_broadcast.start_link/0","doc":"Starts the broadcast server on this node. The initial membership list is fetched from the configured {link partisan_peer_service}. If the node is a singleton then the initial eager and lazy sets are empty. If there are two nodes, each will be in the others eager set and the lazy sets will be empty. When number of members is less than 5, each node will initially have one other node in its eager set and lazy set. If there are more than five nodes each node will have at most two other nodes in its eager set and one in its lazy set, initially. In addition, after the broadcast server is started, all callbacks defined in the configuration option  broadcast_mods  are registered. By default the list of callbacks includes the module  partisan_plumtree_backend  which is used by to generate membership updates as the ring changes.","ref":"partisan_plumtree_broadcast.html#start_link/0"},{"type":"function","title":"partisan_plumtree_broadcast.start_link/5","doc":"Starts the broadcast server on this node.  Members  must be a list of all members known to this node when starting the broadcast server.  Eagers  are the initial peers of this node for all broadcast trees.  Lazys  is a list of random peers not in  Eagers  that will be used as the initial lazy peer shared by all trees for this node. If the number of nodes in the cluster is less than 3,  Lazys  should be an empty list.  Eagers  and  Lazys  must also be subsets of  Members .  Mods  is a list of modules that may be handlers for broadcasted messages. All modules in  Mods  should implement the  partisan_plumtree_broadcast_handler  behaviour. Opts  is a proplist or map with the following possible options: lazy_tick_period :: non_neg_integer()  - Flush all outstanding lazy pushes period (in milliseconds) exchange_tick_period :: non_neg_integer()  - Possibly perform an exchange period (in milliseconds) NOTE: When starting the server using start_link/2 no automatic membership update from ring_events is registered. Use  start_link/0 .","ref":"partisan_plumtree_broadcast.html#start_link/5"},{"type":"type","title":"partisan_plumtree_broadcast.state/0","doc":"","ref":"partisan_plumtree_broadcast.html#t:state/0"},{"type":"function","title":"partisan_plumtree_broadcast.terminate/2","doc":"","ref":"partisan_plumtree_broadcast.html#terminate/2"},{"type":"function","title":"partisan_plumtree_broadcast.update/1","doc":"Notifies broadcast server of membership update This is the function is added to partisan_peer_service_events using partisan_peer_service:add_sup_callback(fun ?MODULE:update/1),","ref":"partisan_plumtree_broadcast.html#update/1"},{"type":"behaviour","title":"partisan_plumtree_broadcast_handler","doc":"This module defines a behaviour to customise the implementation for the operations performed by the  partisan_plumtree_broadcast  server. Callbacks The behaviour defines the following callbacks: broadcast_data/1  - must return a two-tuple of message id and payload from a given broadcast. Where the broadcasted message is application-specific. broadcast_channel/1  (optional) - Must return the channel to be used when broadcasting data associate with this handler. See  partisan_plumtree_broadcast:broadcast/2 .","ref":"partisan_plumtree_broadcast_handler.html"},{"type":"callback","title":"partisan_plumtree_broadcast_handler.broadcast_channel/0","doc":"","ref":"partisan_plumtree_broadcast_handler.html#c:broadcast_channel/0"},{"type":"callback","title":"partisan_plumtree_broadcast_handler.broadcast_data/1","doc":"","ref":"partisan_plumtree_broadcast_handler.html#c:broadcast_data/1"},{"type":"callback","title":"partisan_plumtree_broadcast_handler.exchange/1","doc":"","ref":"partisan_plumtree_broadcast_handler.html#c:exchange/1"},{"type":"callback","title":"partisan_plumtree_broadcast_handler.graft/1","doc":"","ref":"partisan_plumtree_broadcast_handler.html#c:graft/1"},{"type":"callback","title":"partisan_plumtree_broadcast_handler.is_stale/1","doc":"","ref":"partisan_plumtree_broadcast_handler.html#c:is_stale/1"},{"type":"callback","title":"partisan_plumtree_broadcast_handler.merge/2","doc":"","ref":"partisan_plumtree_broadcast_handler.html#c:merge/2"},{"type":"module","title":"partisan_plumtree_util","doc":"","ref":"partisan_plumtree_util.html"},{"type":"function","title":"partisan_plumtree_util.build_tree/3","doc":"Convert a list of elements into an N-ary tree. This conversion works by treating the list as an array-based tree where, for example in a binary 2-ary tree, a node at index i has children 2i and 2i+1. The conversion also supports a \"cycles\" mode where the array is logically wrapped around to ensure leaf nodes also have children by giving them backedges to other elements.","ref":"partisan_plumtree_util.html#build_tree/3"},{"type":"function","title":"partisan_plumtree_util.log/2","doc":"","ref":"partisan_plumtree_util.html#log/2"},{"type":"function","title":"partisan_plumtree_util.log/3","doc":"","ref":"partisan_plumtree_util.html#log/3"},{"type":"module","title":"partisan_acknowledgement_backend","doc":"","ref":"partisan_acknowledgement_backend.html"},{"type":"function","title":"partisan_acknowledgement_backend.ack/1","doc":"","ref":"partisan_acknowledgement_backend.html#ack/1"},{"type":"function","title":"partisan_acknowledgement_backend.outstanding/0","doc":"","ref":"partisan_acknowledgement_backend.html#outstanding/0"},{"type":"function","title":"partisan_acknowledgement_backend.start_link/0","doc":"","ref":"partisan_acknowledgement_backend.html#start_link/0"},{"type":"function","title":"partisan_acknowledgement_backend.store/2","doc":"","ref":"partisan_acknowledgement_backend.html#store/2"},{"type":"module","title":"partisan_causality_backend","doc":"","ref":"partisan_causality_backend.html"},{"type":"function","title":"partisan_causality_backend.emit/4","doc":"","ref":"partisan_causality_backend.html#emit/4"},{"type":"function","title":"partisan_causality_backend.handle_call/3","doc":"","ref":"partisan_causality_backend.html#handle_call/3"},{"type":"function","title":"partisan_causality_backend.is_causal_message/1","doc":"Determine is a message is being sent with causal delivery or not.","ref":"partisan_causality_backend.html#is_causal_message/1"},{"type":"function","title":"partisan_causality_backend.receive_message/2","doc":"","ref":"partisan_causality_backend.html#receive_message/2"},{"type":"function","title":"partisan_causality_backend.reemit/2","doc":"","ref":"partisan_causality_backend.html#reemit/2"},{"type":"function","title":"partisan_causality_backend.set_delivery_fun/2","doc":"","ref":"partisan_causality_backend.html#set_delivery_fun/2"},{"type":"function","title":"partisan_causality_backend.start_link/1","doc":"Same as start_link([]).","ref":"partisan_causality_backend.html#start_link/1"},{"type":"module","title":"partisan_acceptor_pool","doc":"","ref":"partisan_acceptor_pool.html"},{"type":"function","title":"partisan_acceptor_pool.accept_socket/2","doc":"","ref":"partisan_acceptor_pool.html#accept_socket/2"},{"type":"function","title":"partisan_acceptor_pool.init/1","doc":"","ref":"partisan_acceptor_pool.html#init/1"},{"type":"function","title":"partisan_acceptor_pool.start_link/0","doc":"","ref":"partisan_acceptor_pool.html#start_link/0"},{"type":"module","title":"partisan_acceptor_socket","doc":"","ref":"partisan_acceptor_socket.html"},{"type":"function","title":"partisan_acceptor_socket.code_change/3","doc":"","ref":"partisan_acceptor_socket.html#code_change/3"},{"type":"function","title":"partisan_acceptor_socket.handle_call/3","doc":"","ref":"partisan_acceptor_socket.html#handle_call/3"},{"type":"function","title":"partisan_acceptor_socket.handle_cast/2","doc":"","ref":"partisan_acceptor_socket.html#handle_cast/2"},{"type":"function","title":"partisan_acceptor_socket.handle_info/2","doc":"","ref":"partisan_acceptor_socket.html#handle_info/2"},{"type":"function","title":"partisan_acceptor_socket.init/1","doc":"","ref":"partisan_acceptor_socket.html#init/1"},{"type":"function","title":"partisan_acceptor_socket.start_link/2","doc":"","ref":"partisan_acceptor_socket.html#start_link/2"},{"type":"function","title":"partisan_acceptor_socket.terminate/2","doc":"","ref":"partisan_acceptor_socket.html#terminate/2"},{"type":"module","title":"partisan_acceptor_socket_pool_sup","doc":"","ref":"partisan_acceptor_socket_pool_sup.html"},{"type":"function","title":"partisan_acceptor_socket_pool_sup.init/1","doc":"","ref":"partisan_acceptor_socket_pool_sup.html#init/1"},{"type":"function","title":"partisan_acceptor_socket_pool_sup.start_link/0","doc":"","ref":"partisan_acceptor_socket_pool_sup.html#start_link/0"},{"type":"module","title":"partisan_peer_connections","doc":"","ref":"partisan_peer_connections.html"},{"type":"function","title":"partisan_peer_connections.channel/1","doc":"Returns the channel name of the connection","ref":"partisan_peer_connections.html#channel/1"},{"type":"type","title":"partisan_peer_connections.connection/0","doc":"","ref":"partisan_peer_connections.html#t:connection/0"},{"type":"type","title":"partisan_peer_connections.connections/0","doc":"","ref":"partisan_peer_connections.html#t:connections/0"},{"type":"function","title":"partisan_peer_connections.connections/0","doc":"Finds connection for a node.","ref":"partisan_peer_connections.html#connections/0"},{"type":"function","title":"partisan_peer_connections.connections/1","doc":"Finds connection for a node.","ref":"partisan_peer_connections.html#connections/1"},{"type":"function","title":"partisan_peer_connections.connections/2","doc":"Finds connection for a node and channel.","ref":"partisan_peer_connections.html#connections/2"},{"type":"function","title":"partisan_peer_connections.connections/3","doc":"Finds connection for a node and channel.","ref":"partisan_peer_connections.html#connections/3"},{"type":"function","title":"partisan_peer_connections.count/0","doc":"","ref":"partisan_peer_connections.html#count/0"},{"type":"function","title":"partisan_peer_connections.count/1","doc":"Returns the number of connections for node  Node . When passed a  partisan:node_spec()  as  Arg  it is equivalent to calling  connection_count/2  with a wildcard as a second argument i.e. '_'. However, when passed a  node()` as `Arg  is uses the more efficient  ets` `lookup_element  operation.","ref":"partisan_peer_connections.html#count/1"},{"type":"function","title":"partisan_peer_connections.count/2","doc":"Returns the nbr of connections for node  Node  and channel  Channel .","ref":"partisan_peer_connections.html#count/2"},{"type":"function","title":"partisan_peer_connections.count/3","doc":"","ref":"partisan_peer_connections.html#count/3"},{"type":"function","title":"partisan_peer_connections.dispatch/1","doc":"","ref":"partisan_peer_connections.html#dispatch/1"},{"type":"function","title":"partisan_peer_connections.dispatch_pid/1","doc":"Return a pid to use for message dispatch.","ref":"partisan_peer_connections.html#dispatch_pid/1"},{"type":"function","title":"partisan_peer_connections.dispatch_pid/2","doc":"Return a pid to use for message dispatch.","ref":"partisan_peer_connections.html#dispatch_pid/2"},{"type":"function","title":"partisan_peer_connections.dispatch_pid/3","doc":"Return a  {ok, Pid}  where  Pid  is the connection pid to use for message dispatch. If channel  Channel  is disconnected it falls back to a default channel connection if one exists. If no connections exist returns  {error, disconnected} .","ref":"partisan_peer_connections.html#dispatch_pid/3"},{"type":"function","title":"partisan_peer_connections.erase/1","doc":"","ref":"partisan_peer_connections.html#erase/1"},{"type":"function","title":"partisan_peer_connections.fold/2","doc":"","ref":"partisan_peer_connections.html#fold/2"},{"type":"function","title":"partisan_peer_connections.foreach/1","doc":"","ref":"partisan_peer_connections.html#foreach/1"},{"type":"function","title":"partisan_peer_connections.foreach/2","doc":"","ref":"partisan_peer_connections.html#foreach/2"},{"type":"type","title":"partisan_peer_connections.info/0","doc":"","ref":"partisan_peer_connections.html#t:info/0"},{"type":"function","title":"partisan_peer_connections.info/1","doc":"Returns a tuple  {ok, Value} , where  Value  is an instance of  info()  associated with  Node , or  error  if no info is associated with  Node .","ref":"partisan_peer_connections.html#info/1"},{"type":"function","title":"partisan_peer_connections.init/0","doc":"Creates a new connections table. The owner of the table is the calling process and the table is protected so only the owner can write to it.","ref":"partisan_peer_connections.html#init/0"},{"type":"function","title":"partisan_peer_connections.is_connected/1","doc":"Returns true is this node is connected to  NodeOrName . If  Node  is this node, returns  true .","ref":"partisan_peer_connections.html#is_connected/1"},{"type":"function","title":"partisan_peer_connections.is_connected/2","doc":"Returns true is this node is connected to  NodeOrName . If  Node  is this node, returns  true .","ref":"partisan_peer_connections.html#is_connected/2"},{"type":"function","title":"partisan_peer_connections.is_fully_connected/1","doc":"Returns true is this node has all the requested connections ( parallelism  configuration parameter) for all the configured channels with node  NodeOrSpec .","ref":"partisan_peer_connections.html#is_fully_connected/1"},{"type":"function","title":"partisan_peer_connections.kill/1","doc":"","ref":"partisan_peer_connections.html#kill/1"},{"type":"function","title":"partisan_peer_connections.kill_all/0","doc":"","ref":"partisan_peer_connections.html#kill_all/0"},{"type":"function","title":"partisan_peer_connections.listen_addr/1","doc":"","ref":"partisan_peer_connections.html#listen_addr/1"},{"type":"type","title":"partisan_peer_connections.listen_addr_spec/0","doc":"","ref":"partisan_peer_connections.html#t:listen_addr_spec/0"},{"type":"type","title":"partisan_peer_connections.maybe_var/1","doc":"","ref":"partisan_peer_connections.html#t:maybe_var/1"},{"type":"function","title":"partisan_peer_connections.node/1","doc":"","ref":"partisan_peer_connections.html#node/1"},{"type":"function","title":"partisan_peer_connections.node_spec/1","doc":"","ref":"partisan_peer_connections.html#node_spec/1"},{"type":"function","title":"partisan_peer_connections.node_specs/0","doc":"Returns a list of all nodes specifications connected to this node.","ref":"partisan_peer_connections.html#node_specs/0"},{"type":"function","title":"partisan_peer_connections.nodes/0","doc":"Returns a list of all nodes connected to this node through normal connections (that is, hidden nodes are not listed).","ref":"partisan_peer_connections.html#nodes/0"},{"type":"type","title":"partisan_peer_connections.optional/1","doc":"","ref":"partisan_peer_connections.html#t:optional/1"},{"type":"function","title":"partisan_peer_connections.pid/1","doc":"","ref":"partisan_peer_connections.html#pid/1"},{"type":"function","title":"partisan_peer_connections.processes/1","doc":"Returns the pids for all the active connection for a node.","ref":"partisan_peer_connections.html#processes/1"},{"type":"function","title":"partisan_peer_connections.processes/2","doc":"Returns the pids for all the active connection for a node and channel.","ref":"partisan_peer_connections.html#processes/2"},{"type":"function","title":"partisan_peer_connections.prune/1","doc":"Prune all occurrences of a connection pid returns the node where the pruned pid was found","ref":"partisan_peer_connections.html#prune/1"},{"type":"function","title":"partisan_peer_connections.store/4","doc":"Store a connection","ref":"partisan_peer_connections.html#store/4"},{"type":"function","title":"partisan_peer_connections.timestamp/1","doc":"","ref":"partisan_peer_connections.html#timestamp/1"},{"type":"type","title":"partisan_peer_connections.var/0","doc":"","ref":"partisan_peer_connections.html#t:var/0"},{"type":"module","title":"partisan_peer_socket","doc":"Wrapper that allows transparent usage of plain TCP or TLS socket for peer connections. This module also implements the monotonic channel functionality.","ref":"partisan_peer_socket.html"},{"type":"function","title":"partisan_peer_socket.accept/1","doc":"Wraps a TCP socket with the appropriate information for transceiving on and controlling the socket later. If TLS/SSL is enabled, this performs the socket upgrade/negotiation before returning the wrapped socket.","ref":"partisan_peer_socket.html#accept/1"},{"type":"function","title":"partisan_peer_socket.close/1","doc":"See also:  gen_tcp:close/1 ,  ssl:close/1 .","ref":"partisan_peer_socket.html#close/1"},{"type":"function","title":"partisan_peer_socket.connect/3","doc":"See also:  gen_tcp:connect/3 ,  ssl:connect/3 .","ref":"partisan_peer_socket.html#connect/3"},{"type":"function","title":"partisan_peer_socket.connect/4","doc":"","ref":"partisan_peer_socket.html#connect/4"},{"type":"function","title":"partisan_peer_socket.connect/5","doc":"","ref":"partisan_peer_socket.html#connect/5"},{"type":"type","title":"partisan_peer_socket.options/0","doc":"","ref":"partisan_peer_socket.html#t:options/0"},{"type":"type","title":"partisan_peer_socket.reason/0","doc":"","ref":"partisan_peer_socket.html#t:reason/0"},{"type":"function","title":"partisan_peer_socket.recv/2","doc":"See also:  gen_tcp:recv/2 ,  ssl:recv/2 .","ref":"partisan_peer_socket.html#recv/2"},{"type":"function","title":"partisan_peer_socket.recv/3","doc":"See also:  gen_tcp:recv/3 ,  ssl:recv/3 .","ref":"partisan_peer_socket.html#recv/3"},{"type":"function","title":"partisan_peer_socket.send/2","doc":"See also:  gen_tcp:send/2 ,  ssl:send/2 .","ref":"partisan_peer_socket.html#send/2"},{"type":"function","title":"partisan_peer_socket.setopts/2","doc":"See also:  inet:setopts/2 ,  ssl:setopts/2 .","ref":"partisan_peer_socket.html#setopts/2"},{"type":"function","title":"partisan_peer_socket.socket/1","doc":"Returns the wrapped socket from within the connection.","ref":"partisan_peer_socket.html#socket/1"},{"type":"type","title":"partisan_peer_socket.t/0","doc":"","ref":"partisan_peer_socket.html#t:t/0"},{"type":"module","title":"partisan_compose_orchestration_strategy","doc":"","ref":"partisan_compose_orchestration_strategy.html"},{"type":"module","title":"partisan_kubernetes_orchestration_strategy","doc":"","ref":"partisan_kubernetes_orchestration_strategy.html"},{"type":"behaviour","title":"partisan_orchestration_backend","doc":"","ref":"partisan_orchestration_backend.html"},{"type":"callback","title":"partisan_orchestration_backend.clients/1","doc":"","ref":"partisan_orchestration_backend.html#c:clients/1"},{"type":"callback","title":"partisan_orchestration_backend.download_artifact/2","doc":"","ref":"partisan_orchestration_backend.html#c:download_artifact/2"},{"type":"function","title":"partisan_orchestration_backend.graph/0","doc":"","ref":"partisan_orchestration_backend.html#graph/0"},{"type":"function","title":"partisan_orchestration_backend.nodes/0","doc":"","ref":"partisan_orchestration_backend.html#nodes/0"},{"type":"function","title":"partisan_orchestration_backend.orchestrated/0","doc":"","ref":"partisan_orchestration_backend.html#orchestrated/0"},{"type":"function","title":"partisan_orchestration_backend.orchestration/0","doc":"","ref":"partisan_orchestration_backend.html#orchestration/0"},{"type":"function","title":"partisan_orchestration_backend.servers/0","doc":"","ref":"partisan_orchestration_backend.html#servers/0"},{"type":"callback","title":"partisan_orchestration_backend.servers/1","doc":"","ref":"partisan_orchestration_backend.html#c:servers/1"},{"type":"function","title":"partisan_orchestration_backend.start_link/0","doc":"Same as start_link([]).","ref":"partisan_orchestration_backend.html#start_link/0"},{"type":"function","title":"partisan_orchestration_backend.start_link/1","doc":"Start and link to calling process.","ref":"partisan_orchestration_backend.html#start_link/1"},{"type":"function","title":"partisan_orchestration_backend.tree/0","doc":"","ref":"partisan_orchestration_backend.html#tree/0"},{"type":"callback","title":"partisan_orchestration_backend.upload_artifact/3","doc":"","ref":"partisan_orchestration_backend.html#c:upload_artifact/3"},{"type":"function","title":"partisan_orchestration_backend.was_connected/0","doc":"","ref":"partisan_orchestration_backend.html#was_connected/0"},{"type":"behaviour","title":"partisan_orchestration_strategy","doc":"","ref":"partisan_orchestration_strategy.html"},{"type":"callback","title":"partisan_orchestration_strategy.clients/1","doc":"","ref":"partisan_orchestration_strategy.html#c:clients/1"},{"type":"callback","title":"partisan_orchestration_strategy.download_artifact/2","doc":"","ref":"partisan_orchestration_strategy.html#c:download_artifact/2"},{"type":"callback","title":"partisan_orchestration_strategy.servers/1","doc":"","ref":"partisan_orchestration_strategy.html#c:servers/1"},{"type":"callback","title":"partisan_orchestration_strategy.upload_artifact/3","doc":"","ref":"partisan_orchestration_strategy.html#c:upload_artifact/3"},{"type":"module","title":"partisan_trace_file","doc":"","ref":"partisan_trace_file.html"},{"type":"function","title":"partisan_trace_file.read/1","doc":"","ref":"partisan_trace_file.html#read/1"},{"type":"function","title":"partisan_trace_file.write/2","doc":"","ref":"partisan_trace_file.html#write/2"},{"type":"module","title":"partisan_trace_orchestrator","doc":"This module requires  disterl .","ref":"partisan_trace_orchestrator.html"},{"type":"function","title":"partisan_trace_orchestrator.debug/2","doc":"","ref":"partisan_trace_orchestrator.html#debug/2"},{"type":"function","title":"partisan_trace_orchestrator.enable/1","doc":"Enable trace.","ref":"partisan_trace_orchestrator.html#enable/1"},{"type":"function","title":"partisan_trace_orchestrator.identify/1","doc":"Identify trace.","ref":"partisan_trace_orchestrator.html#identify/1"},{"type":"function","title":"partisan_trace_orchestrator.is_membership_strategy_message/2","doc":"","ref":"partisan_trace_orchestrator.html#is_membership_strategy_message/2"},{"type":"function","title":"partisan_trace_orchestrator.perform_preloads/1","doc":"Perform preloads.","ref":"partisan_trace_orchestrator.html#perform_preloads/1"},{"type":"function","title":"partisan_trace_orchestrator.print/0","doc":"Print trace.","ref":"partisan_trace_orchestrator.html#print/0"},{"type":"function","title":"partisan_trace_orchestrator.replay/2","doc":"Replay trace.","ref":"partisan_trace_orchestrator.html#replay/2"},{"type":"function","title":"partisan_trace_orchestrator.replay_debug/2","doc":"","ref":"partisan_trace_orchestrator.html#replay_debug/2"},{"type":"function","title":"partisan_trace_orchestrator.reset/0","doc":"Reset trace.","ref":"partisan_trace_orchestrator.html#reset/0"},{"type":"function","title":"partisan_trace_orchestrator.start_link/0","doc":"Same as start_link([]).","ref":"partisan_trace_orchestrator.html#start_link/0"},{"type":"function","title":"partisan_trace_orchestrator.start_link/1","doc":"Start and link to calling process.","ref":"partisan_trace_orchestrator.html#start_link/1"},{"type":"function","title":"partisan_trace_orchestrator.stop/0","doc":"","ref":"partisan_trace_orchestrator.html#stop/0"},{"type":"function","title":"partisan_trace_orchestrator.trace/2","doc":"Record trace message.","ref":"partisan_trace_orchestrator.html#trace/2"},{"type":"module","title":"partisan_app","doc":"","ref":"partisan_app.html"},{"type":"function","title":"partisan_app.start/2","doc":"Starts the application.","ref":"partisan_app.html#start/2"},{"type":"function","title":"partisan_app.stop/1","doc":"Stop the application.","ref":"partisan_app.html#stop/1"},{"type":"module","title":"partisan_sup","doc":"","ref":"partisan_sup.html"},{"type":"function","title":"partisan_sup.init/1","doc":"","ref":"partisan_sup.html#init/1"},{"type":"function","title":"partisan_sup.start_link/0","doc":"","ref":"partisan_sup.html#start_link/0"},{"type":"module","title":"partisan_analysis","doc":"","ref":"partisan_analysis.html"},{"type":"function","title":"partisan_analysis.annotate/1","doc":"","ref":"partisan_analysis.html#annotate/1"},{"type":"type","title":"partisan_analysis.escapes/0","doc":"","ref":"partisan_analysis.html#t:escapes/0"},{"type":"function","title":"partisan_analysis.intraprocedural/1","doc":"","ref":"partisan_analysis.html#intraprocedural/1"},{"type":"function","title":"partisan_analysis.is_escape_op/2","doc":"","ref":"partisan_analysis.html#is_escape_op/2"},{"type":"function","title":"partisan_analysis.is_escape_op/3","doc":"","ref":"partisan_analysis.html#is_escape_op/3"},{"type":"function","title":"partisan_analysis.is_literal_op/2","doc":"","ref":"partisan_analysis.html#is_literal_op/2"},{"type":"function","title":"partisan_analysis.is_literal_op/3","doc":"","ref":"partisan_analysis.html#is_literal_op/3"},{"type":"type","title":"partisan_analysis.label/0","doc":"","ref":"partisan_analysis.html#t:label/0"},{"type":"type","title":"partisan_analysis.labelset/0","doc":"","ref":"partisan_analysis.html#t:labelset/0"},{"type":"type","title":"partisan_analysis.ordset/1","doc":"XXX: TAKE ME OUT","ref":"partisan_analysis.html#t:ordset/1"},{"type":"type","title":"partisan_analysis.outlist/0","doc":"","ref":"partisan_analysis.html#t:outlist/0"},{"type":"function","title":"partisan_analysis.partisan_analysis/1","doc":"","ref":"partisan_analysis.html#partisan_analysis/1"},{"type":"module","title":"partisan_inet","doc":"","ref":"partisan_inet.html"},{"type":"function","title":"partisan_inet.code_change/3","doc":"","ref":"partisan_inet.html#code_change/3"},{"type":"function","title":"partisan_inet.handle_call/3","doc":"","ref":"partisan_inet.html#handle_call/3"},{"type":"function","title":"partisan_inet.handle_cast/2","doc":"","ref":"partisan_inet.html#handle_cast/2"},{"type":"function","title":"partisan_inet.handle_info/2","doc":"","ref":"partisan_inet.html#handle_info/2"},{"type":"function","title":"partisan_inet.init/1","doc":"","ref":"partisan_inet.html#init/1"},{"type":"function","title":"partisan_inet.monitor/1","doc":"","ref":"partisan_inet.html#monitor/1"},{"type":"function","title":"partisan_inet.net_status/0","doc":"Returns  connected  if the host has at least one non-loopback network interface address. Otherwise returns  disconnected .","ref":"partisan_inet.html#net_status/0"},{"type":"function","title":"partisan_inet.net_status/1","doc":"Returns  connected  if the host has at least one non-loopback network interface address. Otherwise returns  disconnected .","ref":"partisan_inet.html#net_status/1"},{"type":"function","title":"partisan_inet.start_link/0","doc":"","ref":"partisan_inet.html#start_link/0"},{"type":"function","title":"partisan_inet.terminate/2","doc":"","ref":"partisan_inet.html#terminate/2"},{"type":"module","title":"partisan_transform","doc":"Parse transformation that replaces all instances of the Erlang bang operator  !  with a call to  partisan:forward_message/2 . Example:  Pid ! hello  will be transformed to  partisan:forward_message(Pid, hello) .","ref":"partisan_transform.html"},{"type":"function","title":"partisan_transform.parse_transform/2","doc":"","ref":"partisan_transform.html#parse_transform/2"},{"type":"module","title":"partisan_transformed_module","doc":"Ringleader parse transformation. First pass of a ringleader parse transformation to write send calls to use ringleader.","ref":"partisan_transformed_module.html"},{"type":"function","title":"partisan_transformed_module.get_pid/0","doc":"","ref":"partisan_transformed_module.html#get_pid/0"},{"type":"function","title":"partisan_transformed_module.local_send/1","doc":"","ref":"partisan_transformed_module.html#local_send/1"},{"type":"function","title":"partisan_transformed_module.send_to_pid/2","doc":"","ref":"partisan_transformed_module.html#send_to_pid/2"},{"type":"module","title":"partisan_util","doc":"","ref":"partisan_util.html"},{"type":"function","title":"partisan_util.apply/4","doc":"","ref":"partisan_util.html#apply/4"},{"type":"function","title":"partisan_util.encode/1","doc":"","ref":"partisan_util.html#encode/1"},{"type":"function","title":"partisan_util.encode/2","doc":"If  pid_encoding  or  ref_encoding  configuration options are enabled, this function will ignore Opts and return an iolist(). Otherwise, the function calls  erlang:term_to_iovec(Term, Opts) .'","ref":"partisan_util.html#encode/2"},{"type":"function","title":"partisan_util.encode_/1","doc":"","ref":"partisan_util.html#encode_/1"},{"type":"function","title":"partisan_util.format_posix_error/1","doc":"Given a POSIX error reason see  inet  and  file , returns a descriptive binary string of the error in English and adding  Reason  at the end of the description inside parenthesis.","ref":"partisan_util.html#format_posix_error/1"},{"type":"function","title":"partisan_util.get/2","doc":"","ref":"partisan_util.html#get/2"},{"type":"function","title":"partisan_util.get/3","doc":"","ref":"partisan_util.html#get/3"},{"type":"function","title":"partisan_util.maps_append/3","doc":"","ref":"partisan_util.html#maps_append/3"},{"type":"function","title":"partisan_util.maybe_connect_disterl/1","doc":"","ref":"partisan_util.html#maybe_connect_disterl/1"},{"type":"function","title":"partisan_util.maybe_pad_term/1","doc":"","ref":"partisan_util.html#maybe_pad_term/1"},{"type":"function","title":"partisan_util.parse_listen_address/1","doc":"","ref":"partisan_util.html#parse_listen_address/1"},{"type":"function","title":"partisan_util.safe_apply/4","doc":"","ref":"partisan_util.html#safe_apply/4"},{"type":"module","title":"partisan_vclock","doc":"A simple Erlang implementation of vector clocks as inspired by Lamport logical clocks. Taken from Riak.","ref":"partisan_vclock.html"},{"type":"function","title":"partisan_vclock.all_nodes/1","doc":"Return the list of all nodes that have ever incremented VClock.","ref":"partisan_vclock.html#all_nodes/1"},{"type":"type","title":"partisan_vclock.binary_vclock/0","doc":"The timestamp is present but not used, in case a client wishes to inspect it.","ref":"partisan_vclock.html#t:binary_vclock/0"},{"type":"type","title":"partisan_vclock.counter/0","doc":"","ref":"partisan_vclock.html#t:counter/0"},{"type":"function","title":"partisan_vclock.descends/2","doc":"Return true if Va is a direct descendant of Vb, else false -- remember, a vclock is its own descendant!","ref":"partisan_vclock.html#descends/2"},{"type":"function","title":"partisan_vclock.dominates/2","doc":"","ref":"partisan_vclock.html#dominates/2"},{"type":"function","title":"partisan_vclock.equal/2","doc":"Compares two VClocks for equality.","ref":"partisan_vclock.html#equal/2"},{"type":"function","title":"partisan_vclock.fresh/0","doc":"Create a brand new vclock.","ref":"partisan_vclock.html#fresh/0"},{"type":"function","title":"partisan_vclock.from_binary/1","doc":"takes the output of  to_binary/1  and returns a vclock","ref":"partisan_vclock.html#from_binary/1"},{"type":"function","title":"partisan_vclock.get_counter/2","doc":"Get the counter value in VClock set from Node.","ref":"partisan_vclock.html#get_counter/2"},{"type":"function","title":"partisan_vclock.glb/2","doc":"take two vclocks and return a vclock that summerizes only the events both have seen.","ref":"partisan_vclock.html#glb/2"},{"type":"function","title":"partisan_vclock.increment/2","doc":"Increment VClock at Node.","ref":"partisan_vclock.html#increment/2"},{"type":"function","title":"partisan_vclock.merge/1","doc":"Combine all VClocks in the input list into their least possible common descendant.","ref":"partisan_vclock.html#merge/1"},{"type":"function","title":"partisan_vclock.subtract_dots/2","doc":"subtract the VClock from the DotList. what this means is that any  {actor(), count()}  pair in DotList that is <= an entry in VClock is removed from DotList Example [{a, 3}, {b, 2}, {d, 14}, {g, 22}] - [{a, 4}, {b, 1}, {c, 1}, {d, 14}, {e, 5}, {f, 2}] = [{{b, 2}, {g, 22}]","ref":"partisan_vclock.html#subtract_dots/2"},{"type":"function","title":"partisan_vclock.to_binary/1","doc":"an efficient format for disk / wire. 5 @see from_binary/1","ref":"partisan_vclock.html#to_binary/1"},{"type":"type","title":"partisan_vclock.vc_entry/0","doc":"","ref":"partisan_vclock.html#t:vc_entry/0"},{"type":"type","title":"partisan_vclock.vclock/0","doc":"","ref":"partisan_vclock.html#t:vclock/0"},{"type":"type","title":"partisan_vclock.vclock_node/0","doc":"","ref":"partisan_vclock.html#t:vclock_node/0"},{"type":"module","title":"partisan_otp_adapter","doc":"TODO validate this module, align vs partisan_gen and if useful add gen_statem API, deprecating fsm API.","ref":"partisan_otp_adapter.html"},{"type":"function","title":"partisan_otp_adapter.call/6","doc":"","ref":"partisan_otp_adapter.html#call/6"},{"type":"function","title":"partisan_otp_adapter.gen_fsm_send_all_state_event/3","doc":"","ref":"partisan_otp_adapter.html#gen_fsm_send_all_state_event/3"},{"type":"function","title":"partisan_otp_adapter.gen_fsm_send_event/3","doc":"Deprecated","ref":"partisan_otp_adapter.html#gen_fsm_send_event/3"},{"type":"function","title":"partisan_otp_adapter.gen_fsm_sync_send_all_state_event/4","doc":"","ref":"partisan_otp_adapter.html#gen_fsm_sync_send_all_state_event/4"},{"type":"function","title":"partisan_otp_adapter.gen_fsm_sync_send_event/4","doc":"","ref":"partisan_otp_adapter.html#gen_fsm_sync_send_event/4"},{"type":"function","title":"partisan_otp_adapter.gen_server_call/4","doc":"","ref":"partisan_otp_adapter.html#gen_server_call/4"},{"type":"function","title":"partisan_otp_adapter.gen_server_cast/3","doc":"","ref":"partisan_otp_adapter.html#gen_server_cast/3"},{"type":"extras","title":"README","doc":"![Version](https://img.shields.io/badge/version-5.0.0--rc.8-blue?style=for-the-badge)  \n![Core Test Suite](https://img.shields.io/github/actions/workflow/status/lasp-lang/partisan/build_and_test.yml?&branch=master&label=core-test-suite&style=for-the-badge)\n![OTP Test Suite](https://img.shields.io/github/actions/workflow/status/lasp-lang/partisan/otp-test.yml?&branch=master&label=otp-test-suite&style=for-the-badge)\n![Alt Test Suite](https://img.shields.io/github/actions/workflow/status/lasp-lang/partisan/alt-test.yml?&branch=master&label=alt-test-suite&style=for-the-badge)\n\n# Partisan\n\nPartisan is a scalable and flexible, TCP-based membership system and distribution layer for the BEAM. It bypasses the use of Distributed Erlang for manual connection management via TCP, and has several pluggable backends for different deployment scenarios.\n\nPartisan is a runtime system that enables greater scalability and reduced latency for distributed actor applications.\n\n* Partisan improves scalability by allowing the application developer to specialize the overlay network to the application’s communication patterns.\n* Partisan achieves lower latency by leveraging several predominately automatic optimizations that result in the efficient scheduling of messages.\n* Bring Your Own Overlay - Partisan exposes an API for users to implement their own overlays; application developers must simply implement the `membership_strategy` interface for handling messages. Partisan automatically uses this membership strategy for processing incoming and outgoing messages to the system – the application developer only needs to handle internal state transitions and supplying the system with an updated list of members. Partisan automatically sets up required connections, serializes and deserializes messages, performs failure detection, and message forwarding. This makes it possible to implement protocols with very little code; our implementation of the full-mesh membership protocol is 152 LOC.\n* Partisan is the first distributed actor system to expose this level of control to the application developer, improving the performance of existing actor application and enabling new types of actor applications.","ref":"readme.html"},{"type":"extras","title":"Getting started - README","doc":"See the documentation for Partisan at [hex.pm](https://hexdocs.pm/partisan/partisan.html).\n\nAlternatively you can build the documentation yourself locally using `make docs`.\nThe resulting documentation will be found in the `docs` directory, just open the `index.html` file with your preferred web browser.","ref":"readme.html#getting-started"},{"type":"extras","title":"Why do we need Partisan? - README","doc":"Erlang/OTP, specifically distributed erlang (a.k.a. `disterl`), uses a full-mesh overlay network. This means that in the worst case scenario all nodes are connected-to and communicate-with all other nodes in the system.\n\n**Failure detector**. These nodes send periodic heartbeat messages to their connected nodes and deem a node \"failed\" or \"unreachable\" when it misses a certain number of heartbeat messages i.e. the `net_tick_time` setting in `disterl`.\n\nDue to this heartbeating and other issues in the way Erlang handles certain internal data structures, Erlang systems present a limit to the number of connected nodes that depending on the application goes between 60 and 200 nodes.\n\nAlso, Erlang conflates control plane messages with application messages on the same TCP/IP connection and uses a single TCP/IP connection between two nodes, making it liable to the [Head-of-line blocking](https://en.wikipedia.org/wiki/Head-of-line_blocking) issue. This also leads to congestion and contention that further affects latency.\n\nThis model might scale well for datacenter deployments, where low latency can be assumed, but not for geo-distributed deployments, where latency is non-uniform and can show wide variance.\n\nPartisan was also designed to handle failures:\n\n* Message omission\n* Message reordering, this can happen in Erlang during reconnections\n* State loss\n* Bit flips\n* Message corruption\n* Faulty failure detectors\n* Etc.","ref":"readme.html#why-do-we-need-partisan"},{"type":"extras","title":"Partisan features - README","doc":"Partisan was designed to increase scalability, reduce latency and improve failure detection for Erlang/BEAM distributed applications.\n\n* Scalability\n    * Provides several overlays that are configurable at runtime\n        * `partisan_pluggable_peer_service_manager`: full mesh with TCP-based failure detection. All nodes maintain active connections to all other nodes in the system using one or more TCP connections.\n        * `partisan_hyparview_peer_service_manager.`: modified implementation of the HyParView protocol, peer-to-peer, designed for high scale, high churn environments. A hybrid partial view membership protocol, with TCP-based failure detection.\n        * `partisan_client_server_peer_service_manager.`: star topology, where clients communicate with servers, and servers communicate with other servers.\n        * `partisan_static_peer_service_manager`: static membership, where connections are explicitly made between nodes\n    * Specialised to particular application communication patterns\n    * Doesn't alter application behaviour\n* Reduce latency\n    * Increasing parallelism - by configuring the number of TCP/IP connections between nodes (named channels).\n    * Pushing background and maintenance traffic to other communication channels - to avoid the Head-of-line blocking due to background activity\n    * Leveraging monotonicity - so that you can do load shedding more possible.\n        * Monotonic channels drop messages when state is increasing on the channel to reduce load and transmission of redundation information. Ideal for growing monotonic hash rings, objects designated with vector clock, CRDTs, etc.\n* Failure detection\n    * Performed using TCP/IP\n    * Connections are verified at each gossip round\n    * Reliable delivery and stronger ordering\n    * Fault-injection\n* Erlang-like API and OTP compliance\n    * Partisan offers re-implementations of `gen_server` and `gen_statem`.\n    * Monitoring: Partisan offers an API similar to the modules `erlang` and `net_kernel` for monitoring nodes and remote processes. Notice this currently only works for `partisan_pluggable_peer_service_manager` backend.\n* Other\n    * On join, gossip is performed immediately, instead of having to wait for the next gossip round.\n    * Single node testing, facilitated by a `disterl` control channel for figuring out which ports the peer service is operating at.","ref":"readme.html#partisan-features"},{"type":"extras","title":"Requirements - README","doc":"* Erlang/OTP 24+","ref":"readme.html#requirements"},{"type":"extras","title":"Who is using Partisan - README","doc":"","ref":"readme.html#who-is-using-partisan"},{"type":"extras","title":"Projects - README","doc":"* [Bondy](https://bondy.io)\n* [Erleans](https://github.com/erleans/erleans)\n* [PlumDB](https://github.com/Leapsight/plum_db)","ref":"readme.html#projects"},{"type":"extras","title":"Organizations and People - README","doc":"* [Christopher Meiklejohn's Blog](https://christophermeiklejohn.com)\n* [Leapsight](https://www.leapsight.com)","ref":"readme.html#organizations-and-people"},{"type":"extras","title":"Reference - README","doc":"","ref":"readme.html#reference"},{"type":"extras","title":"Academic Papers - README","doc":"* [Partisan: Enabling Real-World Protocol Evaluation](https://dl.acm.org/doi/10.1145/3231104.3231106) - ApPLIED '18: Proceedings of the 2018 Workshop on Advanced Tools, Programming Languages, and PLatforms for Implementing and Evaluating Algorithms for Distributed systems, Christopher Meiklejohn\n* [Partisan: Enabling Cloud-Scale Erlang Applications](https://arxiv.org/abs/1802.02652), Christopher Meiklejohn, Heather Miller\n* [Partisan: Scaling the Distributed Actor Runtime](https://www.usenix.org/system/files/atc19-meiklejohn.pdf) - 2019 USENIX Annual Technical Conference,  Christopher S. Meiklejohn and Heather Miller, Carnegie Mellon University; Peter Alvaro, UC Santa Cruz\n* [HyParView: a membership protocol for reliable gossip-based broadcast](https://asc.di.fct.unl.pt/~jleitao/pdf/dsn07-leitao.pdf), Jo&atilde;o Leit&atilde;o, Jos&eacute; Pereira, Lu&iacute;s Rodrigues\n* [X-BOT: A Protocol for Resilient Optimization of Unstructured Overlay Networks](https://www.academia.edu/2901632/X_BOT_A_Protocol_for_Resilient_Optimization_of_Unstructured_Overlay_Networks), Jo&atilde;o Leit&atilde;o, Jo&atilde;o Pedro Marques, Jos&eacute; Pereira, Lu&iacute;s Rodrigues","ref":"readme.html#academic-papers"},{"type":"extras","title":"Presentations - README","doc":"* [Rethinking the Language Runtime for Scale](http://www.erlang-factory.com/euc2016/christopher-meiklejohn) - Erlang User Conference 2016, Christopher S. Meiklejohn\n* [Partisan: Scaling the Distributed Actor Runtime](https://www.usenix.org/conference/atc19/presentation/meiklejohn) - 2019 USENIX Annual Technical Conference, Christopher S. Meiklejohn\n* [Partisan: testable, high performance, large scale distributed Erlang](https://codesync.global/media/partisan-testable-high-performance-large-scale-distributed-erlang/) - Code BEAM SF 2019, Christopher S. Meiklejohn\n* [Distributed Erlang: From Datacenter Applications to Planetary Scale Applications](https://www.youtube.com/watch?v=01vedKGBQkQ), Christopher Meiklejohn.","ref":"readme.html#presentations"},{"type":"extras","title":"Partisan Cheatsheet","doc":"# Partisan Cheatsheet","ref":"cheatsheet.html"},{"type":"extras","title":"Configuring Partisan - Partisan Cheatsheet","doc":"Partisan is configured using the normal `sys.conf` file and/or calling the functions in the `partisan_config` module.\n\n#### Example sys.config file\n```erlang\n[\n    {partisan, [\n        %% Which overlay to use\n        {peer_service_manager, partisan_pluggable_peer_service_manager},\n        %% The listening port for Partisan TCP/IP connections\n        {peer_port, 10200},\n        %% The list of channels\n        {channels, [{data, #{parallelism => 1}]},\n        %% Encoding for pid(), reference() and names\n        {pid_encoding, false},\n        {ref_encoding, false},\n        {remote_ref_format, improper_list}\n    ]},\n    %% ...Other apps...\n].\n```\n\nNotice that in order to work, all nodes in the cluster need to use the same configuration (apart from parameters like `peer_port` which can vary between nodes when deployed on the same host).","ref":"cheatsheet.html#configuring-partisan"},{"type":"extras","title":"Connecting to other peers and sending messages - Partisan Cheatsheet","doc":"The following sections assumes you have two nodes running: **ruby** (`ruby@127.0.0.1`) and **max** (`max@127.0.0.1`).","ref":"cheatsheet.html#connecting-to-other-peers-and-sending-messages"},{"type":"extras","title":"Manually joining using Erlang's console - Partisan Cheatsheet","doc":"#### 1. Obtain max's node specification\n\n```erlang\n(max@127.0.0.1)1> NodeSpec = partisan:node_spec().\n```\n\n#### 2. Join ruby with max\n\n```erlang\n(ruby@127.0.0.1)1> NodeSpec = ...\n(ruby@127.0.0.1)2> partisan_peer_service:join(NodeSpec).\n```\n`NodeSpec` is the value obtained at `max` in the previous step.\n{: .wrap}","ref":"cheatsheet.html#manually-joining-using-erlang-s-console"},{"type":"extras","title":"Checking cluster membership view - Partisan Cheatsheet","doc":"```erlang\n(max@127.0.0.1)1> partisan:nodes().\n```\n\nReturns `[node()]` and should contain both nodes.","ref":"cheatsheet.html#checking-cluster-membership-view"},{"type":"extras","title":"Obtain max's shell pid - Partisan Cheatsheet","doc":"```erlang\n(max@127.0.0.1)2> partisan:self().\n['max@127.0.0.1'|<<\"#Pid<0.813.0>\">>]\n```\n\nReturns `partisan_remote_ref:t()`. Notice this can be a tuple and improper list or a URI binary depending on the configuration option `remote_ref_format` which defaults to `improper_list`.","ref":"cheatsheet.html#obtain-max-s-shell-pid"},{"type":"extras","title":"Send message from ruby to max - Partisan Cheatsheet","doc":"```erlang\n(ruby@127.0.0.1)3> Ref = ['max@127.0.0.1'|<<\"#Pid<0.813.0>\">>].\n(ruby@127.0.0.1)4> partisan:forward_message(Ref, hello).\n```\n{: .wrap}","ref":"cheatsheet.html#send-message-from-ruby-to-max"},{"type":"extras","title":"Check the message arrived at max - Partisan Cheatsheet","doc":"```erlang\n(max@127.0.0.1)3> flush().\nShell got hello\nok\n```","ref":"cheatsheet.html#check-the-message-arrived-at-max"},{"type":"extras","title":"Leave the cluster - Partisan Cheatsheet","doc":"```erlang\n(max@127.0.0.1)4> partisan_peer_service:leave().\nok\n```","ref":"cheatsheet.html#leave-the-cluster"},{"type":"extras","title":"Migrating from Distributed Erlang - Partisan Cheatsheet","doc":"In addition to using Partisan-specific functions to manage a cluster and send messages, adopting Partisan implies the need to replace some Erlang BIFs with Partisan's counterparts. This is mainly to cope with the impossibility for Partisan to represent remote pids and references in the way Distributed Erlang does. For that reason, pids and references are encoded manually (or automatically is the configuration options `pid_encoding` and `ref_encoding ` are enabled) using the `partisan_remote_ref:from_term/1` function.\n\nSeveral Erlang BIFs (a.k.a \"native implementation\") won't work when using Partisan so you will need to use the Partisan API instead. The Partisan API tries to be a drop-in replacement to Erlang's as much as possible. It tries comply with Erlang's in terms of naming, function signature and behaviour, so in most cases migrating to Partisan is as easy as replacing the module name from `erlang` to `partisan`.\n\nThe same applies for OTP behaviours when making remote calls e.g. `gen_server:call/1` will not work when the first argument is a remote name. If you need your OTP behaviours to comminicate over the network you will need to: (i) implement the partisan counterpart fork i.e. `m:partisan_gen_server`; or (ii) use `partisan_rpc:call/2` instead of `gen_server:call/2`.\n\nNotice also that calling `sys` functions e.g. `sys:get_state/1` passing a `partisan_gen_server` pid will not work. You will also have to use the partisan\ncounterpart `partisan_sys:get_state/1`.\n\nThe following table shows a mapping of Erlang to Partisan APIs.\n\n|Erlang|Partisan|Description|\n|---|---|---|\n|`erlang:cancel_timer/1`|`partisan:cancel_timer/1`| |\n|`erlang:cancel_timer/2`|`partisan:cancel_timer/2`| |\n|`erlang:demonitor/1`|`partisan:demonitor/1`| |\n|`erlang:demonitor/2`|`partisan:demonitor/2`| |\n|`erlang:disconnect_node/1`|`partisan:disconnect_node/1`| |\n|`erlang:exit/2`|`partisan:exit/2`| |\n|`erlang:is_alive/0`|`partisan:is_alive/0`| |\n|`erlang:is_pid/1`|`partisan:is_pid/1`| |\n|`erlang:is_process_alive/1`|`partisan:is_process_alive/1`| |\n|`erlang:is_reference/1`|`partisan:is_reference/1`| |\n|`erlang:make_ref/0`|`partisan:make_ref/0`| |\n|`erlang:monitor/1`|`partisan:monitor/1`| |\n|`erlang:monitor/2`|`partisan:monitor/2`| |\n|`erlang:monitor/3`|`partisan:monitor/3`| |\n|`erlang:node/0`|`partisan:node/0`| |\n|`erlang:node/1`|`partisan:node/1`| |\n|`erlang:process_info/1`|`partisan:process_info/1`| |\n|`erlang:process_info/2`|`partisan:process_info/2`| |\n|`erlang:self/0`|`partisan:self/0`| |\n|`erlang:send/2`|`partisan:send/2`| |\n|`erlang:send/3`|`partisan:send/3`| |\n|`erlang:send_after/3`|`partisan:send_after/3`|Accepts a `partisan_remote_ref:t()` as destination. When destination is a local pid, it reverts to the native implementation.|\n|`erlang:send_after/4`|`partisan:send_after/4`|Accepts a `partisan_remote_ref:t()` as destination. When destination is a local pid, it reverts to the native implementation.|\n|`erlang:spawn/2`|`partisan:spawn/2`| |\n|`erlang:spawn/4`|`partisan:spawn/4`| |\n|`erlang:spawn_monitor/2`|`partisan:spawn_monitor/2`| |\n|`erlang:spawn_monitor/4`|`partisan:spawn_monitor/4`| |\n|`erlang:whereis/1`|`partisan:whereis/1`| |\n|`net_kernel:monitor_node/2`|`partisan:monitor_node/2`| |\n|`net_kernel:monitor_nodes/1`|`partisan:monitor_nodes/1`| |\n|`net_kernel:monitor_nodes/2`|`partisan:monitor_nodes/2`| |","ref":"cheatsheet.html#migrating-from-distributed-erlang"},{"type":"extras","title":"Telemetry Events","doc":"# Telemetry Events\n\nPartisan uses the `telemetry` library for instrumentation.\n\nA Telemetry event is made up of the following:\n\n* `name` - A list of atoms that uniquely identifies the event.\n\n* `measurements` - A map of atom keys (e.g. duration) and numeric values.\n\n* `metadata` - A map of key-value pairs that can be used for tagging metrics.","ref":"telemetry.html"},{"type":"extras","title":"Membership Events - Telemetry Events","doc":"### [partisan, membership, peer, join]\nThis event is triggered when a node joins the cluster.\n\n##### Measurements\n```erlang\n#{\n    count => 1\n}\n```\n\n##### Metadata\n```erlang\n#{\n    name => 'node@192.168.0.20',\n    listen_addrs => [\n        #{ip => {127,0,0,1}, port => 10200}\n    ]\n}\n```\n\n### [partisan, membership, peer, leave]\nThis event is triggered when a node leaves the cluster.\n\n##### Measurements\n```erlang\n#{\n    count => 1\n}\n```\n\n##### Metadata\n```erlang\n#{\n    name => 'node@192.168.0.20',\n    listen_addrs => [\n        #{ip => {127,0,0,1}, port => 10200}\n    ]\n}\n```\n\n### [partisan, membership, peer, up]\nThis event is triggered when a node successfully establishes all necessary channel connections with a peer. In other words, the node has established the number of connections for each channel based on the `parallelism` setting for the corresponding channel.\n\n##### Measurements\n```erlang\n#{\n    count => 1\n}\n```\n\n##### Metadata\n```erlang\n#{\n    name => 'node@192.168.0.20',\n    listen_addrs => [\n        #{ip => {127,0,0,1}, port => 10200}\n    ]\n}\n```\n\n### [partisan, membership, peer, down]\nThis event occurs when a peer disconnects, and there are no established channel connections with that peer.\n\n##### Measurements\n```erlang\n#{\n    count => 1\n}\n```\n\n##### Metadata\n\n```erlang\n#{\n    name => 'node@192.168.0.20',\n    listen_addrs => [\n        #{ip => {127,0,0,1}, port => 10200}\n    ]\n}\n```\n\n\n### [partisan, membership, peer, channel, up]\nEmitted every time a channel reaches the desired number of connections i.e. `parallelism`.\n\n##### Measurements\n```erlang\n#{\n    count => 1,\n    sockets => 3\n}\n```\n\n##### Metadata\n```erlang\n#{\n\n}\n```\n\n### [partisan, membership, peer, channel, down]\nEmitted every time a channel reaches the desired number of connections i.e. `parallelism`.\n\n##### Measurements\n```erlang\n#{\n\n}\n```\n\n##### Metadata\n```erlang\n#{\n\n}\n```","ref":"telemetry.html#membership-events"},{"type":"extras","title":"Channel Events - Telemetry Events","doc":"### [partisan, channel, configured]\n\nEmitted once for every channel every time the `channels` configuration parameter is modified. It provides a measurement of the count of channels. The metadata includes the channel name and options i.e. `partisan:channel_opts()`.\n\n##### Measurements\n```erlang\n#{\n    count => 1\n}\n```\n\n##### Metadata\n```erlang\n#{\n    name => user_data,\n    config => #{\n        monotonic => false,\n        compression => false,\n        parallelism => 4\n    }\n}\n```","ref":"telemetry.html#channel-events"},{"type":"extras","title":"Socket Events - Telemetry Events","doc":"### [partisan, socket, open]\nEmitted once for every socket that is open and waiting for connection with another socket. It provides a measurement of the count of connect `open` events.\n\n##### Measurements\n```erlang\n#{\n\n}\n```\n\n##### Metadata\n```erlang\n#{\n\n}\n```\n\n### [partisan, socket, connect]\n\n##### Measurements\n```erlang\n#{\n\n}\n```\n\n##### Metadata\n```erlang\n#{\n\n}\n```\n### [partisan, socket, recv]\n\n##### Measurements\n```erlang\n#{\n\n}\n```\n\n##### Metadata\n```erlang\n#{\n\n}\n```\n### [partisan, socket, send]\n\n##### Measurements\n```erlang\n#{\n\n}\n```\n\n##### Metadata\n```erlang\n#{\n\n}\n```\n\n### [partisan, socket, close]\n\n##### Measurements\n```erlang\n#{\n\n}\n```\n\n##### Metadata\n```erlang\n#{\n\n}\n```\n\n\n\n\n* `[partisan, channel, configured]` -\n* `[partisan, socket, open]` -\n* `[partisan, socket, connect]` -\n* `[partisan, socket, recv]` -\n* `[partisan, socket, send]` -\n* `[partisan, socket, close]` -\n* `[partisan, socket, tag_msg]` -\n* `[partisan, connection, connections]` -\n* `[partisan, connection, monitors]` -\n* `[partisan, connection, new]` -\n* `[partisan, connection, outstanding]` -\n* `[partisan, connection, owners]` -\n* `[partisan, queue, unacknowledged, count]` -\n* `[partisan, queue, unacknowledged, bytes]` -\n* `[partisan, queue, retransmitted, count]` -\n* `[partisan, queue, retransmitted, bytes]` -\n* `[partisan, queue, undelivered, count]` -\n* `[partisan, queue, undelivered, bytes]` -\n* `[partisan, queue, delivered, count]` -\n* `[partisan, queue, delivered, bytes]` -\nplumbtree_broadcast oustanding, neweagers, lazy_sets, all_members (ordset)","ref":"telemetry.html#socket-events"},{"type":"extras","title":"LICENSE","doc":"Copyright (c) 2021-2022, Leapsight Technologies Limited\nCopyright (c) 2016, Christopher Meiklejohn\nCopyright (c) 2015, Basho Technologies, Inc\nCopyright (c) 2015, Helium Systems, Inc\nAll rights reserved.\n\n\n                                 Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS","ref":"license.html"},{"type":"extras","title":"CHANGELOG","doc":"# CHANGELOG\n# v5.0.0","ref":"changelog.html"},{"type":"extras","title":"Changes - CHANGELOG","doc":"* Drop `rc` tag and graduate to v5.0.0!\n* Added `connection_ping` configuration option to prevent staleness during TCP half-open connections and other netorking issues. The same configuration works both for the client and server sides of the connection.\n\n# v5.0.0-rc.17","ref":"changelog.html#changes"},{"type":"extras","title":"Changes - CHANGELOG","doc":"* Drop support for OTP24\n* Added missing export `to_reference/1` in `partisan_remote_ref`","ref":"changelog.html#changes-1"},{"type":"extras","title":"Fixes - CHANGELOG","doc":"* Fixes plumtree calling the local node\n* Update to `partisan_interval_set` util module\n\n# v5.0.0-rc.16","ref":"changelog.html#fixes"},{"type":"extras","title":"Fixes - CHANGELOG","doc":"* Fixes a bug introduced in previous commit in the return of the `graft` callback.\n\n# v5.0.0-rc.15","ref":"changelog.html#fixes-1"},{"type":"extras","title":"Fixes - CHANGELOG","doc":"* Allow `ok` as result for `partisan_plumtree_broadcast:exchange/1` callback.\n\n# v5.0.0-rc.14","ref":"changelog.html#fixes-2"},{"type":"extras","title":"Changes - CHANGELOG","doc":"* Add `ok` as valid return for `exchange` callback in `partisan_plumtree_broadcast_handler`.\n# v5.0.0-rc.14","ref":"changelog.html#changes-2"},{"type":"extras","title":"Fixes - CHANGELOG","doc":"* Fixes the case where `partisan_plumbtree_broadcast` behaviour implementors' callbacks throw an exception which would crash the broadcast server.\n* Replace use of RPC in `partisan_plumbtree_broadcast` and use \n  `partisan_gen_server:call/3` instead\n* Other minor fixes\n\n\n# v5.0.0-rc.13","ref":"changelog.html#fixes-3"},{"type":"extras","title":"Fixes - CHANGELOG","doc":"* set `distance_enabled` options to `false` by default.\n\n\n# v5.0.0-rc.12","ref":"changelog.html#fixes-4"},{"type":"extras","title":"Fixes - CHANGELOG","doc":"* Fix a bug causing fast forward to be disabled in full-mesh topologies\n* Merged [PR #254](https://github.com/lasp-lang/partisan/pull/254) - Thanks Massimo Cesaro!\n\n# v5.0.0-rc.11","ref":"changelog.html#fixes-5"},{"type":"extras","title":"Fixes - CHANGELOG","doc":"* Fix a bug when dealing with deprecated configs\n\n# v5.0.0-rc.10","ref":"changelog.html#fixes-6"},{"type":"extras","title":"Changes - CHANGELOG","doc":"* `partisan_peer_discovery_dns` configuration changes. Added support for IPV6 via `aaaa` record_type and additional `options`.\n```\n{partisan, [\n    {peer_discovery, [\n         {type, partisan_peer_discovery_dns},\n         {config, #{\n             record_type => aaaa,\n             query => \"foo.local\",\n             node_basename => \"foo\",\n             options => #{\n                nameservers => [\"fdaa::3\"]\n             }\n         }}\n    ]}\n]}\n```\n\n# v5.0.0-rc.9","ref":"changelog.html#changes-3"},{"type":"extras","title":"Changes - CHANGELOG","doc":"* `partisan_peer_discovery_dns` configuration changes. The configuration parameters `name` was renamed to `query` and `nodename` was renamed to `node_basename`. `name` and `nodename` are still valid inputs but they are transformed during init.\n```\n{partisan, [\n    {peer_discovery, [\n         {type, partisan_peer_discovery_dns},\n         {config, #{\n             record_type => fqdns,\n             query => \"foo.local\",\n             node_basename => \"foo\"\n         }}\n    ]}\n]}\n```\n* New implementation of plumtree heartbeats in `partisan_plumtree_backend` to bound the timestamps stored by each peer. This is done using the new module `partisan_invertal_sets`.\nThe module also offers new performance improvements by avoiding calling the server when possible (using ets directly instead).\n\n# v5.0.0-rc.8","ref":"changelog.html#changes-4"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* Fixes #250 `peer_host` not working. The `peer_host` was an experimental option that was never rally implemented and thus has been deprecated and the original feature has been now implemented using the `listen_addrs` feature and the new host resolution algorithm","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Changes - CHANGELOG","doc":"* `listen_addrs` is now the preferred way to configure the IP/Ports where Partisan will listen for connections. The new implementation allows for multiple different formats and coerces them to the `partisan:listen_addr()` type i.e. `#{ip => inet:ip_address(), port => 1..65535}`. The following example shows the different formats accepted by the option.\n```erlang\n    {listen_addrs, [\n        \"127.0.0.1:12345\",\n        <<\"127.0.0.1:12345\">>,\n        {\"127.0.0.1\", \"12345\"},\n        {{127, 0, 0, 1}, 12345},\n        #{ip => \"127.0.0.1\", port => \"12345\"},\n        #{ip => <<\"127.0.0.1\">>, port => <<\"12345\">>},\n        #{ip => {127, 0, 0, 1}, port => 12345}\n    ]},\n```\n* A new algorithm has been implemented to determine the listen address when `listen_addr` is not defined in the configuration. The algorithm uses `peer_ip` the Erlang nodename or `name` configuration option to extract the host from the name e.g. `HOST` in `mynode@HOST` and uses `inet:getaddr` to determine the IP Address.\n\n# v5.0.0-rc.7","ref":"changelog.html#changes-5"},{"type":"extras","title":"Changes - CHANGELOG","doc":"* Performance improvements for `partisan:forward/2,3,4`.\n\n# v5.0.0-rc.2","ref":"changelog.html#changes-6"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* Fixes a bug in `partisan:spawn/2`\n\n# v5.0.0-rc.1","ref":"changelog.html#bug-fixes-1"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* Make sure a message forward to a local process never fails (restoring the original behaviour).\n* Minor bug fixes\n* Fixed type issues detected by Eqwalizer and Dialyzer","ref":"changelog.html#bug-fixes-2"},{"type":"extras","title":"Changes - CHANGELOG","doc":"* Readme Docs improvements\n\n# v5.0.0-beta.24\n* Removed eqwalizer from default profile\n\n# v5.0.0-beta.23","ref":"changelog.html#changes-7"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* Coerce `forward_options` configuration option to map format.\n* Fix bug in merge of forward options on `partisan_pluggable_peer_service` module\n* Test suite fixes\n* Export missing `partisan:monitor_node/3` function.\n* Fix a bug in `partisan_hyparview_peer_service_message` when Options are passed as list.","ref":"changelog.html#bug-fixes-3"},{"type":"extras","title":"Changes - CHANGELOG","doc":"* Remove unused module `partisan_promise_backend`\n\n# v5.0.0-beta.22","ref":"changelog.html#changes-8"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* Continued adding support for OTP.\n    * The OTP modules `sys`, `proc_lib` where patched (`partisan_sys`, `partisan_proc_lib`) so that they support the `partisan_remote_ref:t()` type and use the `partisan` module functions for finding, monitoring and sending messages instead of the native Erlang counterparts.\n    * OTP patched files are located in the priv directory and loaded dynamically by `rebar.config.script` based on the Erlang/OTP version being used.\n    * Patched the CT suites (`gen_server_SUITE`, `gen_statem_SUITE`, `gen_event_SUITE`) to test the partisan OTP modules. All tests passing except for some test cases that require not-yet implemented features like global and some `rpc` functions.\n    * Notice `global` is not yet supported by Partisan.\n* Added support for Eqwalizer, and passed both Eqwalizer and Dialyzer checks","ref":"changelog.html#bug-fixes-4"},{"type":"extras","title":"Additions - CHANGELOG","doc":"* New improper list format for `partisan_remote_ref`. This deprecates the config option `remote_ref_as_uri` and adds `remote_ref_format` instead which accepts `improper_list` (the new default), `tuple` (the legacy format) and `uri` (also introduced in v5).\n* Adds `partisan_erpc`. The patched version of the Erlang's `erpc` module.\n\n\n# v5.0.0-beta.19","ref":"changelog.html#additions"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* Fix implementation of `partisan_pluggable_peer_service_manager:sync_join/1`.\n\n\n\n# v5.0.0-beta.18","ref":"changelog.html#bug-fixes-5"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* Remove optimisation from `partisan:self/0` and add `partisan:self/1` which accepts the `cache` option making the use of th optimization to be explicit. Check the docs for the explanation.\n* Fixed bug in `partisan:monitor/2` introduced in previous version.\n\n\n# v5.0.0-beta.17","ref":"changelog.html#bug-fixes-6"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* Fix bugs in `partisan_gen_statem` and `partisan_gen`\n\n# v5.0.0-beta.16","ref":"changelog.html#bug-fixes-7"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* Fix a bug in `partisan:send/2,3`","ref":"changelog.html#bug-fixes-8"},{"type":"extras","title":"Changes - CHANGELOG","doc":"* Ensure the membership channel (`partisan_membership`) exits and is properly configured.\n\n# v5.0.0-beta.15","ref":"changelog.html#changes-9"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* General bug fixes including:\n    * #121 updated_members should only accept a list of maps (an never a list of nodes)\n    * fix wrong calls to `self()` and `node()` as opposed to their partisan counterparts\n* Fixed bugs in `partisan_monitor`\n* Several bug fixes in the OTP implementation\n* Several bug fixes in the CT suite","ref":"changelog.html#bug-fixes-9"},{"type":"extras","title":"Changes - CHANGELOG","doc":"* Changed signature of partisan_membership_strategy and the implementing modules; added API e.g.  `join(state(), partisan:node_spec(), state())`  is now ` join(partisan:node_spec(), state(), state())` which is more natural.\n* Added partisan_membership_strategy API functions, so that pluggable manager can call these functions\n* Some other naming changes to disambiguate e.g. membership -> members\n* moved some opt types from partisan_monitor to partisan module\n* Fixed missing of gen_ and partisan_gen function calls.\n* Made `channel` options to be respected across the stack\n    * Added channel configuration to `partisan_monitor` calls.\n    * Added channel to OTP behaviours.\n        * The messages and the monitor signals will be sent using the configured channel.\n        * overloaded gen_server/statem functions to accept options including channel so that we do not add another function to the API\n        * store the Partisan opts in the process dict (again to avoid modifying our changed versions of the behaviours)\n        *\n* Configuration parameters renaming. Several configuration parameters were renamed. Check `partisan_config` module description. The old parameters are still accepted but are renamed during startup.\n* Deprecated the `partisan_peer_service_manager:myself` callback\n* Fix `partisan_util` term encoding and renamed function; added compression option for encoding and for memberhip payload","ref":"changelog.html#changes-10"},{"type":"extras","title":"Additions - CHANGELOG","doc":"* Added the following modules:\n    * `partisan_supervisor` behaviour\n* Added the following functions:\n    * `partisan:exit/2`\n    * `partisan:send/2`\n    * `partisan:send/3`\n    * `partisan:send_after/3`\n    * `partisan:send_after/4`\n    * `partisan:cancel_timer/1`\n    * `partisan:cancel_timer/2`\n * Peer Service manager now allows subscribing to events per channel\n    * `partisan_peer_service_manager:on_up/3` accepting a channel\n    * `partisan_peer_service_manager:on_down/3` accepting a channel\n\n\n# v5.0.0-beta.14","ref":"changelog.html#additions-1"},{"type":"extras","title":"API - CHANGELOG","doc":"#### Changes\n\n* Several functions previously found in `partisan_util` are now in `partisan_peer_service_manager`.\n- Types previously found in `partisan.hrl` are now defined and exported by the `partisan` module.","ref":"changelog.html#api"},{"type":"extras","title":"Peer Membership - CHANGELOG","doc":"#### Fixes\n\n* Several bug fixes in the following backends:\n    * `partisan_hyparview_peer_service_manager`\n    * `partisan_xbot_hyparview_peer_service_manager`\n    * `partisan_client_server_peer_service_manager`\n* Fixes a bug in `partisan_plumbtree_broadcast` where not all the handlers were used.\n    * The configuration option `broadcast_start_exchange_limit` is now considered to refer to each handler i.e. a limit of `1` means Partisan will only allow one instance of a broadcast AAE exchange per handler (and not a single one in total).","ref":"changelog.html#peer-membership"},{"type":"extras","title":"Peer Connection Management - CHANGELOG","doc":"#### Changes\n\n* **Channel parallelism** can now be defined **per channel**\n    * `channels` configuration option is overloaded to allow the new configuration options while keeping backwards compatibility. Check the documentation for the new formats in [partisan_config](partisan_config.html).\n    * The `partisan:node_spec()` representation was changed:\n        * `parallelism` was removed\n        * `channels` was changed from a list of atoms or tuples to a the return of `partisan_config:get(channels)` i.e. a map.\n    * `parallelism` is now used as a default when the user doesn’t define a per channel parallelism.\n    * The `partisan` module now exports the new function  `channel_opts/1` with returns the options for a given channel.\n\n# v5.0.0-beta.13","ref":"changelog.html#peer-connection-management"},{"type":"extras","title":"API - CHANGELOG","doc":"In general, the API was redesigned to concentrate all functions around two modules: `partisan` and `partisan_peer_service`.\n\n#### Changes\n\n* `partisan` module was repurposed as a replacement for the `erlang` module for use cases related to distribution e.g. `erlang:nodes/0` -> `partisan:nodes/0`.\n    * Several functions previously found in `partisan_peer_service`, `partisan_monitor` and `partisan_util` are now in this module:\n        * `partisan:broadcast/2`\n        * `partisan:cast_message/2`\n        * `partisan:cast_message/3`\n        * `partisan:cast_message/4`\n        * `partisan:default_channel/0`\n        * `partisan:demonitor/1`\n        * `partisan:demonitor/2`\n        * `partisan:disconnect_node/1`.\n        * `partisan:forward_message/2`\n        * `partisan:forward_message/3`\n        * `partisan:forward_message/4`\n        * `partisan:is_alive/0`\n        * `partisan:is_connected/1`\n        * `partisan:is_connected/2`\n        * `partisan:is_fully_connected/1`\n        * `partisan:is_local/1`\n        * `partisan:is_pid/1`\n        * `partisan:is_process_alive/1`\n        * `partisan:is_reference/1`\n        * `partisan:make_ref/0`\n        * `partisan:monitor/1`\n        * `partisan:monitor/2`\n        * `partisan:monitor/3`\n        * `partisan:monitor_node/2`\n        * `partisan:monitor_nodes/1`\n        * `partisan:monitor_nodes/2`\n        * `partisan:node/0`\n        * `partisan:node/1`\n        * `partisan:node_spec/0`\n        * `partisan:node_spec/1`\n        * `partisan:node_spec/2`\n        * `partisan:nodes/0`\n        * `partisan:nodes/1`\n        * `partisan:nodestring/0`\n        * `partisan:self/0`\n* Added the following functions:\n    * `partisan_peer_service:broadcast_members/0`\n    * `partisan_peer_service:broadcast_members/1`\n    * `partisan_peer_service:cancel_exchanges/1`\n    * `partisan_peer_service:exchanges/0`\n    * `partisan_peer_service:exchanges/1`\n    * `partisan_peer_service:get_local_state/0`\n    * `partisan_peer_service:inject_partition/2`\n    * `partisan_peer_service:leave/1`\n    * `partisan_peer_service:member/1`\n    * `partisan_peer_service:members_for_orchestration/0`\n    * `partisan_peer_service:on_down/2`\n    * `partisan_peer_service:on_up/2`\n    * `partisan_peer_service:partitions/0`\n    * `partisan_peer_service:reserve/1`\n    * `partisan_peer_service:resolve_partition/1`\n    * `partisan_peer_service:update_members/1`\n* Use of `partisan_peer_service:mynode/0` has been replaced by `partisan:node/0` to follow Erlang convention\n* Use of `partisan_peer_service:myself/0` has been replaced by `partisan:node_spec/0` to disambiguate from `partisan:node/0`.\n* Use of `Node` variable name for `node()` type (as opposed to `Name`) and `NodeSpec` for `node_spec()` (as opposed to `Node`) to disambiguate.\n* Adde new module `partisan_rpc` that will provide and API that mirrors Erlangs `rpc` and `erpc` modules\n* Added `partisan_remote_ref` to encapsulate the creation of reference and added an optional/alternative representation for encoded pids, references and registered names. The module offers all the functions to convert pids, references and names to/from Partisan encoded references.\n    * Alternative representation: In cases where lots of references are stored in process state, ets and specially where those are uses as keys, a binary format is preferable to the tuple format in order to save memory usage and avoid copying the term every time a message is send between processes. `partisan_remote_ref` represents an encoded reference as binary URI. This is controlled by the config option `remote_ref_as_uri` and `remote_ref_binary_padding` in case the resulting URIs are smaller than 65 bytes.\n\n        ```erlang\n        1> partisan_remote_ref:from_term(self()).\n        {partisan_remote_reference,nonode@nohost,{partisan_process_reference,\"<0.1062.0>\"}}\n        2> partisan_config:set(remote_ref_as_uri, true).\n        ok\n        3> partisan_remote_ref:from_term(self()).\n        <<\"partisan:pid:nonode@nohost:0.1062.0\">>\n        4> partisan_config:set(remote_ref_binary_padding, true).\n        ok\n        5> partisan_remote_ref:from_term(self()).\n        <<\"partisan:pid:nonode@nohost:0.1062.0:\"...>>\n        ```","ref":"changelog.html#api-1"},{"type":"extras","title":"Peer Membership - CHANGELOG","doc":"#### Fixes\n* Extracted the use of `state_orset` from `partisan_full_membership_strategy` into its own module `partisan_membership_set` which will allow the possibility to explore alternative data structures to manage the membership set.\n* Introduced a membership prune operation to remove duplicate node specifications in the underlying `state_orset` data structure. This isto avoid an issue where a node will crash and restart with a different IP address e.g. when deploying in cloud orchestration platforms. As the membership set contains `node_spec()` objects which contain IP addresses we ended up with duplicate entries for the node.  The prune operation tries to break ties between these duplicates at time of connection, trying to recognise when a node specification might be no longer valid forcing the removal of the spec from the set.\n* Fixes several bugs related to the `leave` operation in `partisan_pluggable_peer_service_manager`:\n    * Added a missing call to update the membership set during leave\n    * Fixed a concurrency issue whereby on self leave the peer service server will restart before being able to sending the new state with the cluster peers and thus the node would remain as a member in all other nodes.\n* Resolves an issue `partisan_plumtree_broadcast` where the `all_members` set was not updated when a member is removed.\n* Resolves the issue where the `partisan_plumtree_broadcast` was not removing the local node from the broadcast member set.\n* Gen Behaviours take new option `channel` if defined.\n* Fixed implementation of `on_up` and `on_down` callback functions in `partisan_pluggable_peer_service_manager`\n\n\n#### Changes\n* Added function `partisan_peer_service_manager:member/1`\n* Replaced the use of in-process sets in `plumtree_broadcast_backend` with an `ets` table for outstanding messages keeping the gen_server stack lean and avoiding garbage collection","ref":"changelog.html#peer-membership-1"},{"type":"extras","title":"Peer Connection management - CHANGELOG","doc":"#### Fixes\n\n* Fixes a bug where connections where not properly killed during a leave\n* Split TLS options for client and server roles\n    * Removed `tls_options`\n    * Added `tls_client_options` and `tls_server_options`\n\n#### Changes\n\n* New module `peer_service_connections`:\n    * Replaces the former `peer_service_connections` process state data structure and the `partisan_connection_cache` module.\n    * As a result, the `partisan_connection_cache` module has been was removed.\n    * Checking connection status is now very fast and cheap. The implementation uses `ets`  to handle concurreny. It leverages leverages `ets:update_counter/4`, `ets:lookup_element/3` and `ets:select_count/2` for fast access and to minimise copying data into the caller's process heap.","ref":"changelog.html#peer-connection-management-1"},{"type":"extras","title":"Process and Peer Monitoring - CHANGELOG","doc":"#### Fixes\n* A more complete/safe implementation of process monitoring in `partisan_monitor`.\n* More robust implementation of monitors using the new subscription capabilities provided by `peer_service:on_up` and `peer_service:on_down` callback functions.\n    - monitor a node or all nodes\n    - use node monitors to signal a process monitor when the remote node is disconnected\n    - local cache of process monitor to ensure the delivery of DOWN signal when the connection to the process node is down.\n    - avoid leaking monitors\n    - new supervisor to ensure that `partisan_monitor` is restarted every time the configured `partisan_peer_service_manager` is restarted.\n    - re-implementation based on ets tables\n    - If using OTP25 the monitor gen_server uses the parallel signal optimisation by placing the process inbox data off heap\n\n> #### NOTICE {: .warning}\n>\n> At the moment this only works for `partisan_pluggable_peer_service_manager` backend.\n\n#### Changes\n\n* New api in `partisan` module following the same name, signature and semantics of their `erlang` and `net_kernel` modules counterparts:\n    * `partisan:monitor/1`\n    * `partisan:monitor/2`\n    * `partisan:monitor/3`\n    * `partisan:monitor_node/2`\n    * `partisan:monitor_nodes/1`\n    * `partisan:monitor_nodes/2`","ref":"changelog.html#process-and-peer-monitoring"},{"type":"extras","title":"OTP compatibility - CHANGELOG","doc":"#### Fixes\n\n#### Changes\n\n* Partisan now requires **OTP24 or later**.\n* Upgraded `partisan_gen` and `partisan_gen_server` to match their OTP24 counterparts implementation\n* Added `partisan_gen_statem`\n* `partisan_gen_fsm` deprecated as it was not complete and focus was given to the implementation of `partisan_gen_statem` instead\n* Module `partisan_mochiglobal` has been removed and replaced by `persistent_term`","ref":"changelog.html#otp-compatibility"},{"type":"extras","title":"Misc - CHANGELOG","doc":"#### Fixes\n\n* Most existing `INFO` level logs have been reclassified as `DEBUG`\n* Fixed types specifications in various modules\n\n#### Changes\n\n* `lager` dependency has been removed and all logging is done using the new Erlang `logger`\n* Most uses of the `orddict` module have been replaced by maps for extra performance and better usability\n* Most API options using `proplists` module have been replaced by maps for extra performance and better usability\n* In several functions the computation of options (merging user provided with defaults, validation, etc.) has been postponed until (and only if) it is needed for extra performance e.g. `partisan_pluggable_peer_servie_manager:forward_message`\n* More utils in `partisan_util`\n* Added `ex_doc` (Elixir documentation) rebar plugin\n* Upgraded the following dependencies:\n    * `uuid`\n    * `types`\n    * rebar plugins","ref":"changelog.html#misc"},{"type":"extras","title":"Contributor Covenant Code of Conduct","doc":"# Contributor Covenant Code of Conduct","ref":"code_of_conduct.html"},{"type":"extras","title":"Our Pledge - Contributor Covenant Code of Conduct","doc":"In the interest of fostering an open and welcoming environment, we as contributors and maintainers pledge to making participation in our project and our community a harassment-free experience for everyone, regardless of age, body size, disability, ethnicity, gender identity and expression, level of experience, nationality, personal appearance, race, religion, or sexual identity and orientation.","ref":"code_of_conduct.html#our-pledge"},{"type":"extras","title":"Our Standards - Contributor Covenant Code of Conduct","doc":"Examples of behavior that contributes to creating a positive environment include:\n\n* Using welcoming and inclusive language\n* Being respectful of differing viewpoints and experiences\n* Gracefully accepting constructive criticism\n* Focusing on what is best for the community\n* Showing empathy towards other community members\n\nExamples of unacceptable behavior by participants include:\n\n* The use of sexualized language or imagery and unwelcome sexual attention or advances\n* Trolling, insulting/derogatory comments, and personal or political attacks\n* Public or private harassment\n* Publishing others' private information, such as a physical or electronic address, without explicit permission\n* Other conduct which could reasonably be considered inappropriate in a professional setting","ref":"code_of_conduct.html#our-standards"},{"type":"extras","title":"Our Responsibilities - Contributor Covenant Code of Conduct","doc":"Project maintainers are responsible for clarifying the standards of acceptable behavior and are expected to take appropriate and fair corrective action in response to any instances of unacceptable behavior.\n\nProject maintainers have the right and responsibility to remove, edit, or reject comments, commits, code, wiki edits, issues, and other contributions that are not aligned to this Code of Conduct, or to ban temporarily or permanently any contributor for other behaviors that they deem inappropriate, threatening, offensive, or harmful.","ref":"code_of_conduct.html#our-responsibilities"},{"type":"extras","title":"Scope - Contributor Covenant Code of Conduct","doc":"This Code of Conduct applies both within project spaces and in public spaces when an individual is representing the project or its community. Examples of representing a project or community include using an official project e-mail address, posting via an official social media account, or acting as an appointed representative at an online or offline event. Representation of a project may be further defined and clarified by project maintainers.","ref":"code_of_conduct.html#scope"},{"type":"extras","title":"Enforcement - Contributor Covenant Code of Conduct","doc":"Instances of abusive, harassing, or otherwise unacceptable behavior may be reported by contacting the project team at christopher.meiklejohn@gmail.com. The project team will review and investigate all complaints, and will respond in a way that it deems appropriate to the circumstances. The project team is obligated to maintain confidentiality with regard to the reporter of an incident. Further details of specific enforcement policies may be posted separately.\n\nProject maintainers who do not follow or enforce the Code of Conduct in good faith may face temporary or permanent repercussions as determined by other members of the project's leadership.","ref":"code_of_conduct.html#enforcement"},{"type":"extras","title":"Attribution - Contributor Covenant Code of Conduct","doc":"This Code of Conduct is adapted from the [Contributor Covenant][homepage], version 1.4, available at [http://contributor-covenant.org/version/1/4][version]\n\n[homepage]: http://contributor-covenant.org\n[version]: http://contributor-covenant.org/version/1/4/","ref":"code_of_conduct.html#attribution"}],"proglang":"erlang","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.1"}}